------------------------------------------------------------------------
r7382 | divverent | 2007-05-30 10:52:15 +0200 (Wed, 30 May 2007) | 2 lines

OS X: make unknown char/keycode just a DPrint, reportedly some mouse drivers work fine apart from that they also send weird key codes

------------------------------------------------------------------------
r7381 | divverent | 2007-05-29 01:40:25 +0200 (Tue, 29 May 2007) | 2 lines

ignore r_glsl_contrastboost in range 0..1 (it breaks overbright pixels in that range), that is, the cvar now only does anything when > 1 (brighten up image) or < 0 (threshold effect)

------------------------------------------------------------------------
r7380 | divverent | 2007-05-28 23:46:15 +0200 (Mon, 28 May 2007) | 2 lines

contrast boost: change 1 to myhvec3(1, 1, 1) to make ATI driver happy (doesn't change fps on nvidia)

------------------------------------------------------------------------
r7379 | divverent | 2007-05-28 23:01:55 +0200 (Mon, 28 May 2007) | 2 lines

make degrading shaders actually WORK

------------------------------------------------------------------------
r7378 | divverent | 2007-05-28 15:35:07 +0200 (Mon, 28 May 2007) | 6 lines

glsl doesn't allow dividing by zero (result is undefined, although sane on nvidia), so...
-"      color.rgb = SceneBrightness / (ContrastBoostCoeff + 1 / color.rgb);\n"
+"      color.rgb = color.rgb * SceneBrightness / (ContrastBoostCoeff * color.rgb + 1);\n"
also gains some fps apparently (7600GT here)
Weirdly, *= seems to be by 3fps slower than using = and *

------------------------------------------------------------------------
r7377 | divverent | 2007-05-28 14:29:48 +0200 (Mon, 28 May 2007) | 2 lines

new cvar r_glsl_contrastboost to do something similar to gamma in the GLSL shader... costs some fps when enabled, but works everywhere, and doesn't grey out as much as gamma (see http://hector.rbi.informatik.uni-frankfurt.de/nex/img/r_ambient4r_hdr_scenebrightness2r_glsl_contrastboost2.jpg vs http://hector.rbi.informatik.uni-frankfurt.de/nex/img/v_gamma2.jpg)

------------------------------------------------------------------------
r7376 | divverent | 2007-05-27 11:22:07 +0200 (Sun, 27 May 2007) | 2 lines

that was missing in 7372 (TAB should also hide the centerprinting of finale)

------------------------------------------------------------------------
r7375 | havoc | 2007-05-27 08:46:44 +0200 (Sun, 27 May 2007) | 5 lines

added polygonoffset as a texture property, used on submodels (such as
doors in q1bsp maps) to prevent zfighting if they exactly overlap a
wall, consistent with software quake (which intentionally removed the
portions of the door overlapping a wall)

------------------------------------------------------------------------
r7374 | havoc | 2007-05-27 08:42:10 +0200 (Sun, 27 May 2007) | 3 lines

default sv_gameplayfix_blowupfallenzombies to 0 in -hipnotic mode as it
messes up the friendly monsters

------------------------------------------------------------------------
r7373 | havoc | 2007-05-27 07:57:48 +0200 (Sun, 27 May 2007) | 3 lines

fixed recently introduced bug that made lightmapintensity affect dlights
and rtlights

------------------------------------------------------------------------
r7372 | havoc | 2007-05-27 00:15:27 +0200 (Sun, 27 May 2007) | 5 lines

make showscores work while finale is up in all game modes
(this should not have been implemented as a nexuiz specific feature)
made monsters and secrets display check the STAT_TOTAL values to decide
whether to draw, rather than a nexuiz check

------------------------------------------------------------------------
r7371 | divverent | 2007-05-26 13:42:33 +0200 (Sat, 26 May 2007) | 2 lines

change noise4f to a function that does not crash

------------------------------------------------------------------------
r7370 | divverent | 2007-05-26 12:19:37 +0200 (Sat, 26 May 2007) | 4 lines

intermission: store the current time to completed_time only on the first svc_intermission-like command (Nexuiz switches to svc_intermission for final scoreboard display and to svc_finale for the voting screen);
intermission: in GAME_NEXUIZ, display standard scoreboard instead of intermission overlay, and allow showscores (TAB) to override svc_finale overlay
scoreboard: in intermission, show the time when the game ended, not the current time

------------------------------------------------------------------------
r7369 | havoc | 2007-05-25 22:32:05 +0200 (Fri, 25 May 2007) | 3 lines

reorganized rgbgen/alphagen/tcgen fields into their own structs to clean
up the code somewhat

------------------------------------------------------------------------
r7368 | havoc | 2007-05-25 10:03:48 +0200 (Fri, 25 May 2007) | 3 lines

implemented deformvertexes (previously autosprite/autosprite2 had been
supported as a special case, but now all deformvertexes modes work)

------------------------------------------------------------------------
r7367 | havoc | 2007-05-25 09:57:11 +0200 (Fri, 25 May 2007) | 2 lines

added a 4D noise function for use by shaders

------------------------------------------------------------------------
r7366 | divverent | 2007-05-25 08:40:21 +0200 (Fri, 25 May 2007) | 2 lines

ask for generated normals when usign Q3TCGEN_ENVIRONMENT

------------------------------------------------------------------------
r7365 | havoc | 2007-05-24 22:12:21 +0200 (Thu, 24 May 2007) | 2 lines

added parsing of rgbgen wave and alphagen wave

------------------------------------------------------------------------
r7364 | havoc | 2007-05-24 09:35:30 +0200 (Thu, 24 May 2007) | 2 lines

support multiple tcmod commands on a single layer

------------------------------------------------------------------------
r7363 | havoc | 2007-05-24 08:43:28 +0200 (Thu, 24 May 2007) | 2 lines

implemented tcgen

------------------------------------------------------------------------
r7362 | havoc | 2007-05-24 07:55:41 +0200 (Thu, 24 May 2007) | 2 lines

implemented tcmod (all forms)

------------------------------------------------------------------------
r7361 | havoc | 2007-05-24 05:37:44 +0200 (Thu, 24 May 2007) | 2 lines

added loading of rgbgen/alphagen/tcgen/tcmod

------------------------------------------------------------------------
r7360 | havoc | 2007-05-24 03:49:26 +0200 (Thu, 24 May 2007) | 2 lines

remove unused rsurface.modelneighbor3i

------------------------------------------------------------------------
r7359 | havoc | 2007-05-24 03:36:13 +0200 (Thu, 24 May 2007) | 6 lines

eliminated rsurface.model, so there is now no dependence on having an
actual model in the material renderer
(except transparent surface queuing still needing an entity)
this cleanup means that the material renderer could be called from other
places without an entity (effects such as particles and lightning beams)

------------------------------------------------------------------------
r7358 | havoc | 2007-05-24 00:41:52 +0200 (Thu, 24 May 2007) | 2 lines

moved rsurface_ variables into rsurface struct as a minor cleanup

------------------------------------------------------------------------
r7356 | havoc | 2007-05-24 00:36:08 +0200 (Thu, 24 May 2007) | 6 lines

added DP_QC_CVAR_DEFSTRING extension
corrected function descriptions of DP_QC_STRING_CASE_FUNCTIONS extension
to indicate that they are in that extension, previously they broke the
formatting convention by saying what they were for instead of the
extension they belong to

------------------------------------------------------------------------
r7355 | havoc | 2007-05-24 00:24:53 +0200 (Thu, 24 May 2007) | 2 lines

forgot to commit this change

------------------------------------------------------------------------
r7354 | havoc | 2007-05-24 00:07:18 +0200 (Thu, 24 May 2007) | 5 lines

changed DP_SV_MODELFLAGS_AS_EFFECTS extension, now using any of the MF_
flags will override the model's flags
added EF_NOMODELFLAGS effect to disable model flags without replacing
them with anything new

------------------------------------------------------------------------
r7352 | havoc | 2007-05-23 22:51:31 +0200 (Wed, 23 May 2007) | 3 lines

removed rsurface_entity field, and copied all fields that were accessed
through it into rsurface_* fields

------------------------------------------------------------------------
r7350 | havoc | 2007-05-23 19:15:21 +0200 (Wed, 23 May 2007) | 3 lines

remove stupid int casts of pitch/yaw in beam code, yet another instance
of this legacy from quake that I hadn't killed yet

------------------------------------------------------------------------
r7349 | havoc | 2007-05-23 19:05:10 +0200 (Wed, 23 May 2007) | 7 lines

changed server to not send pingplreport in response to "ping" command,
because it confuses non-DP clients and older DP clients (resulting in
the message "unknown command pingplreport" flooding the console)
changed client to send "pings" command to DP7 protocol servers so that
it gets only the pingplreport output, avoiding any potential misparsing
of ping reports and reducing bandwidth a little.

------------------------------------------------------------------------
r7348 | havoc | 2007-05-23 19:03:07 +0200 (Wed, 23 May 2007) | 2 lines

hide ping reports in demos

------------------------------------------------------------------------
r7347 | divverent | 2007-05-23 18:26:59 +0200 (Wed, 23 May 2007) | 2 lines

replace funky !!a ^ !!b XOR usage by a new boolxor(a, b) macro that does that internally - should be more readable

------------------------------------------------------------------------
r7346 | divverent | 2007-05-23 13:31:54 +0200 (Wed, 23 May 2007) | 2 lines

in v_flipped mode, invert the sense of snd_swapstereo

------------------------------------------------------------------------
r7344 | havoc | 2007-05-23 05:51:42 +0200 (Wed, 23 May 2007) | 2 lines

added support for "rgbgen lightingdiffuse" as a type of lighting

------------------------------------------------------------------------
r7343 | divverent | 2007-05-23 02:23:30 +0200 (Wed, 23 May 2007) | 2 lines

damn, committed the old version of my patch... this now is the REAL v_flipped

------------------------------------------------------------------------
r7342 | divverent | 2007-05-23 02:11:40 +0200 (Wed, 23 May 2007) | 3 lines

cvar: v_flipped flips all 3D view except sprites and flips input to compensate,
basically a poor man's left handed mode

------------------------------------------------------------------------
r7341 | havoc | 2007-05-22 22:17:21 +0200 (Tue, 22 May 2007) | 2 lines

call FS_ClearSearchPath in FS_Shutdown

------------------------------------------------------------------------
r7340 | havoc | 2007-05-22 22:15:24 +0200 (Tue, 22 May 2007) | 2 lines

close packs when clearing search path

------------------------------------------------------------------------
r7339 | havoc | 2007-05-22 22:07:56 +0200 (Tue, 22 May 2007) | 2 lines

renamed snd_reload to snd_unloadallsounds to clarify its purpose

------------------------------------------------------------------------
r7338 | havoc | 2007-05-22 20:46:56 +0200 (Tue, 22 May 2007) | 4 lines

enable svc_pointparticles1 protocol, because the pointparticles
extension is so new that compatibility with month-old clients that never
officially supported the DP_SV_POINTPARTICLES feature is not a concern

------------------------------------------------------------------------
r7337 | havoc | 2007-05-22 12:08:34 +0200 (Tue, 22 May 2007) | 5 lines

fixed bug in autosprite setup code that made it malfunction badly on any
non-world entity
rewrote autosprite code to make it a bit cleaner
rewrote autosprite2 code to make it work properly

------------------------------------------------------------------------
r7336 | divverent | 2007-05-22 10:07:34 +0200 (Tue, 22 May 2007) | 2 lines

Win32: ioctl SIO_UDP_CONNRESET <- FALSE

------------------------------------------------------------------------
r7335 | divverent | 2007-05-22 09:39:05 +0200 (Tue, 22 May 2007) | 3 lines

Reject clc_stringcmd with \r and \n in them; when developer is set, hex dump these commands.
Exception: \r and \n are allowed at the end of a clc_stringcmd, but get cut off before processing (DP builds from before yesterday did that with sentcvar commands).

------------------------------------------------------------------------
r7334 | havoc | 2007-05-22 07:50:19 +0200 (Tue, 22 May 2007) | 2 lines

q3 shaders are now supported on all model and map formats

------------------------------------------------------------------------
r7333 | havoc | 2007-05-22 04:37:06 +0200 (Tue, 22 May 2007) | 2 lines

fix typo

------------------------------------------------------------------------
r7331 | havoc | 2007-05-22 01:08:37 +0200 (Tue, 22 May 2007) | 3 lines

added DP_SV_POINTPARTICLES extension string (the functions already
existed)

------------------------------------------------------------------------
r7330 | havoc | 2007-05-22 00:13:46 +0200 (Tue, 22 May 2007) | 4 lines

added svc_pointparticles1 for next protocol bump (uses 15 bytes instead
of 29 bytes for the potentially common case of zero velocity and a count
of 1)

------------------------------------------------------------------------
r7329 | divverent | 2007-05-21 23:14:34 +0200 (Mon, 21 May 2007) | 2 lines

make ASCII 10 and ASCII 13 terminate messagemode too (fixes Ctrl-J, Ctrl-M, Num-Enter)

------------------------------------------------------------------------
r7328 | divverent | 2007-05-21 23:08:24 +0200 (Mon, 21 May 2007) | 2 lines

sentcvar: don't append a \n, it's a clc_stringcmd, these are not separated by \n!

------------------------------------------------------------------------
r7327 | havoc | 2007-05-21 00:42:39 +0200 (Mon, 21 May 2007) | 3 lines

removed r_shadow_realtime_world_dlightshadows cvar, now the
r_shadow_realtime_dlight_shadows setting applies even in rtworld mode

------------------------------------------------------------------------
r7326 | havoc | 2007-05-21 00:32:51 +0200 (Mon, 21 May 2007) | 2 lines

renamed r_shadow_shadow_polygon* cvars to r_shadow_polygon*

------------------------------------------------------------------------
r7325 | havoc | 2007-05-21 00:28:18 +0200 (Mon, 21 May 2007) | 3 lines

validate r_shadow_frontsidecasting each frame and correct it to a valid
value if invalid

------------------------------------------------------------------------
r7324 | havoc | 2007-05-21 00:26:48 +0200 (Mon, 21 May 2007) | 4 lines

made the effect of the r_shadow_shadow_polygonoffset cvar reverse when
r_shadow_frontsidecasting is off, so that only one setting needs
changing to toggle between the two modes

------------------------------------------------------------------------
r7323 | havoc | 2007-05-20 18:16:02 +0200 (Sun, 20 May 2007) | 2 lines

send input for every client frame in singleplayer

------------------------------------------------------------------------
r7322 | divverent | 2007-05-20 18:02:27 +0200 (Sun, 20 May 2007) | 2 lines

DP_PRELOAD_DEPENDENCIES=yes makefile option: when set, link against the libraries needed using -l dynamically so they won't get loaded at runtime using dlopen

------------------------------------------------------------------------
r7321 | divverent | 2007-05-20 16:59:03 +0200 (Sun, 20 May 2007) | 7 lines

new option -capturedemo to capture a demo to an AVI file;
new cvars cl_capturevideo_width, cl_capturevideo_height to scale down video capture
when capturing >1GB, don't write an index chunk (in that case, an ix00/ix01 chunk has to be written, but that's not yet implemented)
when capturing, write a "dmlh" header to store the total number of frames, and store the partial number of frames in the "avih" header, as specified by OpenDML
when capturing, store the aspect ratio in a "vprp" header chunk (OpenDML)
make Host_Quit_f do nothing when already quitting (fixes "quit" issue while playing back a demo); note that Host_Quit_f is only used by the console and by -benchmark/-demo/-capturedemo

------------------------------------------------------------------------
r7320 | havoc | 2007-05-19 21:24:19 +0200 (Sat, 19 May 2007) | 2 lines

don't send svc_statubyte or any stat index over 32 to old clients

------------------------------------------------------------------------
r7319 | havoc | 2007-05-19 21:23:34 +0200 (Sat, 19 May 2007) | 2 lines

don't send empty unreliable packets

------------------------------------------------------------------------
r7318 | havoc | 2007-05-19 20:42:03 +0200 (Sat, 19 May 2007) | 3 lines

fix bug that caused server to send incorrect format of .velocity in
svc_clientdata when using "QUAKEDP" protocol

------------------------------------------------------------------------
r7317 | havoc | 2007-05-19 14:01:02 +0200 (Sat, 19 May 2007) | 6 lines

reworked newmouseparms[] code
removed -noforcemspd and -noforcemaccel options as they didn't make
sense when comparing to the MSDN documentation (-noforcemparms remains)
fixed any possible bugs with restoring originalmouseparms[]
added comments explaining the meaning of newmouseparms[] components

------------------------------------------------------------------------
r7316 | divverent | 2007-05-19 11:19:52 +0200 (Sat, 19 May 2007) | 2 lines

kill mouse accel using IOHIDSetAccelerationWithKey(mouseDev, CFSTR(kIOHIDMouseAccelerationType), -1.0) instead, this is what System Preferences uses (otherwise, mouse accel doesn't get restored right on exit)

------------------------------------------------------------------------
r7315 | divverent | 2007-05-18 23:11:39 +0200 (Fri, 18 May 2007) | 2 lines

more of these

------------------------------------------------------------------------
r7314 | divverent | 2007-05-18 23:08:47 +0200 (Fri, 18 May 2007) | 5 lines

foo *var;
sizeof(var) is the size of the POINTER
sizeof(*var) is the size of the TYPE
Now it should work...

------------------------------------------------------------------------
r7313 | divverent | 2007-05-18 23:05:19 +0200 (Fri, 18 May 2007) | 2 lines

only memcpy the suggested format if the failure is not permanent! Otherwise, it can lead to endless loops

------------------------------------------------------------------------
r7312 | havoc | 2007-05-18 17:26:11 +0200 (Fri, 18 May 2007) | 2 lines

implemented support for \" in console command parsing code

------------------------------------------------------------------------
r7311 | havoc | 2007-05-18 00:01:55 +0200 (Fri, 18 May 2007) | 2 lines

changed default of cl_netinputpacketsperserverpacket to 1.0

------------------------------------------------------------------------
r7310 | havoc | 2007-05-17 23:23:03 +0200 (Thu, 17 May 2007) | 2 lines

allow non-integer cl_netinputpacketsperserverpacket values

------------------------------------------------------------------------
r7309 | havoc | 2007-05-17 21:19:38 +0200 (Thu, 17 May 2007) | 2 lines

fix descriptions on cl_netinputpacketsper* cvars

------------------------------------------------------------------------
r7308 | havoc | 2007-05-17 21:14:36 +0200 (Thu, 17 May 2007) | 4 lines

added a cvar which allows the client to send more than one packet per
server packet, by default 2, this results in smoother demos when packet
loss is occurring with predicted movement

------------------------------------------------------------------------
r7307 | havoc | 2007-05-17 21:04:55 +0200 (Thu, 17 May 2007) | 2 lines

don't limit lerps to 100ms in demo playback

------------------------------------------------------------------------
r7306 | havoc | 2007-05-17 20:58:54 +0200 (Thu, 17 May 2007) | 7 lines

moved the code that applies slowmo to demo playback so that it reacts
immediately to changes, not at the next packet read (which may never
come if slowmo was set to 0 at any point)
made pausedemo command freeze demo playback in a way that time does not
advance, preventing the problem where it fast forwards to catch up with
where it would have been if not paused after unpausing the demo

------------------------------------------------------------------------
r7303 | divverent | 2007-05-17 17:53:57 +0200 (Thu, 17 May 2007) | 2 lines

cvar apple_mouse_noaccel (1 default) disables mouse acceleration

------------------------------------------------------------------------
r7302 | divverent | 2007-05-17 17:50:10 +0200 (Thu, 17 May 2007) | 2 lines

setting skinframe to R_SkinFrame_LoadMissing for animmap too!

------------------------------------------------------------------------
r7301 | havoc | 2007-05-17 16:14:19 +0200 (Thu, 17 May 2007) | 2 lines

fix 3 typos

------------------------------------------------------------------------
r7300 | havoc | 2007-05-17 15:49:39 +0200 (Thu, 17 May 2007) | 2 lines

renamed vid_dga to vid_dgamouse

------------------------------------------------------------------------
r7299 | havoc | 2007-05-17 15:45:35 +0200 (Thu, 17 May 2007) | 2 lines

renamed vid_dga to vid_dgamouse

------------------------------------------------------------------------
r7298 | havoc | 2007-05-17 15:44:12 +0200 (Thu, 17 May 2007) | 3 lines

cleaned up vid_dga code, removed vid_dga_mouseaccel cvar as it did the
same thing as sensitivity (and was not saved, and defaulted to 1)

------------------------------------------------------------------------
r7297 | havoc | 2007-05-17 13:55:41 +0200 (Thu, 17 May 2007) | 2 lines

improved coreaudio initialization code to suggest more changes

------------------------------------------------------------------------
r7296 | havoc | 2007-05-17 13:43:53 +0200 (Thu, 17 May 2007) | 3 lines

fix CoreAudio support so that it suggests a proper sound speed when the
hardware returns a different value

------------------------------------------------------------------------
r7295 | divverent | 2007-05-17 12:16:58 +0200 (Thu, 17 May 2007) | 2 lines

enable apple multithreaded GL by default; let's see when the first one complains

------------------------------------------------------------------------
r7294 | divverent | 2007-05-17 11:38:46 +0200 (Thu, 17 May 2007) | 2 lines

libcurl-4; vid_glx: RTLD_GLOBAL (apparently FreeBSD users need it)

------------------------------------------------------------------------
r7293 | havoc | 2007-05-16 19:15:09 +0200 (Wed, 16 May 2007) | 3 lines

trace corona checks from eye to light origin, this fixes light coronas
being seen inside walls in quake mission pack 2 on lightning traps

------------------------------------------------------------------------
r7292 | havoc | 2007-05-16 19:11:35 +0200 (Wed, 16 May 2007) | 2 lines

fix some unused variables

------------------------------------------------------------------------
r7291 | havoc | 2007-05-16 19:11:04 +0200 (Wed, 16 May 2007) | 4 lines

changed 1-frame warm-up period to 3 frames before time begins advancing
in the timedemo playback (meaning 3 identical frames are rendered first)
this should improve consistency of timedemo results

------------------------------------------------------------------------
r7290 | havoc | 2007-05-16 15:45:39 +0200 (Wed, 16 May 2007) | 3 lines

changed an error when fighting the end boss of Nehahra to merely a
warning, the qc should be fixed though

------------------------------------------------------------------------
r7289 | havoc | 2007-05-16 13:47:15 +0200 (Wed, 16 May 2007) | 2 lines

hopefully fixed a bug in line/sphere collision code (not used)

------------------------------------------------------------------------
r7288 | havoc | 2007-05-16 11:27:04 +0200 (Wed, 16 May 2007) | 3 lines

optimized the Mod_Q3BSP_LightPoint pitch/yaw math by using the
mod_md3_sin table rather than a lot of angle math to feed to cos/sin

------------------------------------------------------------------------
r7287 | divverent | 2007-05-16 01:16:06 +0200 (Wed, 16 May 2007) | 2 lines

only print Set: and SetA: for developer >= 100 (as only then, a Cvar_Get function call line always follows)

------------------------------------------------------------------------
r7286 | divverent | 2007-05-16 01:12:54 +0200 (Wed, 16 May 2007) | 4 lines

calling VM_SetTraceGlobals can create a tempstring for the texture name; thus,
make sure that the tempstring gets freed when VM_SetTraceGlobals gets called
from outside QC (before calling the touch function)

------------------------------------------------------------------------
r7285 | havoc | 2007-05-15 12:14:06 +0200 (Tue, 15 May 2007) | 2 lines

renamed QUAKEWORLD protocol to QW to shorten connect string

------------------------------------------------------------------------
r7284 | havoc | 2007-05-15 12:08:23 +0200 (Tue, 15 May 2007) | 3 lines

fix a bug that caused the DP server to only report the first two
protocols it supports rather than all

------------------------------------------------------------------------
r7280 | havoc | 2007-05-14 16:34:53 +0200 (Mon, 14 May 2007) | 4 lines

added a proper gl_lightmaps rendering path, previously the gl_lightmaps
option did not work with r_glsl 1 and affected sprites (which it was not
meant to)

------------------------------------------------------------------------
r7279 | divverent | 2007-05-14 16:31:57 +0200 (Mon, 14 May 2007) | 2 lines

oops, forgot to remove it...

------------------------------------------------------------------------
r7278 | divverent | 2007-05-14 16:25:46 +0200 (Mon, 14 May 2007) | 2 lines

need to explicitly load vorbis_comment_query from libvorbis, not libvorbisfile, on Win32

------------------------------------------------------------------------
r7277 | havoc | 2007-05-14 16:20:00 +0200 (Mon, 14 May 2007) | 2 lines

remove a piece of debugging code

------------------------------------------------------------------------
r7276 | havoc | 2007-05-14 16:07:27 +0200 (Mon, 14 May 2007) | 3 lines

fixed lightmap merging bugs and added a special simplified case for
the case of no merging (mainly for testing)

------------------------------------------------------------------------
r7275 | havoc | 2007-05-14 14:24:55 +0200 (Mon, 14 May 2007) | 4 lines

reworked lightmap merging code to determine optimal texture size for
each merged lightmap texture (which basically means the last one is now
smaller than the rest in most cases)

------------------------------------------------------------------------
r7274 | divverent | 2007-05-14 14:03:07 +0200 (Mon, 14 May 2007) | 2 lines

LOOP_START tag in vorbis files now gives the sample number to loop from

------------------------------------------------------------------------
r7273 | havoc | 2007-05-14 12:28:00 +0200 (Mon, 14 May 2007) | 4 lines

restored the old lightmap batching code that I removed when adding the
lightmap merging, this helps a lot on maps that don't fit in one
1024x1024 lightmap

------------------------------------------------------------------------
r7272 | havoc | 2007-05-14 11:33:26 +0200 (Mon, 14 May 2007) | 3 lines

changed loopstart from signed to unsigned, now un-looped sounds are
represented with loopstart == total_length

------------------------------------------------------------------------
r7271 | havoc | 2007-05-14 11:12:25 +0200 (Mon, 14 May 2007) | 6 lines

removed channel_t->end and lastptime, now only pos governs playback
position, this should make the playback code safer
reworked S_PaintChannels to advance channel pos regardless of volume
changed S_StartSound to delay sounds rather than skip them, which may be
important on short sound effects

------------------------------------------------------------------------
r7270 | havoc | 2007-05-12 12:26:15 +0200 (Sat, 12 May 2007) | 2 lines

don't use cl_nettimesync code when playing a demo

------------------------------------------------------------------------
r7269 | havoc | 2007-05-12 12:02:06 +0200 (Sat, 12 May 2007) | 6 lines

added a keyname for backslash which is now used instead of the literal \
character, avoiding issues with bind "\" "something" which was parsing
wrongly, also removed the quotes around the bind keyname, and changed
the keyname code to prefer using the override names (such as tilde
instead of ~) in binds when saving the config

------------------------------------------------------------------------
r7268 | havoc | 2007-05-12 11:46:58 +0200 (Sat, 12 May 2007) | 3 lines

patch from David Cristian which adds a "browse mods" menu which seems to
work quite well

------------------------------------------------------------------------
r7267 | divverent | 2007-05-11 10:45:14 +0200 (Fri, 11 May 2007) | 2 lines

fix description of cl_movement_wateraccelerate; make air movement use movevars_airaccelerate (fixes movement in Nexuiz Pro)

------------------------------------------------------------------------
r7266 | divverent | 2007-05-11 10:20:56 +0200 (Fri, 11 May 2007) | 2 lines

if .gravity field is zero, it means the same as one (see also: SV_AddGravity)

------------------------------------------------------------------------
r7265 | divverent | 2007-05-11 10:14:11 +0200 (Fri, 11 May 2007) | 2 lines

also send friction/waterfriction as stats

------------------------------------------------------------------------
r7264 | divverent | 2007-05-11 09:47:31 +0200 (Fri, 11 May 2007) | 2 lines

fix typo in r_q1bsp_skymasking cvar name

------------------------------------------------------------------------
r7263 | havoc | 2007-05-11 03:17:24 +0200 (Fri, 11 May 2007) | 4 lines

added back cl_netsyncboundmode 5 (4 with sub-millisecond adjustment when
very near the correct value)
added new default cl_nettimesyncboundmode 6, this is a hybrid of 1 and 5

------------------------------------------------------------------------
r7262 | havoc | 2007-05-11 03:04:45 +0200 (Fri, 11 May 2007) | 5 lines

moved almost all server cvars to sv_main.c and added corresponding
externs in server.h
removed cl_gravity and cl_slowmo cvars
renamed cl.movevars_slowmo to cl.movevars_timescale

------------------------------------------------------------------------
r7261 | havoc | 2007-05-11 02:00:29 +0200 (Fri, 11 May 2007) | 4 lines

added friction and waterfriction movevars stats
corrected sv_airaccel_qw and sv_airaccel_sideways_friction cvars (they
had the wrong name string)

------------------------------------------------------------------------
r7257 | havoc | 2007-05-09 13:09:07 +0200 (Wed, 09 May 2007) | 3 lines

added back support for {}()[]: special characters in
COM_ParseToken_VM_Tokenize

------------------------------------------------------------------------
r7256 | havoc | 2007-05-09 13:00:14 +0200 (Wed, 09 May 2007) | 5 lines

renamed COM_ParseTokenConsole to COM_ParseToken_Console
split COM_ParseToken into COM_ParseToken_Simple, COM_ParseToken_QuakeC
and COM_ParseToken_VM_Tokenize which have different support for special
characters

------------------------------------------------------------------------
r7255 | havoc | 2007-05-09 11:53:11 +0200 (Wed, 09 May 2007) | 2 lines

fixed several critical bugs in VM_tokenizebyseparator

------------------------------------------------------------------------
r7254 | havoc | 2007-05-09 11:29:56 +0200 (Wed, 09 May 2007) | 3 lines

fix broken OFS_PARM0 + index code in VM_M_callfunction and
VM_tokenizebyseparator, these were not multiplying by 3 as is required

------------------------------------------------------------------------
r7253 | havoc | 2007-05-09 02:17:21 +0200 (Wed, 09 May 2007) | 2 lines

removed a wasted normalize in fragment shader for model lighting

------------------------------------------------------------------------
r7252 | havoc | 2007-05-09 02:13:21 +0200 (Wed, 09 May 2007) | 2 lines

scale demo playback speed by slowmo cvar

------------------------------------------------------------------------
r7251 | divverent | 2007-05-08 01:19:14 +0200 (Tue, 08 May 2007) | 2 lines

GAME_NEXUIZ: move the key up a bit for keyhunt, looks better

------------------------------------------------------------------------
r7250 | divverent | 2007-05-07 23:36:32 +0200 (Mon, 07 May 2007) | 2 lines

Impossible combination of GAME_NEXUIZ CTF status icons ("have red flag | have blue flag") now displays an alternate image for the new keyhunt game mode

------------------------------------------------------------------------
r7249 | havoc | 2007-05-07 22:50:22 +0200 (Mon, 07 May 2007) | 2 lines

fix crash when loading progs/null.spr in nehahra, which has 0x0 size

------------------------------------------------------------------------
r7248 | divverent | 2007-05-07 20:23:22 +0200 (Mon, 07 May 2007) | 3 lines

fix glsl model lighting on unlit maps (normal vector was calculated as (0,0,0) as there was no contribution from the map -> GLSL calls normalize() on that -> (nan,nan,nan), which apparently counts as black).
The fix replaces these zero normal vectors by (0,0,1) (which vector is actually chosen does not matter, as its contribution is scaled by zero anyway).

------------------------------------------------------------------------
r7247 | divverent | 2007-05-07 19:17:38 +0200 (Mon, 07 May 2007) | 2 lines

let the slowmo cvar override the server/demo's idea of slowmo when it is != 1; makes slowmo work again for demo playback

------------------------------------------------------------------------
r7246 | havoc | 2007-05-07 10:46:37 +0200 (Mon, 07 May 2007) | 2 lines

reduced uninitialized memory a bit more

------------------------------------------------------------------------
r7245 | havoc | 2007-05-07 09:28:00 +0200 (Mon, 07 May 2007) | 4 lines

reduced uninitialized data size by 13MB by moving some temporary arrays
used by outdated protocols into their database struct, also moved some
other arrays

------------------------------------------------------------------------
r7244 | havoc | 2007-05-07 08:46:04 +0200 (Mon, 07 May 2007) | 2 lines

replaced mod_known array with a memexpandablearray_t, this saves 11.5MB

------------------------------------------------------------------------
r7243 | havoc | 2007-05-07 07:37:08 +0200 (Mon, 07 May 2007) | 7 lines

rewrote server sendstates building code, no longer builds two
entity_state_t arrays (where one of them is global and one per-client),
this is a slight efficiency loss but saves a few megabytes and makes the
customizeentityforclient code more straightforward
merged some global variables into cl. and sv. structs, and others became
arrays on the stack

------------------------------------------------------------------------
r7242 | havoc | 2007-05-07 05:41:11 +0200 (Mon, 07 May 2007) | 5 lines

now sends player physics variables as stats, including slowmo, gravity,
and sys_ticrate, this avoids the need to stuffcmd cl_movement cvars
on servers that provide the ticrate stat the cl_netinputpacketspersecond
cvar is no longer important, this also seems to improve demo recording

------------------------------------------------------------------------
r7241 | havoc | 2007-05-07 05:01:40 +0200 (Mon, 07 May 2007) | 2 lines

removed PRVM_EDICT_NUM_UNSIGNED (PRVM_EDICT_NUM now casts to unsigned)

------------------------------------------------------------------------
r7240 | havoc | 2007-05-07 04:49:41 +0200 (Mon, 07 May 2007) | 3 lines

changed rain to spawn particles without collisions and implemented
delayed spawning of splashes to facilitate this

------------------------------------------------------------------------
r7239 | havoc | 2007-05-07 04:49:10 +0200 (Mon, 07 May 2007) | 2 lines

increased tolerance on warnings in DEBUGMOVES code

------------------------------------------------------------------------
r7238 | havoc | 2007-05-07 04:48:43 +0200 (Mon, 07 May 2007) | 3 lines

fixed a reference to sv.models in client code (should have been
cl.model_precache)

------------------------------------------------------------------------
r7237 | havoc | 2007-05-07 00:46:43 +0200 (Mon, 07 May 2007) | 4 lines

rewrote most of wad system, this eliminated 512KB of static arrays for
hlwad lumpinfo
added W_UnloadAll function which is now called by FS_Rescan

------------------------------------------------------------------------
r7236 | havoc | 2007-05-06 14:23:19 +0200 (Sun, 06 May 2007) | 2 lines

made r_depthfirst a saved cvar

------------------------------------------------------------------------
r7235 | havoc | 2007-05-06 13:37:04 +0200 (Sun, 06 May 2007) | 2 lines

added support for \" in console

------------------------------------------------------------------------
r7234 | havoc | 2007-05-06 12:38:31 +0200 (Sun, 06 May 2007) | 5 lines

added r_depthfirst option which defaults to 1 (render depth of world
into scene before rendering color), and also offers 2 (render depth of
world and models), this saves shader fillrate on intensive shaders or
texturing techniques (deluxemapping, anisotropic filtering, etc)

------------------------------------------------------------------------
r7233 | havoc | 2007-05-06 12:13:43 +0200 (Sun, 06 May 2007) | 4 lines

reworked sound mixing code to fix a bug that caused sound to stop
working after a timedemo (or anything else that overrode the normal
sound timing)

------------------------------------------------------------------------
r7232 | havoc | 2007-05-06 12:12:19 +0200 (Sun, 06 May 2007) | 3 lines

fix a bug that caused GL20 render path to always ask for tangents and
normals when rendering models

------------------------------------------------------------------------
r7230 | divverent | 2007-05-04 13:40:58 +0200 (Fri, 04 May 2007) | 2 lines

oops, the r_picmipworld should be CVAR_SAVE of course. Sorry for that.

------------------------------------------------------------------------
r7229 | divverent | 2007-05-04 11:29:57 +0200 (Fri, 04 May 2007) | 2 lines

r_picmipworld - when 0, gl_picmip does not apply to world models (because they tend to use much less texture memory than player models in Nexuiz)

------------------------------------------------------------------------
r7228 | havoc | 2007-05-04 09:01:34 +0200 (Fri, 04 May 2007) | 6 lines

fixed broken trails (introduced by my attempt to fix them)
fixed a bug where attachments to viewmodelforclient entities would show
up in the world in chase_active 1 mode near 0 0 0
rain particles now trace ahead at spawn and only begin collision
checking when near the impact time

------------------------------------------------------------------------
r7227 | havoc | 2007-05-04 03:17:16 +0200 (Fri, 04 May 2007) | 2 lines

reenabled code that unloads unused models on level change

------------------------------------------------------------------------
r7226 | havoc | 2007-05-03 09:40:58 +0200 (Thu, 03 May 2007) | 3 lines

fix bug where attached models spawn a trail from their non-attached
start location to their new location on the first frame

------------------------------------------------------------------------
r7225 | divverent | 2007-05-02 15:49:57 +0200 (Wed, 02 May 2007) | 2 lines

damn, I can't convert hex/dec...

------------------------------------------------------------------------
r7224 | divverent | 2007-05-02 15:20:35 +0200 (Wed, 02 May 2007) | 2 lines

made palette colors more readable

------------------------------------------------------------------------
r7223 | havoc | 2007-05-02 06:36:28 +0200 (Wed, 02 May 2007) | 3 lines

a slight cleanup of PaintAndSubmit conditions and S_Update early out
conditions

------------------------------------------------------------------------
r7222 | havoc | 2007-05-01 08:11:48 +0200 (Tue, 01 May 2007) | 6 lines

significant cleanup of input networking code (reorganized and now uses
frametimes rather than timestamps for queued moves) and some refinements
to prediction code
tried to reimplement the anti-pogostick code and it's partially working
but not completely (mispredicts for one frame each time)

------------------------------------------------------------------------
r7221 | havoc | 2007-05-01 04:25:32 +0200 (Tue, 01 May 2007) | 3 lines

default vid_grabkeyboard to 0, it's already forced to 1 on fullscreen so
this should do no harm

------------------------------------------------------------------------
r7220 | divverent | 2007-05-01 01:00:58 +0200 (Tue, 01 May 2007) | 2 lines

make SV_PushMove push by playerclip faces too (by using the right contents mask for each pushed entity)

------------------------------------------------------------------------
r7219 | havoc | 2007-05-01 00:44:19 +0200 (Tue, 01 May 2007) | 3 lines

mvdsv sucks (changed *ver from showing a string like DarkPlaces Linux
14:15:44 Apr 30 2007, to simply \*ver\dp)

------------------------------------------------------------------------
r7218 | dresk | 2007-04-30 23:59:19 +0200 (Mon, 30 Apr 2007) | 1 line

Applied KadaverJack's patch on my cl_sound_ric_gunshot code that provides a small optimization by using bitwise operations instead of numerical calculations.
------------------------------------------------------------------------
r7216 | dresk | 2007-04-30 19:27:16 +0200 (Mon, 30 Apr 2007) | 1 line

Added DP_QC_STRING_CASE_FUNCTIONS extension, providing VM functions strtolower and strtoupper which return the lowercase and uppercase of strings respectively, available across the CL, SV and MENU VMs.
------------------------------------------------------------------------
r7215 | havoc | 2007-04-30 19:22:47 +0200 (Mon, 30 Apr 2007) | 2 lines

fix pl% calculation for QW servers (was using [i] instead of [j])

------------------------------------------------------------------------
r7214 | havoc | 2007-04-30 19:02:10 +0200 (Mon, 30 Apr 2007) | 2 lines

fix nettimesync bug after the recent cleanup

------------------------------------------------------------------------
r7213 | havoc | 2007-04-30 07:39:56 +0200 (Mon, 30 Apr 2007) | 3 lines

implemented QW skin support, it's broken on skins that are not the same
size as the model skin though

------------------------------------------------------------------------
r7212 | havoc | 2007-04-30 07:39:00 +0200 (Mon, 30 Apr 2007) | 2 lines

count empty packets in rate limiting

------------------------------------------------------------------------
r7211 | havoc | 2007-04-30 07:28:29 +0200 (Mon, 30 Apr 2007) | 3 lines

fix a bug in texture path identification (the nopath case was occurring
even when there was a path, because it was checking the wrong variable)

------------------------------------------------------------------------
r7210 | havoc | 2007-04-30 07:27:03 +0200 (Mon, 30 Apr 2007) | 7 lines

removed cl_nettimesyncboundmode 5 because it seems to print many more
time warnings than 4 does when developer is on
now sets cls.servermovesequence to cls.netcon->qw_incoming_sequence
now keeps around qw player entities if a packet does not contain any
(an fteqw server I was testing on sometimes sent packets containing
large reliable message groups but no player entities at all)

------------------------------------------------------------------------
r7209 | dresk | 2007-04-30 05:58:20 +0200 (Mon, 30 Apr 2007) | 1 line

Updated cl_sound_ric_gunshot CVar to support multiple modes.  0 plays no sounds, 1 plays sounds on TE_GUNSHOT, 2 plays sounds on TE_GUNSHOTQUAD and 3 plays sounds on both TE_GUNSHOT and TE_GUNSHOTQUAD.  This is not bloat because the Crylink in Nexuiz uses TE_GUNSHOTQUAD, and most people don't want ricochet sounds on that (though if you do, all the merrier).
------------------------------------------------------------------------
r7208 | havoc | 2007-04-30 00:15:44 +0200 (Mon, 30 Apr 2007) | 3 lines

increased IP + UDP header overhead estimate from 18 bytes to 28 bytes
based on tcpdump results

------------------------------------------------------------------------
r7207 | divverent | 2007-04-29 21:36:05 +0200 (Sun, 29 Apr 2007) | 2 lines

store into *colorindex again

------------------------------------------------------------------------
r7206 | dresk | 2007-04-28 01:25:47 +0200 (Sat, 28 Apr 2007) | 1 line

Added cl_sound_ric_gunshot which specifies if the related cl_sound_ric and cl_sound_tink CVars will apply to te_gunshot and te_gunshotquad calls.  The default value is 0 and it is not saved.
------------------------------------------------------------------------
r7205 | divverent | 2007-04-28 00:57:01 +0200 (Sat, 28 Apr 2007) | 2 lines

make COM_StringLengthNoColors and COM_StringDecolorize get an additional length parameter to just work on part of a string (if set to 0, it means use the whole string); use that in centerprint drawing to fix centering issues in some odd situations like "^^^^^^^^^^^^^^^^^^^^^^^^^^".

------------------------------------------------------------------------
r7203 | havoc | 2007-04-26 22:20:20 +0200 (Thu, 26 Apr 2007) | 2 lines

clarified descriptions of r_mipsprites and r_mipskins

------------------------------------------------------------------------
r7202 | havoc | 2007-04-26 18:19:42 +0200 (Thu, 26 Apr 2007) | 3 lines

split cl_netpacketloss into cl_netpacketloss_send and
cl_netpacketloss_receive to allow more network testing

------------------------------------------------------------------------
r7197 | havoc | 2007-04-25 20:17:38 +0200 (Wed, 25 Apr 2007) | 4 lines

fixed bug where animated mdl skins (such as Tomaz's health box and
explobox models in dpmod) were getting freed because they were not
properly counted in the model->num_textures

------------------------------------------------------------------------
r7194 | havoc | 2007-04-25 18:41:34 +0200 (Wed, 25 Apr 2007) | 2 lines

changed default cl_movement_minping from 1 to 0

------------------------------------------------------------------------
r7193 | havoc | 2007-04-25 18:41:02 +0200 (Wed, 25 Apr 2007) | 2 lines

changed default cl_movement_minping from 50 to 1

------------------------------------------------------------------------
r7192 | havoc | 2007-04-25 16:47:02 +0200 (Wed, 25 Apr 2007) | 4 lines

added tracking of memory usage of VBO/EBO buffers
added gl_vbostats command to list VBO/EBO buffers
added total VBO/EBO usage information in memstats

------------------------------------------------------------------------
r7191 | havoc | 2007-04-25 12:15:55 +0200 (Wed, 25 Apr 2007) | 3 lines

fix bugs in Mod_Q3BSP_Loadtextures that caused crashes and other
sillyness

------------------------------------------------------------------------
r7190 | divverent | 2007-04-25 10:38:40 +0200 (Wed, 25 Apr 2007) | 2 lines

prevent abuse by ending netname with a ^: if the name is not a valid colored string, add a ^ if possible, and if there is no space for it, remove the trailing ^

------------------------------------------------------------------------
r7189 | divverent | 2007-04-25 09:18:16 +0200 (Wed, 25 Apr 2007) | 7 lines

fix strlennocol/strdecolorize on unusual strings like "foo^";
now strlennocol returns the visible width (like before) and strdecolorize
returns a string that can be safely printed and that looks like the original,
just without the colors.

Moved decolorizing and counting to common.c.

------------------------------------------------------------------------
r7188 | havoc | 2007-04-25 01:17:36 +0200 (Wed, 25 Apr 2007) | 3 lines

isolated more of the texture loading code from the rest of model
loading, to avoid potential for crashes in dedicated servers

------------------------------------------------------------------------
r7187 | havoc | 2007-04-25 00:55:20 +0200 (Wed, 25 Apr 2007) | 2 lines

fixed crash in sprite loaders on dedicated servers

------------------------------------------------------------------------
r7186 | havoc | 2007-04-24 23:29:59 +0200 (Tue, 24 Apr 2007) | 6 lines

added DP_SV_MODELFLAGS_AS_EFFECTS extension, this adds EF_ROCKET and
friends as effect bits in the protocol, the QC can use these constants
directly or can use the new .modelflags field to set them without float
precision issues caused by the large values, this basically means that
you can make an entity leave a blood trail, or look like a rocket

------------------------------------------------------------------------
r7185 | havoc | 2007-04-24 22:33:32 +0200 (Tue, 24 Apr 2007) | 3 lines

reverted dresk's DP_SV_ALLOWTOUCHWITHOWNER patch as it adds unnecessary
bloat when there is a well-known QuakeC approach to do this already

------------------------------------------------------------------------
r7184 | dresk | 2007-04-24 22:28:42 +0200 (Tue, 24 Apr 2007) | 1 line

Added QC float .allowtouchwithowner .  Setting this to true allow an entity to touch its owner (ie. missile or grenade).  Be careful where you spawn your projectiles and assign this value, as you may end up detonating the projectile immediately.
------------------------------------------------------------------------
r7183 | havoc | 2007-04-24 21:24:32 +0200 (Tue, 24 Apr 2007) | 2 lines

allow model flags to work on attached entities

------------------------------------------------------------------------
r7182 | havoc | 2007-04-24 19:11:32 +0200 (Tue, 24 Apr 2007) | 3 lines

expanded texture name buffer so that names don't get clipped in
r_texturestats output

------------------------------------------------------------------------
r7181 | havoc | 2007-04-24 19:08:54 +0200 (Tue, 24 Apr 2007) | 2 lines

don't crash in Mod_BuildAliasSkinFromSkinFrame on dedicated servers

------------------------------------------------------------------------
r7180 | dresk | 2007-04-24 18:27:21 +0200 (Tue, 24 Apr 2007) | 1 line

Added standard color escapes to "changed name to" broadcast prints
------------------------------------------------------------------------
r7179 | dresk | 2007-04-24 18:11:13 +0200 (Tue, 24 Apr 2007) | 1 line

Updated console command description of prvm_edicts (it had the description of prvm_edictset)
------------------------------------------------------------------------
r7178 | dresk | 2007-04-24 17:47:51 +0200 (Tue, 24 Apr 2007) | 1 line

Added return to standard color coding in "status" command player listing
------------------------------------------------------------------------
r7177 | dresk | 2007-04-24 17:40:38 +0200 (Tue, 24 Apr 2007) | 1 line

Added check for MAX_MODELS in cl_modelindexlist command
------------------------------------------------------------------------
r7176 | dresk | 2007-04-24 17:37:47 +0200 (Tue, 24 Apr 2007) | 3 lines

Removed modelindexlist command from cmd.c, shifted function as cl_modelindexlist into cl_main.c

Started modelindex at 1
------------------------------------------------------------------------
r7175 | dresk | 2007-04-24 17:30:47 +0200 (Tue, 24 Apr 2007) | 1 line

Added return to standard color coding in the "Player entered the game" and "Client "Player" Dropped" messages
------------------------------------------------------------------------
r7174 | dresk | 2007-04-24 17:21:56 +0200 (Tue, 24 Apr 2007) | 1 line

Implemented console command 'modelindexlist' which lists all the models and their corresponding model index numbers
------------------------------------------------------------------------
r7173 | havoc | 2007-04-24 17:02:02 +0200 (Tue, 24 Apr 2007) | 2 lines

fixed missing sprite textures caused by purging code

------------------------------------------------------------------------
r7172 | havoc | 2007-04-24 16:41:57 +0200 (Tue, 24 Apr 2007) | 3 lines

fix bug that made all textures without a shader definition have
numskinframes = 0, which caused purging to eliminate their textures

------------------------------------------------------------------------
r7171 | havoc | 2007-04-24 16:41:27 +0200 (Tue, 24 Apr 2007) | 2 lines

check if skinframe is NULL in R_SkinFrame_MarkUsed

------------------------------------------------------------------------
r7170 | havoc | 2007-04-24 16:23:25 +0200 (Tue, 24 Apr 2007) | 2 lines

fix a line I forgot to commit

------------------------------------------------------------------------
r7169 | dresk | 2007-04-24 15:25:23 +0200 (Tue, 24 Apr 2007) | 1 line

Fixed a typo by not putting a whitespace after the DP_SV_NETADDRESS
------------------------------------------------------------------------
r7168 | havoc | 2007-04-24 15:19:07 +0200 (Tue, 24 Apr 2007) | 8 lines

replaced Mod_LoadSkinFrame functions with R_SkinFrame system, this
allows multiple models to share textures in a given level, as well as
models using the same texture multiple times (often the case in md3
where meshes have a vertex limit, and q3bsp where texture structs
describe surface properties and multiple may exist referring to the same
texture set)
this reduced Nexuiz video memory usage by over 150MB

------------------------------------------------------------------------
r7167 | havoc | 2007-04-24 15:12:35 +0200 (Tue, 24 Apr 2007) | 2 lines

fix MAX_CHANNELS, it was too low with the expanded MAX_DYNAMIC_CHANNELS

------------------------------------------------------------------------
r7166 | havoc | 2007-04-24 12:14:46 +0200 (Tue, 24 Apr 2007) | 2 lines

fix crash when freeing an expandable array caused by a typo

------------------------------------------------------------------------
r7165 | havoc | 2007-04-24 08:56:37 +0200 (Tue, 24 Apr 2007) | 3 lines

audited all Sys_Quit calls and gave them return values indicating
whether the game quit normally, so shell scripts get a useful value

------------------------------------------------------------------------
r7164 | havoc | 2007-04-23 22:44:45 +0200 (Mon, 23 Apr 2007) | 5 lines

replaced qglArrayElement calls with qglVertex3f calls in showtris code,
this avoids issues with abysmal gl_vbo 1 performance on NVIDIA cards
(which seem to use a software fallback for drawing lines for some
reason)

------------------------------------------------------------------------
r7162 | dresk | 2007-04-23 22:32:12 +0200 (Mon, 23 Apr 2007) | 1 line

Added new extension for .string netaddress (DP_SV_NETADDRESS)
------------------------------------------------------------------------
r7161 | dresk | 2007-04-23 22:25:05 +0200 (Mon, 23 Apr 2007) | 1 line

Implemented .string netaddress to SVQC, providing the IP Address of the associated client entity (string is "null/botclient is client is not valid)
------------------------------------------------------------------------
r7160 | havoc | 2007-04-23 21:39:18 +0200 (Mon, 23 Apr 2007) | 4 lines

modified Mod_LoadSkinFrame to not attempt to generate a fogging mask if
not given the TEXF_ALPHA flag (in which case the fog mask would not be
used anyway)

------------------------------------------------------------------------
r7159 | havoc | 2007-04-23 21:13:39 +0200 (Mon, 23 Apr 2007) | 2 lines

cleaned up Mod_LoadSkinFrame now that image_loadskin is gone

------------------------------------------------------------------------
r7158 | havoc | 2007-04-23 20:11:15 +0200 (Mon, 23 Apr 2007) | 2 lines

merged image_loadskin and image_freeskin into Mod_LoadSkinFrame

------------------------------------------------------------------------
r7157 | havoc | 2007-04-23 18:20:31 +0200 (Mon, 23 Apr 2007) | 2 lines

fix some unintentional math on a void pointer

------------------------------------------------------------------------
r7154 | havoc | 2007-04-22 15:04:35 +0200 (Sun, 22 Apr 2007) | 3 lines

batch by lightmap rather than by use of lightmaps (batching by use of
lightmaps is no longer necessary with the lightmap merging)

------------------------------------------------------------------------
r7153 | havoc | 2007-04-22 13:24:17 +0200 (Sun, 22 Apr 2007) | 3 lines

added r_showbboxes cvar and accompanying code to render server entity
bounding boxes

------------------------------------------------------------------------
r7152 | havoc | 2007-04-22 11:52:01 +0200 (Sun, 22 Apr 2007) | 2 lines

fix a bug in the last commit pertaining to lightning beam fogging

------------------------------------------------------------------------
r7151 | havoc | 2007-04-22 11:48:18 +0200 (Sun, 22 Apr 2007) | 4 lines

fixed several bugs in fog code, it basically wasn't working in the
r_glsl 0 case at all, it still doesn't work with rtlights in gl_combine
1 mode though

------------------------------------------------------------------------
r7150 | havoc | 2007-04-22 11:02:23 +0200 (Sun, 22 Apr 2007) | 3 lines

fixed bug where items would not fall if pushed off a ledge by a
MOVETYPE_PUSH entity

------------------------------------------------------------------------
r7149 | havoc | 2007-04-22 07:13:06 +0200 (Sun, 22 Apr 2007) | 3 lines

correct a couple error messages which said "Map downloads", changed to
"cURL downloads"

------------------------------------------------------------------------
r7148 | divverent | 2007-04-21 00:36:23 +0200 (Sat, 21 Apr 2007) | 2 lines

oops... sorry for that one. Copypaste without testing never works...

------------------------------------------------------------------------
r7147 | divverent | 2007-04-21 00:22:59 +0200 (Sat, 21 Apr 2007) | 2 lines

fix multithreaded OpenGL support; actually load CGL functions from OpenGL.framework

------------------------------------------------------------------------
r7146 | divverent | 2007-04-20 17:59:28 +0200 (Fri, 20 Apr 2007) | 3 lines

compare the right values for host cache masks;
use -1 bots to indicate unknown bot count

------------------------------------------------------------------------
r7145 | divverent | 2007-04-20 13:43:24 +0200 (Fri, 20 Apr 2007) | 2 lines

new cvar fs_empty_files_in_pack_mark_deletions: when set, a pk3 with empty files can effectively "delete" a file in an earlier pk3

------------------------------------------------------------------------
r7144 | havoc | 2007-04-20 08:25:06 +0200 (Fri, 20 Apr 2007) | 2 lines

upped MAX_DYNAMIC_CHANNELS from 128 to 512

------------------------------------------------------------------------
r7143 | havoc | 2007-04-19 15:17:06 +0200 (Thu, 19 Apr 2007) | 2 lines

changed VERTEXFOGTABLE macro to not use a global variable

------------------------------------------------------------------------
r7142 | havoc | 2007-04-19 14:50:45 +0200 (Thu, 19 Apr 2007) | 6 lines

significant cleanup of reliefmapping shader, now uses step() function
instead of if's, this might improve compatibility with ATI cards, but
not sure, in any case I improved the stepping math a little bit which
saves some time, minor fps improvement on reliefmapping compared to
before

------------------------------------------------------------------------
r7141 | havoc | 2007-04-19 09:32:00 +0200 (Thu, 19 Apr 2007) | 3 lines

adjusted netgraph code to draw the latest netgraph column on the right
rather than the left

------------------------------------------------------------------------
r7140 | havoc | 2007-04-19 02:44:52 +0200 (Thu, 19 Apr 2007) | 2 lines

correct a typo (numbotss)

------------------------------------------------------------------------
r7134 | divverent | 2007-04-18 13:38:57 +0200 (Wed, 18 Apr 2007) | 2 lines

sv_public -2 now allows the local: client to connect

------------------------------------------------------------------------
r7133 | havoc | 2007-04-18 13:15:58 +0200 (Wed, 18 Apr 2007) | 2 lines

fix a bug in the RENDER_EXTERIORMODEL check in the last commit

------------------------------------------------------------------------
r7132 | havoc | 2007-04-18 13:13:57 +0200 (Wed, 18 Apr 2007) | 4 lines

changed protocol code to always send origin as low precision if
possible, except for exteriormodel's (such as the player itself),
this means the only effect of EF_LOWPRECISION is lower precision angles

------------------------------------------------------------------------
r7131 | havoc | 2007-04-18 12:35:30 +0200 (Wed, 18 Apr 2007) | 4 lines

removed the forced LOWPRECISION flag on entities because it messes up
angles too much, and it is hard to decide what origins warrant high
precision or low precision

------------------------------------------------------------------------
r7130 | havoc | 2007-04-18 12:20:09 +0200 (Wed, 18 Apr 2007) | 4 lines

improved entity unsticking code, it now uses a trace from the offset
position back to the original position, and uses the impact point, this
makes it correct significantly less than before

------------------------------------------------------------------------
r7129 | havoc | 2007-04-18 11:59:06 +0200 (Wed, 18 Apr 2007) | 6 lines

try unstick offsets in a certain order, preferring horizontal offsets
and then vertical, and never doing horizontal + vertical, this fixes
problems where you would 'creep' along the floor diagonally at certain
frametimes at certain plane distances where precision error causes
problems, now you only teleport upward 1 unit and fall repeatedly

------------------------------------------------------------------------
r7128 | havoc | 2007-04-18 11:29:50 +0200 (Wed, 18 Apr 2007) | 3 lines

added Mem_ExpandableArray_IndexRange and
Mem_ExpandableArray_RecordAtIndex which allow iterating the array

------------------------------------------------------------------------
r7127 | havoc | 2007-04-18 11:17:54 +0200 (Wed, 18 Apr 2007) | 3 lines

added Mem_ExpandableArray functions, which are not currently used but
may be useful

------------------------------------------------------------------------
r7126 | havoc | 2007-04-18 11:17:33 +0200 (Wed, 18 Apr 2007) | 2 lines

added cl_nettimesyncboundmode 5 which is div0's slight refinement of 4

------------------------------------------------------------------------
r7125 | havoc | 2007-04-18 10:08:31 +0200 (Wed, 18 Apr 2007) | 4 lines

added numbots and numhumans in server info parsing, serverlist filtering
can also mask by these, and the 'player empty' check for the engine's
own server listings now uses numhumans rather than numplayers

------------------------------------------------------------------------
r7124 | havoc | 2007-04-18 09:51:11 +0200 (Wed, 18 Apr 2007) | 4 lines

added reporting of number of bots in getinfo/getstatus replies (they are
counted as clients also, so something parsing the info can deduct them
if it wishes)

------------------------------------------------------------------------
r7123 | havoc | 2007-04-18 09:00:49 +0200 (Wed, 18 Apr 2007) | 3 lines

fix bug introduced in last patch that made all text print one character
to the left

------------------------------------------------------------------------
r7122 | havoc | 2007-04-18 08:45:31 +0200 (Wed, 18 Apr 2007) | 2 lines

further optimized space skipping in DrawQ_String

------------------------------------------------------------------------
r7121 | havoc | 2007-04-18 08:20:32 +0200 (Wed, 18 Apr 2007) | 3 lines

changed weapons bar in nexuiz hud to use alpha rather than additive
blend, and have full opacity for 1 second and then fade over half a second

------------------------------------------------------------------------
r7120 | havoc | 2007-04-18 07:52:36 +0200 (Wed, 18 Apr 2007) | 5 lines

refactored DrawQ_Pic to actually do the drawing rather than wasting time
on a DrawQ_SuperPic call
added DrawQ_Fill as an optimized case of DrawQ_Pic
this significantly improved performance of shownetgraph

------------------------------------------------------------------------
r7119 | havoc | 2007-04-18 07:33:17 +0200 (Wed, 18 Apr 2007) | 9 lines

changed r_textshadow behavior to always draw a black shadow, but with
alpha dependent on the brightness of the primary text color, this means
you don't get white shadows under black text, but do get black shadows
under white text
rewrote DrawQ_String and friends to be one combined function that draws
colored strings more efficiently by batching characters with differing
colors together, and it even batches the shadow with the text which can
help performance significantly with r_textshadow on

------------------------------------------------------------------------
r7118 | havoc | 2007-04-17 13:59:40 +0200 (Tue, 17 Apr 2007) | 2 lines

renamed client netgraphs back to incoming and outgoing

------------------------------------------------------------------------
r7117 | havoc | 2007-04-17 13:51:02 +0200 (Tue, 17 Apr 2007) | 6 lines

added shownetgraph 2 mode which shows netgraphs for all clients when
hosting a listen server
tweaked shownetgraph separator spacing a bit so that it is only 2 pixels
between incoming/outgoing graphs, and 4 pixels between netgraphs
relabeled incoming/outgoing graphs to world/input

------------------------------------------------------------------------
r7116 | havoc | 2007-04-17 13:50:04 +0200 (Tue, 17 Apr 2007) | 6 lines

moved calls of CL_ReadDemoMessage and CL_SendMove from CL_ReadFromServer
to the main loop
renamed CL_ReadFromServer to CL_UpdateWorld, and it is now called even
if not connected (to clear the r_refdef entities/lights info, and the
num_brushmodels)

------------------------------------------------------------------------
r7115 | havoc | 2007-04-17 13:48:51 +0200 (Tue, 17 Apr 2007) | 3 lines

no longer sends nearly-empty input packets when cl.time is less than the
previous move time

------------------------------------------------------------------------
r7114 | havoc | 2007-04-17 11:32:44 +0200 (Tue, 17 Apr 2007) | 6 lines

replaced cl_nettimesyncmode with 3 cvars cl_nettimesyncfactor,
cl_nettimesyncboundmode, cl_nettimesyncboundtolerance
the new default time sync method is from Quake3 and slowly adjusts 1ms
forward each packet received, or falls back 2ms if it found itself ahead
of time

------------------------------------------------------------------------
r7113 | havoc | 2007-04-17 10:03:27 +0200 (Tue, 17 Apr 2007) | 5 lines

fix a crash reported by Lardarse when using more skin textures for a
.mdl model than skins exist in the model, this was caused by texture_t
containing pointers to itself that were broken by the reallocation of
the array

------------------------------------------------------------------------
r7112 | havoc | 2007-04-17 07:54:26 +0200 (Tue, 17 Apr 2007) | 2 lines

moved shownetgraph to right side of screen

------------------------------------------------------------------------
r7111 | divverent | 2007-04-16 23:51:29 +0200 (Mon, 16 Apr 2007) | 2 lines

in X11, keypad * is KP_MULTIPLY, not '*'

------------------------------------------------------------------------
r7110 | havoc | 2007-04-16 15:37:42 +0200 (Mon, 16 Apr 2007) | 3 lines

server no longer calls networking on each physics frame (since sv.datagram
is no longer important)

------------------------------------------------------------------------
r7109 | havoc | 2007-04-16 15:36:31 +0200 (Mon, 16 Apr 2007) | 4 lines

disable some debugging code that caused an empty packet to be sent each
server frame even if CanSend returned false (which was done just to see
when the CanSend blocking was occurring, since it was hard to tell)

------------------------------------------------------------------------
r7108 | havoc | 2007-04-16 15:08:38 +0200 (Mon, 16 Apr 2007) | 7 lines

implemented shownetgraph
major overhaul of rate limiting code
implemented packet-frequency rate limiting (like qw/q2/q3) as a fallback
when packet size limiting fails (such as packet sizes below 100 bytes
causing all sorts of issues, so now the minimum bound on maxsize is 100,
and another good example is reliable messages exceeding the rate limit)

------------------------------------------------------------------------
r7107 | havoc | 2007-04-16 15:05:26 +0200 (Mon, 16 Apr 2007) | 8 lines

fixed several issues in the recent effect rate limiting code (situations
where it could get stuck and stop sending them entirely due to too low a
rate setting)
fixed issues introduced in recent stats code (was not resetting them on
a level change, leading to very broken stats for the client)
this includes a missing part of the LOWPRECISION-on-all-entities patch so
that now works

------------------------------------------------------------------------
r7106 | havoc | 2007-04-16 14:21:00 +0200 (Mon, 16 Apr 2007) | 7 lines

EF_LOWPRECISION is now default on all entities except the player, this
saves quite a bit of bandwidth (bad side effect: rotating bmodels are
less smooth, need another workaround for that...)
fixed a bug in entity priorities which caused entities to be sent with
no change bits set (which did nothing useful, just wasted bandwidth),
saving quite a bit more bandwidth

------------------------------------------------------------------------
r7105 | havoc | 2007-04-16 09:57:51 +0200 (Mon, 16 Apr 2007) | 9 lines

sv.datagram is now flushed to client->unreliablemsg buffers, along with
logging of good split points so that each effect can be issued to
different packets as space allows (sending some each packet), this makes
effects finally obey the rate limit
cleaned up sending of csqc stats in pre-DP6 protocols and renamed the
autosentstats stuff to customstats to better represent what it does
implemented stats updates in pre-DP6 protocols (mostly for sake of
customstats code cleanlyness)

------------------------------------------------------------------------
r7104 | havoc | 2007-04-16 01:37:17 +0200 (Mon, 16 Apr 2007) | 2 lines

made cl_joinbeforedownloadsfinish a saved cvar

------------------------------------------------------------------------
r7103 | havoc | 2007-04-16 01:36:43 +0200 (Mon, 16 Apr 2007) | 2 lines

made cl_nettimesyncmode a saved cvar

------------------------------------------------------------------------
r7102 | havoc | 2007-04-16 00:13:01 +0200 (Mon, 16 Apr 2007) | 2 lines

added cl_nettimesyncmode 7 (adaptive + loose sync)

------------------------------------------------------------------------
r7101 | havoc | 2007-04-15 23:59:02 +0200 (Sun, 15 Apr 2007) | 3 lines

added cl_nettimesyncmode 6 (adaptive sync, gradually adapts to server
sync)

------------------------------------------------------------------------
r7100 | havoc | 2007-04-15 23:42:45 +0200 (Sun, 15 Apr 2007) | 3 lines

increased cl_nettimesyncmode 5 tolerance to 25% of time delta to better
accomodate german ADSL

------------------------------------------------------------------------
r7099 | havoc | 2007-04-15 23:36:53 +0200 (Sun, 15 Apr 2007) | 5 lines

changed cl_nettimesyncmode 2 to use tighter tolerances again (1 frame,
not 2)
added cl_nettimesyncmode 5 (new default) which is like 2 but has very
tight tolerances (1/8th of frame delta)

------------------------------------------------------------------------
r7098 | havoc | 2007-04-15 22:52:08 +0200 (Sun, 15 Apr 2007) | 3 lines

sp2 loader no longer errors if an image is missing
(WHY did it do this before??)

------------------------------------------------------------------------
r7097 | divverent | 2007-04-15 22:01:38 +0200 (Sun, 15 Apr 2007) | 3 lines

New console commands sv_cmd, menu_cmd, cl_cmd, that call GameCommand(string s) in the server, menu, client program with the remainder of the command line as argument. Extension: DP_QC_CMD for all of them, DP_SV_CMD for sv_cmd.


------------------------------------------------------------------------
r7096 | divverent | 2007-04-15 11:21:17 +0200 (Sun, 15 Apr 2007) | 2 lines

adds a cvar r_picmipsprites that, when set to 0, makes gl_picmip not affect sprites

------------------------------------------------------------------------
r7095 | divverent | 2007-04-14 22:44:36 +0200 (Sat, 14 Apr 2007) | 2 lines

fix segfault sendcvar for non existing cvars introduced in r6933

------------------------------------------------------------------------
r7094 | havoc | 2007-04-14 20:27:13 +0200 (Sat, 14 Apr 2007) | 3 lines

changed default cl_autodemo_nameformat to put demos in an autodemos/
directory (they clutter the id1 directory too much)

------------------------------------------------------------------------
r7093 | havoc | 2007-04-14 03:11:00 +0200 (Sat, 14 Apr 2007) | 3 lines

removed all commandline checks for the option "-safe" except for the
OpenGL extension checks, this makes -safe actually playable

------------------------------------------------------------------------
r7092 | havoc | 2007-04-14 00:53:33 +0200 (Sat, 14 Apr 2007) | 4 lines

saved a little more memory by not keeping around the basebonepose data
after loading (it can be regenerated by inverting the inverse array
anyway)

------------------------------------------------------------------------
r7091 | havoc | 2007-04-14 00:41:27 +0200 (Sat, 14 Apr 2007) | 3 lines

fix broken allocation code for skeletal models that was allocating too
much memory for basebonepose arrays (thanks to Vic for reporting this)

------------------------------------------------------------------------
r7090 | havoc | 2007-04-14 00:20:03 +0200 (Sat, 14 Apr 2007) | 3 lines

removed cl_nettimesyncmode 5 code, changed default to 1 (5 had no
theoretical advantages over 1)

------------------------------------------------------------------------
r7089 | havoc | 2007-04-14 00:08:32 +0200 (Sat, 14 Apr 2007) | 3 lines

added cl_nettimesyncmode 5 (now the default), this is very similar to
cl_nettimesyncmode 1 but allows up to 1 millisecond fluctuations

------------------------------------------------------------------------
r7088 | havoc | 2007-04-13 17:32:41 +0200 (Fri, 13 Apr 2007) | 5 lines

changed .viewzoom field to scale view frustum slopes rather than fov
angle, this makes zooming more fluid and straightforward, and causes a 1
to 1 correspondence between the sensitivity decrease and the view size
decrease

------------------------------------------------------------------------
r7082 | havoc | 2007-04-12 02:39:30 +0200 (Thu, 12 Apr 2007) | 2 lines

changed descriptions of r_ambient and r_fullbright cvars to no longer say that they don't work in multiplayer (because they do currently)

------------------------------------------------------------------------
r7081 | havoc | 2007-04-12 02:38:14 +0200 (Thu, 12 Apr 2007) | 2 lines

removed some unnecessary code in CL_TimeRefresh_f

------------------------------------------------------------------------
r7080 | havoc | 2007-04-12 02:37:20 +0200 (Thu, 12 Apr 2007) | 2 lines

implemented two more checks for cls.timedemo to bypass snd_blocked

------------------------------------------------------------------------
r7079 | havoc | 2007-04-11 13:52:34 +0200 (Wed, 11 Apr 2007) | 2 lines

added cls.timedemo check in S_PaintAndSubmit to use cl.mtime[0] for sound sync when doing timedemos, this greatly improves the accuracy of benchmarks with respect to sound mixing time

------------------------------------------------------------------------
r7074 | havoc | 2007-04-07 23:29:03 +0200 (Sat, 07 Apr 2007) | 2 lines

patch from div0 to fix nexuiz ctf flag icon code so it works with vid_conwidth values other than 640

------------------------------------------------------------------------
r7073 | havoc | 2007-04-07 22:52:25 +0200 (Sat, 07 Apr 2007) | 2 lines

fixed a third instance of the length(CubeVector) attenuation code bug (passing a single float to a 2D texture fetch)

------------------------------------------------------------------------
r7072 | havoc | 2007-04-07 22:27:31 +0200 (Sat, 07 Apr 2007) | 2 lines

the value of r_textshadow now controls the amount of offset for the shadow in pixels (formerly it was 25% of text size which typically meant 2 pixels)

------------------------------------------------------------------------
r7071 | havoc | 2007-04-07 20:02:45 +0200 (Sat, 07 Apr 2007) | 2 lines

somehow forgot to save this file before committing the RENDER_NOSELFSHADOW patch

------------------------------------------------------------------------
r7070 | havoc | 2007-04-07 14:36:25 +0200 (Sat, 07 Apr 2007) | 3 lines

player model no longer shadows gun model
technical explanation: this was done by adding a RENDER_NOSELFSHADOW flag which is used on view models, this flag prevents any entities using the flag from shadowing themselves or eachother...  then another hack was added to queue the shadowing of the RENDER_EXTERIORMODEL entities in the RENDER_NOSELFSHADOW batch (so it does not shadow other RENDER_NOSELFSHADOW entities), but still have it receive shadows by lighting it in the normal self-shadowing batch...   In more general use the RENDER_NOSELFSHADOW flag could be used to make characters not shadow themselves (like in Doom3), however r_shadow_frontsidecasting 0 is a better approach to that problem (partial self-shadowing characters)

------------------------------------------------------------------------
r7069 | havoc | 2007-04-07 10:09:47 +0200 (Sat, 07 Apr 2007) | 2 lines

added clearstencil parameter to R_Shadow_RenderMode_StencilShadowVolumes

------------------------------------------------------------------------
r7068 | havoc | 2007-04-07 10:07:08 +0200 (Sat, 07 Apr 2007) | 5 lines

added GL_DepthRange function and MATERIALFLAG_SHORTDEPTHRANGE (now used by viewmodels), this prevents viewmodels from poking into walls
changed EF_NODEPTHTEST code to set MATERIALFLAG_SHORTDEPTHRANGE instead of MATERIALFLAG_NODEPTHTEST, this causes proper rendering of opaque models (such as the held item in prydon gate)
this also reenabled stencil shadows on view models but they render as if they are very very small (due to MATERIALFLAG_SHORTDEPTHRANGE)
changed default value of cl_viewmodel_scale from 0.3 to 1, this makes stereo rendering look better (small gun model looks silly when you can actually see that it is small) and makes rtlight cubemaps affect the gun more realistically

------------------------------------------------------------------------
r7065 | havoc | 2007-04-06 14:48:52 +0200 (Fri, 06 Apr 2007) | 2 lines

view models no longer receive stencil shadows (only basic light visibility culling like transparent surfaces receive), this makes the gun much more visible and protects it the player's own shadow, this change may is a major one and may get further changes (such as better culling perhaps)

------------------------------------------------------------------------
r7064 | havoc | 2007-04-06 14:39:53 +0200 (Fri, 06 Apr 2007) | 2 lines

fix one more case of EF_NODEPTHTEST not being checked

------------------------------------------------------------------------
r7063 | havoc | 2007-04-06 14:31:00 +0200 (Fri, 06 Apr 2007) | 3 lines

removed MATERIALFLAG_TRANSPARENT
added MATERIALFLAGMASK_DEPTHSORTED - this solved a lack of sorting on EF_NODEPTHTEST entities

------------------------------------------------------------------------
r7062 | havoc | 2007-04-06 13:29:03 +0200 (Fri, 06 Apr 2007) | 3 lines

check vid_activewindow in several spammy prints that occur when the client is running slower than the server
changed cl.time warnings from developer 10 to developer 100 and check vid_activewindow

------------------------------------------------------------------------
r7061 | havoc | 2007-04-06 12:29:06 +0200 (Fri, 06 Apr 2007) | 2 lines

added cl_nettimesyncmode 4, this is not the default, just another option to experiment with

------------------------------------------------------------------------
r7060 | havoc | 2007-04-06 11:48:52 +0200 (Fri, 06 Apr 2007) | 6 lines

made the following changes to CL_NetworkTimeReceived:
changed cl_nettimesyncmode 2 to be more tolerant of out of bounds values, this fixes occasional choppyness
now prints warnings if time is out of bounds if developer is 10 or higher
simplified some code
disabled time interpolation code during signon process, this should give better starting values for cl.time

------------------------------------------------------------------------
r7059 | havoc | 2007-04-06 11:42:43 +0200 (Fri, 06 Apr 2007) | 2 lines

changed "new engine string" prints to also include the current text stored in the string, to aid in understanding what engine strings are being used

------------------------------------------------------------------------
r7058 | havoc | 2007-04-06 11:41:58 +0200 (Fri, 06 Apr 2007) | 2 lines

changed "sample frames missing" and similar warnings to require developer 1000 or higher

------------------------------------------------------------------------
r7057 | havoc | 2007-04-06 07:25:18 +0200 (Fri, 06 Apr 2007) | 4 lines

fixed a bug where the loading plaque caused front buffer rendering of all later stereo views (glDrawBuffer was not being set in stereo rendering, except when vid_stereobuffer was used)
swapped left/right views so that positive values for r_stereo_separation produce normal stereo, not cross-eyed
added r_stereo_angle cvar based on a patch from Thomas Spriggs, this allows you to make the views look different directions, in addition to the existing offset capability

------------------------------------------------------------------------
r7056 | havoc | 2007-04-06 07:22:01 +0200 (Fri, 06 Apr 2007) | 2 lines

cl_bobmodel_side and cl_bobmodel_up cvars now are scaled by cl_viewmodel_scale so that cl_viewmodel_scale can be changed without affecting the amount of viewmodel movement on the screen

------------------------------------------------------------------------
r7055 | havoc | 2007-04-05 12:31:42 +0200 (Thu, 05 Apr 2007) | 2 lines

fix bug with cl_nolerp 1 that caused playdemo to play back at timedemo speeds

------------------------------------------------------------------------
r7054 | havoc | 2007-04-05 10:47:17 +0200 (Thu, 05 Apr 2007) | 2 lines

fixed bug where dpmod weapons fired twice as often as intended (frametime is now 0 in calls to PlayerPreThink/PlayerPostthink on input moves)

------------------------------------------------------------------------
r7053 | havoc | 2007-04-05 10:25:54 +0200 (Thu, 05 Apr 2007) | 2 lines

fix another prediction issue (physics code was being called per input frame and per server frame)

------------------------------------------------------------------------
r7052 | havoc | 2007-04-05 10:21:19 +0200 (Thu, 05 Apr 2007) | 2 lines

reworked predicted player physics to call PlayerPreThink before the move and PlayerPostThink after the move, in addition to calling those surrounding the regular physics code, hopefully this doesn't break anything, it fixes the jumping bug introduced in the recent changes

------------------------------------------------------------------------
r7051 | havoc | 2007-04-05 09:50:22 +0200 (Thu, 05 Apr 2007) | 2 lines

changed sv.time to realtime in name change time limit code

------------------------------------------------------------------------
r7050 | havoc | 2007-04-05 09:14:09 +0200 (Thu, 05 Apr 2007) | 2 lines

eliminated most calls to Sys_DoubleTime (using realtime instead, or in one case a different sort of check)

------------------------------------------------------------------------
r7049 | havoc | 2007-04-05 09:02:29 +0200 (Thu, 05 Apr 2007) | 2 lines

fix severe timing issues regarding the global variable realtime which governs many things in the engine

------------------------------------------------------------------------
r7048 | havoc | 2007-04-05 07:09:59 +0200 (Thu, 05 Apr 2007) | 2 lines

fix bug with players not moving during the input timeout after prediction is intentionally disabled

------------------------------------------------------------------------
r7047 | havoc | 2007-04-04 21:06:54 +0200 (Wed, 04 Apr 2007) | 2 lines

fixed compile error in GLSL shader with the new textured attenuation code

------------------------------------------------------------------------
r7046 | havoc | 2007-04-04 17:22:02 +0200 (Wed, 04 Apr 2007) | 2 lines

implemented vbo rendering of map, models, and compiled shadow volumes

------------------------------------------------------------------------
r7045 | havoc | 2007-04-04 17:21:34 +0200 (Wed, 04 Apr 2007) | 2 lines

added gl_vbo cvar to allow disabling of vbo rendering (and vbo creation while loading models) for immediate comparison of framerates with/without vbo

------------------------------------------------------------------------
r7044 | havoc | 2007-04-04 13:54:05 +0200 (Wed, 04 Apr 2007) | 2 lines

now creates EBOs and VBOs containing static model geometry, map geometry, and compiled shadows

------------------------------------------------------------------------
r7043 | havoc | 2007-04-04 12:18:14 +0200 (Wed, 04 Apr 2007) | 2 lines

added bufferobject and bufferoffset parameters to all R_Mesh_*Pointer functions and R_Mesh_Draw

------------------------------------------------------------------------
r7042 | havoc | 2007-04-04 10:32:31 +0200 (Wed, 04 Apr 2007) | 2 lines

the beginnings of VBO support in the rendering backend

------------------------------------------------------------------------
r7041 | havoc | 2007-04-04 09:16:15 +0200 (Wed, 04 Apr 2007) | 2 lines

*** empty log message ***

------------------------------------------------------------------------
r7040 | havoc | 2007-04-04 06:28:28 +0200 (Wed, 04 Apr 2007) | 2 lines

corrected showturtle cvar description (it said it was unused, it actually does work)

------------------------------------------------------------------------
r7039 | havoc | 2007-04-04 06:27:17 +0200 (Wed, 04 Apr 2007) | 2 lines

fixed two timing flaws where cl.realframetime was used instead of (cl.time - cl.oldtime), one being centerprint fade time, and the other being ambient sky/water noise fading

------------------------------------------------------------------------
r7038 | havoc | 2007-04-03 06:09:11 +0200 (Tue, 03 Apr 2007) | 2 lines

fix bug in the previous movement patch where moves were not applied to the QC fields when not MOVETYPE_WALK

------------------------------------------------------------------------
r7037 | havoc | 2007-04-03 04:44:30 +0200 (Tue, 03 Apr 2007) | 2 lines

changed PlayerPrethink/think/PlayerPostThink to occur regardless of movement prediction, so they are guarenteed to run every server frame like in quake/quakeworld, only the movement itself is done elsewhere and only for MOVETYPE_WALK cases, this means that animations keep proper sync regardless of prediction timing

------------------------------------------------------------------------
r7036 | havoc | 2007-04-03 04:40:06 +0200 (Tue, 03 Apr 2007) | 2 lines

added detection of VBO extension

------------------------------------------------------------------------
r7035 | havoc | 2007-03-31 11:56:59 +0200 (Sat, 31 Mar 2007) | 2 lines

patch from div0 to fix the fixangle logic (my fix apparently didn't work properly either)

------------------------------------------------------------------------
r7034 | havoc | 2007-03-31 11:42:34 +0200 (Sat, 31 Mar 2007) | 2 lines

patch from div0 that improves mac keyboard support in the AGL client, this includes a copy of SDL_mackeys.h (as vid_agl_mackeys.h), it should be kept up to date as appropriate

------------------------------------------------------------------------
r7032 | havoc | 2007-03-30 22:42:13 +0200 (Fri, 30 Mar 2007) | 3 lines

added back bullet impact sparks due to complaints
made grenade smoke trails only last 2/3rd as long (this matches the quake grenade trail vs the quake rocket trail length)

------------------------------------------------------------------------
r7031 | havoc | 2007-03-30 21:59:40 +0200 (Fri, 30 Mar 2007) | 2 lines

slight improvement to the new bullet smoke

------------------------------------------------------------------------
r7030 | havoc | 2007-03-30 10:48:11 +0200 (Fri, 30 Mar 2007) | 2 lines

make timedemo and -benchmark use srand(0) to get more predictable results

------------------------------------------------------------------------
r7029 | havoc | 2007-03-30 10:47:12 +0200 (Fri, 30 Mar 2007) | 2 lines

disabled cl_beams_instantaimhack by default, and disabled it in every Effects: preset in the options menu

------------------------------------------------------------------------
r7028 | havoc | 2007-03-30 10:31:10 +0200 (Fri, 30 Mar 2007) | 2 lines

removed restrictions on r_fullbright and r_ambient cvars (they can now be used in multiplayer)

------------------------------------------------------------------------
r7027 | havoc | 2007-03-30 10:26:37 +0200 (Fri, 30 Mar 2007) | 2 lines

fix the corona view distance culling checks, had the values swapped between rtlight/dlight cases

------------------------------------------------------------------------
r7026 | havoc | 2007-03-30 10:25:12 +0200 (Fri, 30 Mar 2007) | 4 lines

changed cl_particles_quake mode to use size 1.5 for particles rather than size 1.0, this makes them about as visible as in glquake
changed explosion sparks to not be affected by gravity and some other differences in how they are spawned
removed sparks on bullet/nail impact effects, made smoke bigger and a bit darker so it's not just small white puffs, it now looks rather nice, and more true to the original quake gunshot/spike/superspike effect

------------------------------------------------------------------------
r7025 | havoc | 2007-03-30 05:33:29 +0200 (Fri, 30 Mar 2007) | 2 lines

fix bug that caused blood stainmaps to not appear when decals were off

------------------------------------------------------------------------
r7024 | havoc | 2007-03-30 05:28:56 +0200 (Fri, 30 Mar 2007) | 3 lines

cleaned up R_DrawCoronas code to be more readable/maintainable
modified R_DrawCoronas to use a spherical distance check on coronas rather than a view-direction dependent one, and changed the distance checks, this should get rid of the 'seeing your own muzzleflash corona when looking down' issue

------------------------------------------------------------------------
r7023 | havoc | 2007-03-30 05:26:51 +0200 (Fri, 30 Mar 2007) | 2 lines

fix bug which caused CL_Move to not see any network bmodels (doors, etc), which caused particles, blood, and coronas to ignore doors and such

------------------------------------------------------------------------
r7022 | havoc | 2007-03-30 03:41:00 +0200 (Fri, 30 Mar 2007) | 2 lines

fixed specularscale calculation

------------------------------------------------------------------------
r7021 | havoc | 2007-03-29 22:23:20 +0200 (Thu, 29 Mar 2007) | 2 lines

fix warning

------------------------------------------------------------------------
r7020 | havoc | 2007-03-29 11:18:03 +0200 (Thu, 29 Mar 2007) | 4 lines

changed Sys_Sleep functions to take microseconds instead of milliseconds (this may mildly improve sleep accuracy on Linux dedicated servers)
modified the host main loop to check for server packets each iteration of the loop rather than at the server framerate (this doesn't accomplish much yet but has potential)
added sv_checkforpacketsduringsleep cvar to enable use of select() instead of Sys_Sleep()

------------------------------------------------------------------------
r7018 | havoc | 2007-03-29 03:39:52 +0200 (Thu, 29 Mar 2007) | 2 lines

added DP_QC_TOKENIZEBYSEPARATOR extension

------------------------------------------------------------------------
r7017 | havoc | 2007-03-29 02:39:50 +0200 (Thu, 29 Mar 2007) | 3 lines

added r_shadow_usenormalmap cvar which allows you to disable directional shading on rtlights, looking a bit more like glquake lights, this also renders somewhat faster so it may be of use as a performance tweak for some cards
added an optimized ambient-without-diffuse path in the GLSL shader to help r_shadow_usenormalmap 0 performance

------------------------------------------------------------------------
r7016 | havoc | 2007-03-29 02:33:16 +0200 (Thu, 29 Mar 2007) | 2 lines

added NetConn_SleepMicroseconds function, and LHNET_SleepUntilPacket_Microseconds function, this uses select() to wait for a specified amount of time or until a packet is received

------------------------------------------------------------------------
r7015 | havoc | 2007-03-29 02:31:57 +0200 (Thu, 29 Mar 2007) | 2 lines

cl_bob* cvars are now saved

------------------------------------------------------------------------
r7014 | havoc | 2007-03-28 02:42:28 +0200 (Wed, 28 Mar 2007) | 2 lines

stop demo playback on connect command but do not disconnect

------------------------------------------------------------------------
r7013 | havoc | 2007-03-27 21:48:09 +0200 (Tue, 27 Mar 2007) | 4 lines

added .float disableclientprediction field for qc to use to disable prediction intentionally if it so wishes
added .movetype check to disable prediction whenever movetype is not MOVETYPE_WALK, this fixes unwanted prediction issues in all known cases
moved prediction disabling code from SV_ReadClientMove to SV_ExecuteClientMoves as a minor cleanup

------------------------------------------------------------------------
r7012 | havoc | 2007-03-27 21:43:56 +0200 (Tue, 27 Mar 2007) | 2 lines

remove unused variable

------------------------------------------------------------------------
r7011 | havoc | 2007-03-27 20:36:21 +0200 (Tue, 27 Mar 2007) | 2 lines

made scr_printspeed 0 also disable slow printing

------------------------------------------------------------------------
r7010 | havoc | 2007-03-27 20:30:44 +0200 (Tue, 27 Mar 2007) | 2 lines

changed default value of scr_printspeed from 8 to 1000000 to disable the slow printing entirely, as it is more annoying than useful

------------------------------------------------------------------------
r7009 | havoc | 2007-03-27 20:28:23 +0200 (Tue, 27 Mar 2007) | 2 lines

patch from div0 to make svc_finale text show up immediately if scr_printspeed is a very high value

------------------------------------------------------------------------
r7008 | havoc | 2007-03-26 06:45:19 +0200 (Mon, 26 Mar 2007) | 2 lines

remove unnecessary calculations of absmin/absmax in csqc builtins, they're not used by the engine and are updated by setorigin/setsize

------------------------------------------------------------------------
r7007 | havoc | 2007-03-26 06:39:47 +0200 (Mon, 26 Mar 2007) | 2 lines

slight optimization to CSQC_AddRenderEdict - don't fetch renderflags twice

------------------------------------------------------------------------
r7006 | havoc | 2007-03-26 04:40:26 +0200 (Mon, 26 Mar 2007) | 2 lines

fix bug in the last commit

------------------------------------------------------------------------
r7005 | havoc | 2007-03-26 04:04:42 +0200 (Mon, 26 Mar 2007) | 2 lines

patch from div0 to fix issues with libcurl on old nexuiz servers

------------------------------------------------------------------------
r7004 | havoc | 2007-03-25 01:49:42 +0100 (Sun, 25 Mar 2007) | 2 lines

eliminated dependency on quakedef.h, this file now compile standalone without any problems

------------------------------------------------------------------------
r7003 | havoc | 2007-03-25 00:04:58 +0100 (Sun, 25 Mar 2007) | 2 lines

changed default value of cl_netinputpacketlosstolerance from 4 to 1, matching Quake3, as it's actually quite rare for more than every other packet to be lost

------------------------------------------------------------------------
r7002 | havoc | 2007-03-24 18:55:42 +0100 (Sat, 24 Mar 2007) | 2 lines

as requested by div0, sprint to world now behaves like print

------------------------------------------------------------------------
r7001 | havoc | 2007-03-24 18:46:19 +0100 (Sat, 24 Mar 2007) | 2 lines

moved clearing of self.fixangle to SV_Physics_ClientEntity so that it is only cleared each time PlayerPreThink is called, fixing bugs with irregular move times causing spectating smoothing to fail

------------------------------------------------------------------------
r7000 | havoc | 2007-03-19 18:53:06 +0100 (Mon, 19 Mar 2007) | 2 lines

added glFinish() call to loading screen (which uses front buffer rendering) to make it work on Windows Vista

------------------------------------------------------------------------
r6999 | havoc | 2007-03-19 15:10:19 +0100 (Mon, 19 Mar 2007) | 2 lines

added leaf culling using the shadow-caster frustum, this got a very small gain

------------------------------------------------------------------------
r6998 | havoc | 2007-03-18 23:44:59 +0100 (Sun, 18 Mar 2007) | 2 lines

changed bestweapon command to match the one in proquake - taking each weapon identifier as a separate parameter, rather than one string of them, I don't know why the person asking for bestweapon support gave me an example of a single parameter as no other engine seems to do it that way

------------------------------------------------------------------------
r6997 | havoc | 2007-03-18 18:52:32 +0100 (Sun, 18 Mar 2007) | 2 lines

added iplog support (iplog_list command, iplog_name cvar, and automatic gathering of ip addresses from status commands)

------------------------------------------------------------------------
r6996 | havoc | 2007-03-18 18:04:28 +0100 (Sun, 18 Mar 2007) | 2 lines

added cl_movement_minping cvar, default 50, this shuts off prediction when your ping time is below 50ms, such as in local games or lan games

------------------------------------------------------------------------
r6995 | havoc | 2007-03-17 14:27:02 +0100 (Sat, 17 Mar 2007) | 2 lines

changed some prints to dprints

------------------------------------------------------------------------
r6994 | havoc | 2007-03-17 14:19:00 +0100 (Sat, 17 Mar 2007) | 2 lines

reenabled vid_grabkeyboard by default until the focus issue is figured out

------------------------------------------------------------------------
r6993 | havoc | 2007-03-17 14:08:52 +0100 (Sat, 17 Mar 2007) | 2 lines

play a different sound (sound/misc/talk2.wav) for team chat messages (only if the file exists of course), to accomplish this the team chat messages now have () around the player name, which is compatible with other engines with this feature

------------------------------------------------------------------------
r6992 | havoc | 2007-03-16 13:35:53 +0100 (Fri, 16 Mar 2007) | 2 lines

cl_autodemo and cl_autodemo_nameformat are now saved cvars

------------------------------------------------------------------------
r6991 | havoc | 2007-03-16 10:37:04 +0100 (Fri, 16 Mar 2007) | 2 lines

fixed cl_autodemo

------------------------------------------------------------------------
r6990 | havoc | 2007-03-16 10:34:24 +0100 (Fri, 16 Mar 2007) | 3 lines

fixed bug where every name/color/playermodel/playerskin/etc property change was sent twice
removed some autodemo code

------------------------------------------------------------------------
r6989 | havoc | 2007-03-16 10:29:11 +0100 (Fri, 16 Mar 2007) | 2 lines

corrected name of gl_ext_separatestencil server (it was missing the second s)

------------------------------------------------------------------------
r6988 | havoc | 2007-03-16 04:13:22 +0100 (Fri, 16 Mar 2007) | 2 lines

reenabled keyboard grab when fullscreen - this is just a temporary solution, the window should be focused but isn't

------------------------------------------------------------------------
r6987 | havoc | 2007-03-16 01:36:27 +0100 (Fri, 16 Mar 2007) | 2 lines

fix a double typo (thanks Willis)

------------------------------------------------------------------------
r6985 | havoc | 2007-03-15 15:29:41 +0100 (Thu, 15 Mar 2007) | 2 lines

fix an error

------------------------------------------------------------------------
r6984 | havoc | 2007-03-15 15:06:03 +0100 (Thu, 15 Mar 2007) | 3 lines

disabled cl_movement prediction when cls.servermovesequence is 0 (either a protocol that does not support move synchronization, or prediction is disabled)
removed cl_movement_latency cvar as it no longer serves any purpose with the removal of support for prediction on unsynchronized move protocols

------------------------------------------------------------------------
r6983 | havoc | 2007-03-15 14:54:37 +0100 (Thu, 15 Mar 2007) | 2 lines

rewrote stringlist stuff, now uses a (dynamically resizing) array of pointers rather than a linked list, and uses a selection sort rather than a bubble sort, this has changed the "maps" command from taking about 7 seconds on my system to about 70ms

------------------------------------------------------------------------
r6982 | havoc | 2007-03-15 13:49:57 +0100 (Thu, 15 Mar 2007) | 2 lines

fix a crash in maps command

------------------------------------------------------------------------
r6981 | havoc | 2007-03-15 13:10:27 +0100 (Thu, 15 Mar 2007) | 2 lines

aligned menu options to not cover the quake logo plaque on the left side

------------------------------------------------------------------------
r6980 | havoc | 2007-03-15 12:34:14 +0100 (Thu, 15 Mar 2007) | 3 lines

main options menu now has only the most frequently used options, and contains several presets for effects and lighting (renamed Graphics Options to Lighting)
main options menu now fits on a 320x240 display

------------------------------------------------------------------------
r6979 | havoc | 2007-03-15 12:32:01 +0100 (Thu, 15 Mar 2007) | 2 lines

updated with new default value of con_closeontoggleconsole

------------------------------------------------------------------------
r6978 | havoc | 2007-03-15 12:23:50 +0100 (Thu, 15 Mar 2007) | 2 lines

reworked quake query code (CCREQ_/CCREP_ handling) to use MSG_Read functions, it was previously using a mixture of these and direct packet parsing, which was not working, this means quake query tools work again

------------------------------------------------------------------------
r6977 | havoc | 2007-03-15 11:34:24 +0100 (Thu, 15 Mar 2007) | 4 lines

separated the code that sends player name and such into CL_SendPlayerInfo
moved call to CL_SendPlayerInfo from signon 2 to signon 1
moved cl_begindownloads from signon 2 to signon 1, this fixes the 'no ambient sounds' bug

------------------------------------------------------------------------
r6976 | havoc | 2007-03-15 11:32:11 +0100 (Thu, 15 Mar 2007) | 2 lines

changed default snd_soundradius from 1000 to 2000, matching proquake (which attempts to match dos quake), this means you can fire a rocket across the outdoor pent area in dm3 and hear the explosion

------------------------------------------------------------------------
r6975 | havoc | 2007-03-15 11:12:52 +0100 (Thu, 15 Mar 2007) | 2 lines

implemented support for fuhquake macros in fuhquake/QIZMO format .loc files, hardcoded the strings for these rather than using cvars (unlike fuhquake) because excess settings is silly

------------------------------------------------------------------------
r6974 | havoc | 2007-03-15 09:34:05 +0100 (Thu, 15 Mar 2007) | 2 lines

made cl_bob 0 also disable cl_bobmodel

------------------------------------------------------------------------
r6973 | havoc | 2007-03-15 09:28:10 +0100 (Thu, 15 Mar 2007) | 2 lines

changed default value of con_closeontoggleconsole due to a never ending stream of complaints about the ~ key not closing the console

------------------------------------------------------------------------
r6972 | havoc | 2007-03-15 09:10:30 +0100 (Thu, 15 Mar 2007) | 2 lines

set pmodel/emodel keys in userinfo for qw servers

------------------------------------------------------------------------
r6971 | havoc | 2007-03-14 11:33:43 +0100 (Wed, 14 Mar 2007) | 2 lines

add apple_multithreadedgl cvar (offloads OpenGL driver to a second thread if possible), off by default (may change to on if I get feedback from testers)

------------------------------------------------------------------------
r6970 | havoc | 2007-03-14 09:48:51 +0100 (Wed, 14 Mar 2007) | 2 lines

added cl_particles_rain and cl_particles_snow cvars to allow disabling of these types of particles, based on a patch from esteel

------------------------------------------------------------------------
r6969 | havoc | 2007-03-14 09:48:00 +0100 (Wed, 14 Mar 2007) | 2 lines

added a missing return statement in the 'any-dimension' bspline example code (which is in a comment so this has no effect on code)

------------------------------------------------------------------------
r6968 | havoc | 2007-03-14 04:09:29 +0100 (Wed, 14 Mar 2007) | 2 lines

fix bug where transparent models used an out of date material (generated earlier in the same frame), which caused problems when multiple instances of the same model exist in the same frame and one or more of them are transparent

------------------------------------------------------------------------
r6967 | havoc | 2007-03-14 03:08:28 +0100 (Wed, 14 Mar 2007) | 3 lines

loc file parsing now supports whitespace following commas (I did not previously have such a test file)
now rejects malformed proquake-format loc file lines that do not have a quoted string directly after the 6 numbers

------------------------------------------------------------------------
r6966 | havoc | 2007-03-12 13:30:57 +0100 (Mon, 12 Mar 2007) | 2 lines

removed duplicate entries in the cvar list

------------------------------------------------------------------------
r6965 | havoc | 2007-03-12 13:28:00 +0100 (Mon, 12 Mar 2007) | 3 lines

removed "Future supported games" section as it really serves no purpose
sorted cvar list

------------------------------------------------------------------------
r6964 | havoc | 2007-03-12 12:39:11 +0100 (Mon, 12 Mar 2007) | 2 lines

442

------------------------------------------------------------------------
r6963 | havoc | 2007-03-12 12:29:40 +0100 (Mon, 12 Mar 2007) | 2 lines

446

------------------------------------------------------------------------
r6962 | havoc | 2007-03-12 12:29:20 +0100 (Mon, 12 Mar 2007) | 2 lines

updated readme

------------------------------------------------------------------------
r6961 | havoc | 2007-03-12 07:21:21 +0100 (Mon, 12 Mar 2007) | 2 lines

multiline cvar_t descriptions cause problems when building the readme

------------------------------------------------------------------------
r6960 | havoc | 2007-03-12 06:58:29 +0100 (Mon, 12 Mar 2007) | 2 lines

removed trailing comments on cvar declarations and Cmd_AddCommand calls

------------------------------------------------------------------------
r6959 | havoc | 2007-03-12 06:44:45 +0100 (Mon, 12 Mar 2007) | 2 lines

corrected some comments

------------------------------------------------------------------------
r6958 | havoc | 2007-03-12 06:31:02 +0100 (Mon, 12 Mar 2007) | 3 lines

removed -demolooponly commandline option as it did precisely the same thing as -demo, and I don't feel like implementing the feature its name implies
corrected a mention of host_maxfps to cl_maxfps in host_framerate cvar description

------------------------------------------------------------------------
r6957 | havoc | 2007-03-12 06:26:59 +0100 (Mon, 12 Mar 2007) | 2 lines

added vid_grabkeyboard cvar which defaults to 0, this means that the glx client no longer locks out window manager hotkeys (such as volume control and music player control keys, as well as alt-tab)

------------------------------------------------------------------------
r6956 | havoc | 2007-03-12 05:18:32 +0100 (Mon, 12 Mar 2007) | 2 lines

implemented proper handling of .frame2/.lerpfrac/.frame1time/.frame2time fields in csqc entities

------------------------------------------------------------------------
r6955 | havoc | 2007-03-12 03:33:27 +0100 (Mon, 12 Mar 2007) | 2 lines

added support for locs/something.loc naming in loc file loading code, for proquake filename compatibility

------------------------------------------------------------------------
r6954 | havoc | 2007-03-12 03:28:15 +0100 (Mon, 12 Mar 2007) | 2 lines

disable interpolation of predicted movement locations when a teleport occurred (just like unpredicted movement is not interpolated in this case)

------------------------------------------------------------------------
r6953 | havoc | 2007-03-12 00:56:44 +0100 (Mon, 12 Mar 2007) | 2 lines

don't abort a download if a level change occurs during the download, instead just wait for it to finish before signing in to the new level

------------------------------------------------------------------------
r6952 | havoc | 2007-03-12 00:54:14 +0100 (Mon, 12 Mar 2007) | 2 lines

make gamedir command work on dedicated servers

------------------------------------------------------------------------
r6951 | havoc | 2007-03-12 00:53:31 +0100 (Mon, 12 Mar 2007) | 2 lines

increased minimum developer cvar level for several spammy messages (new engine string, sample frames missing) from 100 to 200, to make 100 more usable

------------------------------------------------------------------------
r6950 | havoc | 2007-03-11 08:41:47 +0100 (Sun, 11 Mar 2007) | 3 lines

implemented .loc file support, including some editing (add command, and removenearest command) and viewing capability (r_speeds now shows the current location name, and locs_show 1 displays the actual boxes/points as translucent boxes)
implemented proquake message macros (%l, %d, %h, %a, etc), can be disabled by locs_enable 0

------------------------------------------------------------------------
r6949 | havoc | 2007-03-11 04:34:50 +0100 (Sun, 11 Mar 2007) | 3 lines

changed brightness of unlit q1bsp maps from 2x white to 1x white (so textures show as their true colors rather than twice as bright)
fixed bug that made models black in unlit q1bsp maps

------------------------------------------------------------------------
r6948 | havoc | 2007-03-09 11:41:10 +0100 (Fri, 09 Mar 2007) | 2 lines

fix incorrect parameter count check on setspawnparms, this was causing coop servers to suddenly quit when someone respawned

------------------------------------------------------------------------
r6947 | havoc | 2007-03-09 03:39:07 +0100 (Fri, 09 Mar 2007) | 2 lines

removed master 12.166.196.192 (run by Venim) because it hasn't been responding for a long time

------------------------------------------------------------------------
r6946 | havoc | 2007-03-09 01:13:19 +0100 (Fri, 09 Mar 2007) | 2 lines

added cl_dlights_decayradius and cl_dlights_decaybrightness cvars, both default on, this brings back the quake-style radius decay, and keeps the more recently added brightness decay, benchmarks suffered when radius decay was removed, so its return should restore any losses associated with that

------------------------------------------------------------------------
r6945 | havoc | 2007-03-09 00:50:28 +0100 (Fri, 09 Mar 2007) | 2 lines

implemented shadow caster culling by creating a frustum plane set that includes the light origin, any object that is not within this frustum (which encloses the screen and a triangular-shaped volume extending to the light origin) can not possibly cast a shadow onto the visible geometry, this reduces cpu work in a few cases (off-screen explosion with several entities further off-screen)

------------------------------------------------------------------------
r6944 | havoc | 2007-03-09 00:39:14 +0100 (Fri, 09 Mar 2007) | 2 lines

fixed bug in portal culling code that allowed a leaf to be revisited multiple times, causing it to be counted multiple times, and wasting a small amount of time marking surfaces redundantly

------------------------------------------------------------------------
r6943 | havoc | 2007-03-09 00:36:23 +0100 (Fri, 09 Mar 2007) | 2 lines

reworked prediction code to work better when riding lifts

------------------------------------------------------------------------
r6942 | havoc | 2007-03-09 00:33:57 +0100 (Fri, 09 Mar 2007) | 3 lines

refactored csqc entity sending code so that it properly obeys msg->maxsize, undoing writes that could not fit
added comment about how csqc entity sending code needs some changes to avoid packet loss problems

------------------------------------------------------------------------
r6941 | havoc | 2007-03-09 00:32:45 +0100 (Fri, 09 Mar 2007) | 2 lines

added a few more Vector4 macros

------------------------------------------------------------------------
r6940 | havoc | 2007-03-03 23:06:57 +0100 (Sat, 03 Mar 2007) | 2 lines

changed entity networking prioritization code to use the center of the model rather than the origin, this fixes prioritization of doors and lifts which typically have their origin near '0 0 0' rather than inside the entity box

------------------------------------------------------------------------
r6939 | havoc | 2007-03-03 22:59:03 +0100 (Sat, 03 Mar 2007) | 2 lines

fix weapon jitters when walking up ramps, and prediction failures when doing rampjumps, unfortunately this also ends up predicting quake2-style double jumps (which do not occur on the server)

------------------------------------------------------------------------
r6938 | havoc | 2007-03-03 18:47:15 +0100 (Sat, 03 Mar 2007) | 2 lines

patch from div0 fixing his previous patch that he told me had prediction visibility tests but actually lacked it

------------------------------------------------------------------------
r6937 | havoc | 2007-03-03 02:49:43 +0100 (Sat, 03 Mar 2007) | 2 lines

quick hack to get rid of twitchy onground state in prediction when running up ramps, this really needs a better fix sometime

------------------------------------------------------------------------
r6936 | havoc | 2007-03-03 02:37:22 +0100 (Sat, 03 Mar 2007) | 2 lines

fixed bug that was causing prediction to fail periodically in singleplayer games, especially with cl_maxfps 125 (negative packet times were causing sv_clmovement_minping 0 tests to pass occasionally, disabling prediction, and causing a major stall in input handling)

------------------------------------------------------------------------
r6935 | havoc | 2007-03-03 01:57:01 +0100 (Sat, 03 Mar 2007) | 2 lines

server now executes predicted moves of more than 50ms as two separate moves like QWSV does (the client prediction expects this)

------------------------------------------------------------------------
r6934 | havoc | 2007-03-03 01:51:48 +0100 (Sat, 03 Mar 2007) | 3 lines

minor cleanup of CL_SendMove comments regarding packet timing
changed predicted move sending code to not care about the value of cls.signon

------------------------------------------------------------------------
r6933 | havoc | 2007-03-02 23:37:36 +0100 (Fri, 02 Mar 2007) | 2 lines

changed sendcvar command to send a reply (with no value parameter) if the cvar does not exist

------------------------------------------------------------------------
r6932 | havoc | 2007-03-02 23:23:08 +0100 (Fri, 02 Mar 2007) | 2 lines

reworked cvar checks in VID_UpdateGamma to simply set gamma_forcenextframe if they have changed, this is somewhat in preparation for eventual use of cvar callbacks

------------------------------------------------------------------------
r6931 | havoc | 2007-03-02 16:33:59 +0100 (Fri, 02 Mar 2007) | 2 lines

less hacky solution to resetting movesequence on a level change

------------------------------------------------------------------------
r6930 | havoc | 2007-03-02 14:05:39 +0100 (Fri, 02 Mar 2007) | 2 lines

fix really stupid bug introduced in sv_user.c revision 1.83 (sv_waterfriction was being used, even if it's -1 which means use sv_friction instead), now properly uses sv_friction if sv_waterfriction < 0

------------------------------------------------------------------------
r6929 | havoc | 2007-03-02 00:11:26 +0100 (Fri, 02 Mar 2007) | 2 lines

fixed problems with playing on QW server caused by the use of _cl_name and similar config variables

------------------------------------------------------------------------
r6928 | havoc | 2007-03-01 22:36:55 +0100 (Thu, 01 Mar 2007) | 2 lines

fix bug where only the first portal to see a surface was able to mark triangles as worth of receiving light

------------------------------------------------------------------------
r6927 | havoc | 2007-03-01 21:07:20 +0100 (Thu, 01 Mar 2007) | 3 lines

implemented r_shadow_culltriangles cvar (on by default), this improves lighting performance by reducing the amount of geometry to render, it does not add any additional cpu w
ork because similar forms of culling were already used on shadow casting triangles (which are now replaced by this), this just applies the same already computed culling to the lighting as well as the shadowing

------------------------------------------------------------------------
r6926 | havoc | 2007-03-01 19:49:26 +0100 (Thu, 01 Mar 2007) | 2 lines

fix bug that was causing r_editlights light indicators to not render

------------------------------------------------------------------------
r6925 | havoc | 2007-02-28 17:49:54 +0100 (Wed, 28 Feb 2007) | 2 lines

remove stray \n characters in Cmd_AddCommand calls

------------------------------------------------------------------------
r6924 | havoc | 2007-02-28 12:08:30 +0100 (Wed, 28 Feb 2007) | 5 lines

eliminated RENDER_NOCULLFACE (now uses MATERIALFLAG_NOCULLFACE on a texture)
eliminated RENDER_TRANSPARENT (it was only used by the client code briefly, it did not need to be stored, it only turned off RENDER_SHADOW)
added TriangleOverlapsBox macro (and changed several pieces of code to use it)
changed some code to use the BoxInsideBox macro

------------------------------------------------------------------------
r6923 | havoc | 2007-02-28 10:50:36 +0100 (Wed, 28 Feb 2007) | 2 lines

improved detection of q3 terrain blend shaders to reduce chances of a misidentification

------------------------------------------------------------------------
r6922 | havoc | 2007-02-28 10:35:29 +0100 (Wed, 28 Feb 2007) | 2 lines

remove an unused extern

------------------------------------------------------------------------
r6921 | havoc | 2007-02-28 10:34:34 +0100 (Wed, 28 Feb 2007) | 2 lines

fix a cvar name

------------------------------------------------------------------------
r6920 | havoc | 2007-02-27 22:15:48 +0100 (Tue, 27 Feb 2007) | 2 lines

fix missing { character

------------------------------------------------------------------------
r6919 | havoc | 2007-02-27 20:24:48 +0100 (Tue, 27 Feb 2007) | 2 lines

use CVAR_SAVE not 1 for flags on curl cvars

------------------------------------------------------------------------
r6918 | havoc | 2007-02-24 11:05:38 +0100 (Sat, 24 Feb 2007) | 2 lines

allow 0 parameters in VM_SV_makestatic due to a bug in id1 qc

------------------------------------------------------------------------
r6917 | havoc | 2007-02-24 08:12:56 +0100 (Sat, 24 Feb 2007) | 2 lines

added optimized case in R_Q1BSP_GetLightInfo surface culling that skips checking individual triangle bounding boxes if the entire surface is inside the light bounding box (as is often the case)

------------------------------------------------------------------------
r6916 | havoc | 2007-02-24 08:09:31 +0100 (Sat, 24 Feb 2007) | 2 lines

optimized entity culling loop for shadow casting entities that are not directly seen

------------------------------------------------------------------------
r6915 | havoc | 2007-02-23 16:31:06 +0100 (Fri, 23 Feb 2007) | 2 lines

added BoxInsideBox macro

------------------------------------------------------------------------
r6914 | havoc | 2007-02-23 14:49:12 +0100 (Fri, 23 Feb 2007) | 2 lines

minor optimization of R_Q1BSP_RecursiveLightInfo

------------------------------------------------------------------------
r6913 | havoc | 2007-02-23 14:48:42 +0100 (Fri, 23 Feb 2007) | 2 lines

minor optimization

------------------------------------------------------------------------
r6912 | havoc | 2007-02-23 14:09:11 +0100 (Fri, 23 Feb 2007) | 2 lines

forgot to re-sort the todo

------------------------------------------------------------------------
r6911 | havoc | 2007-02-23 14:07:36 +0100 (Fri, 23 Feb 2007) | 4 lines

audited R_Mesh_Matrix calls and RSurf_ActiveEntity calls and moved them to more appropriate locations in some cases
split R_DrawSurfaces into R_DrawWorldSurfaces and R_DrawModelSurfaces to make profile reports more useful
split RSurf_ActiveEntity into RSurf_ActiveWorldEntity and RSurf_ActiveModelEntity to make profile reports more useful, and very slightly improve performance

------------------------------------------------------------------------
r6910 | havoc | 2007-02-23 13:53:07 +0100 (Fri, 23 Feb 2007) | 2 lines

remove ; that was causing crashes/breakage

------------------------------------------------------------------------
r6909 | havoc | 2007-02-23 13:47:02 +0100 (Fri, 23 Feb 2007) | 2 lines

remove unused variables

------------------------------------------------------------------------
r6908 | havoc | 2007-02-23 13:45:35 +0100 (Fri, 23 Feb 2007) | 2 lines

fixed bug that caused the wrong texture to be used on rtlight lighting when two or more textures were involved in a single batch

------------------------------------------------------------------------
r6907 | havoc | 2007-02-23 13:05:14 +0100 (Fri, 23 Feb 2007) | 2 lines

small cleanup of R_DrawSurfaces (separated r_showcollisionbrushes and r_showtris/r_shownormals code into functions)

------------------------------------------------------------------------
r6906 | havoc | 2007-02-23 12:43:03 +0100 (Fri, 23 Feb 2007) | 2 lines

split model_brushq3_t num_lightmaps field into num_originallightmaps (for lightmapindex checking) and num_mergedlightmaps (for loops), this fixes lightmap indexing errors on deluxemapped maps

------------------------------------------------------------------------
r6905 | havoc | 2007-02-23 11:46:00 +0100 (Fri, 23 Feb 2007) | 2 lines

patch from div0 that makes curl downloads stay connected to the game server while downloading (like the direct downloads)

------------------------------------------------------------------------
r6904 | havoc | 2007-02-23 10:36:47 +0100 (Fri, 23 Feb 2007) | 2 lines

patch from div0 that adds clientside culling of entities by TraceLineOfSight (like sv_cullentities_trace does), and merges the client and server code for this culling, this also adds traces for predicted player movement on the server to reduce the "items popping up" problem when running into a new room

------------------------------------------------------------------------
r6903 | havoc | 2007-02-23 10:19:36 +0100 (Fri, 23 Feb 2007) | 2 lines

memset arrays before writing skeletal vertices into them (as the code did long ago), this is an 8% improvement in Mod_Alias_GetMesh_Vertices in my benchmarking (7.58 seconds in profile before, 6.95 seconds after)

------------------------------------------------------------------------
r6902 | havoc | 2007-02-23 10:02:48 +0100 (Fri, 23 Feb 2007) | 2 lines

further optimizations to batching code, not much gain if any from these, but it may play nicer with cpu cache

------------------------------------------------------------------------
r6901 | havoc | 2007-02-23 06:12:05 +0100 (Fri, 23 Feb 2007) | 2 lines

check __GNUC__ version before defining printf attribute, only define it on gcc 3 and later

------------------------------------------------------------------------
r6900 | havoc | 2007-02-22 16:22:37 +0100 (Thu, 22 Feb 2007) | 2 lines

changed default mod_q3bsp_lightmapmergepower from 5 (4096x4096) to 4 (2048x2048), this means that the textures won't use more than 16MB each, which is a bit friendlier to 128MB cards than a 64MB texture  (note: this is only the upper limit, if the map does not need this much lightmap space it already picks a smaller size)

------------------------------------------------------------------------
r6899 | havoc | 2007-02-22 16:17:24 +0100 (Thu, 22 Feb 2007) | 2 lines

fix dedicated server crashes caused by new lightmap merging

------------------------------------------------------------------------
r6898 | havoc | 2007-02-22 15:37:43 +0100 (Thu, 22 Feb 2007) | 2 lines

fixed bug that made some models invisible in nexuiz (if they have skin != 0 and skin 0 was never rendered yet on this model, they were using skin 0, which was often uninitialized)

------------------------------------------------------------------------
r6897 | havoc | 2007-02-22 12:55:01 +0100 (Thu, 22 Feb 2007) | 2 lines

disabled collision_enternudge by default again, due to intermittent problems with getting stuck on ramps

------------------------------------------------------------------------
r6896 | havoc | 2007-02-22 12:45:12 +0100 (Thu, 22 Feb 2007) | 2 lines

changed light attenuation equation in the default.glsl shader in the engine

------------------------------------------------------------------------
r6895 | havoc | 2007-02-22 12:30:29 +0100 (Thu, 22 Feb 2007) | 2 lines

added r_shadow_lightradiusscale cvar (similar to r_shadow_lightintensityscale)

------------------------------------------------------------------------
r6894 | havoc | 2007-02-22 12:29:38 +0100 (Thu, 22 Feb 2007) | 2 lines

don't compute tangents or normals on non-deluxemapped world surfaces, or tangents on models if the shader does not use normalmapping

------------------------------------------------------------------------
r6893 | havoc | 2007-02-22 12:25:51 +0100 (Thu, 22 Feb 2007) | 2 lines

really fixed deluxemapping this time

------------------------------------------------------------------------
r6892 | havoc | 2007-02-22 12:19:51 +0100 (Thu, 22 Feb 2007) | 2 lines

fixed deluxemapping detection bug that made it never work

------------------------------------------------------------------------
r6891 | havoc | 2007-02-22 09:45:28 +0100 (Thu, 22 Feb 2007) | 2 lines

now merges all q3bsp lightmap textures into one huge lightmap texture if possible, this doubled benchmark framerates for me

------------------------------------------------------------------------
r6890 | havoc | 2007-02-22 09:44:01 +0100 (Thu, 22 Feb 2007) | 2 lines

added some debugging code to RSurf_DrawBatch_WithLightmapSwitching to print out how many surfaces are rendered in each batch and each subbatch by lightmap (this revealed that q3map2's surface sorting is horrible)

------------------------------------------------------------------------
r6889 | havoc | 2007-02-22 05:42:10 +0100 (Thu, 22 Feb 2007) | 2 lines

split RSurf_DrawBatch_Lightmap function into 4 main functions (previously there were only 3 modes, causing rendering problems) and 2 utility functions, this cleaned up the code somewhat

------------------------------------------------------------------------
r6888 | havoc | 2007-02-22 04:42:25 +0100 (Thu, 22 Feb 2007) | 2 lines

fix a bug in transparent mesh rendering which often caused crashes

------------------------------------------------------------------------
r6887 | havoc | 2007-02-22 02:13:31 +0100 (Thu, 22 Feb 2007) | 2 lines

reorganized surface batching to batch visible surfaces first, and then pass them to a function that breaks the list down by texture, also reorganized batching code to use a forward-search approach rather than state machine approach, this got a small (2%) speed gain in benchmarks

------------------------------------------------------------------------
r6886 | havoc | 2007-02-22 01:39:49 +0100 (Thu, 22 Feb 2007) | 2 lines

some cleanup of GL20 code (removed rsurface_glsl_texture and rsurface_glsl_uselightmaptexture caching, because with the change to not batching by lightmap texture there are no longer redundant batches)

------------------------------------------------------------------------
r6885 | havoc | 2007-02-22 01:34:20 +0100 (Thu, 22 Feb 2007) | 2 lines

merged some surface rendering setup code

------------------------------------------------------------------------
r6884 | havoc | 2007-02-21 12:56:29 +0100 (Wed, 21 Feb 2007) | 2 lines

default gl_lockarrays to 0, I'm not aware of any cards that actually benefit from it

------------------------------------------------------------------------
r6883 | havoc | 2007-02-21 12:55:37 +0100 (Wed, 21 Feb 2007) | 2 lines

modified surface renderer batching to batch all lightmapped surfaces with the same texture together, rather than a separate batch for each lightmap texture, this means that the lightmap switching overhead is lower than before, no apparent improvement in benchmarks though

------------------------------------------------------------------------
r6882 | havoc | 2007-02-21 05:38:56 +0100 (Wed, 21 Feb 2007) | 2 lines

fixed bug that was causing seta commands to usually not save to config.cfg (due to the value being copied to their default when they are created, causing the default matching to prevent them from being saved before)

------------------------------------------------------------------------
r6881 | havoc | 2007-02-21 04:23:13 +0100 (Wed, 21 Feb 2007) | 2 lines

changed collision nudging to behave like quake2/3, properly handling shallow impacts (not allowing them to go any deeper if they are within epsilon)

------------------------------------------------------------------------
r6880 | havoc | 2007-02-20 13:34:38 +0100 (Tue, 20 Feb 2007) | 2 lines

added model->brush.TraceLineOfSight function, this traces the rendering hull and treats leafs with no pvs as solid (meaning it traces the structural rendering hull in q3bsp, ignoring detail brushes and patches), this function is now used by sv_cullentities_trace for higher performance, and it does not stop at solid transparent surfaces such as the chainlink fences in the nexuiz map toxic.bsp

------------------------------------------------------------------------
r6879 | havoc | 2007-02-20 13:32:03 +0100 (Tue, 20 Feb 2007) | 2 lines

fix some crashes related to particles when csqc is not active

------------------------------------------------------------------------
r6878 | havoc | 2007-02-20 09:07:48 +0100 (Tue, 20 Feb 2007) | 3 lines

added mleaf_t->containscollisionsurfaces variable which indicates if the leafsurfaces array contains any q3 patches to collide against, checking this saves a substantial amount of time on collision detection in q3bsp (as few leafs actually contain patches, but many contain other kinds of surfaces)
added combinedsupercontents variable to mnode_t and mleaf_t, this was intended for collision culling but is not actually used (checks are implemented but commented out, because there was no measurable speed increase, and it could cause inconsistent results for startcontents when tracing objects larger than a point test - since point tests are always about contents there is no such culling performed in that case)

------------------------------------------------------------------------
r6877 | havoc | 2007-02-20 09:04:28 +0100 (Tue, 20 Feb 2007) | 2 lines

added scr_refresh cvar which is similar to r_render but disables the entire render code rather than merely disabling the glDraw calls

------------------------------------------------------------------------
r6876 | havoc | 2007-02-20 04:27:08 +0100 (Tue, 20 Feb 2007) | 2 lines

changed reconnect command description

------------------------------------------------------------------------
r6875 | havoc | 2007-02-20 04:25:24 +0100 (Tue, 20 Feb 2007) | 2 lines

made reconnect command reconnect to the last server you were on, even if it was an nq server (previously this only worked on qw servers)

------------------------------------------------------------------------
r6874 | havoc | 2007-02-20 02:18:22 +0100 (Tue, 20 Feb 2007) | 2 lines

changed Q3SURFACEPARM_ANTIPORTAL to be an unsigned constant

------------------------------------------------------------------------
r6873 | havoc | 2007-02-20 01:25:57 +0100 (Tue, 20 Feb 2007) | 3 lines

added parsing of surfaceparm antiportal
added support of "noshader" (treated the same as nodraw, basically)

------------------------------------------------------------------------
r6872 | havoc | 2007-02-20 00:17:21 +0100 (Tue, 20 Feb 2007) | 2 lines

moved cl.movesequence/cl.servermovesequence to cls. struct, this keeps the movesequence from level to level and fixes level change problems on old servers

------------------------------------------------------------------------
r6871 | havoc | 2007-02-20 00:05:27 +0100 (Tue, 20 Feb 2007) | 2 lines

reenabled network culling of bmodels (optional however), this should improve network performance in some nexuiz levels, and a few quake levels, it means that blood and decals do not interact with bmodels in other rooms however

------------------------------------------------------------------------
r6870 | havoc | 2007-02-19 11:15:11 +0100 (Mon, 19 Feb 2007) | 2 lines

reworked packet sending code a bit more, this is mostly just a cleanup, not a change in logic, except that cl_movement 0 now reports the correct ping time to the server, so local players get ping 0 as they used to

------------------------------------------------------------------------
r6869 | havoc | 2007-02-19 10:08:16 +0100 (Mon, 19 Feb 2007) | 3 lines

fixed stair smoothing code so it no longer jitters when riding lifts
added support for cl_stairsmoothspeed 0 as a means of disabling stair smoothing

------------------------------------------------------------------------
r6868 | havoc | 2007-02-19 08:48:09 +0100 (Mon, 19 Feb 2007) | 3 lines

changed FL_ONGROUND handling for pushers (lifts for example) so you now ride down lifts, rather than repeatedly falling and hitting the lift
cleaned up FL_ONGROUND handling for items riding pushers, so they now only lose their FL_ONGROUND status if the move is blocked

------------------------------------------------------------------------
r6867 | havoc | 2007-02-19 07:21:30 +0100 (Mon, 19 Feb 2007) | 2 lines

changed how CL_PrintEntities_f prints the model name, this seems to fix the garbage characters bug

------------------------------------------------------------------------
r6866 | havoc | 2007-02-19 06:53:32 +0100 (Mon, 19 Feb 2007) | 2 lines

fix broken SOLID_CORPSE collisions

------------------------------------------------------------------------
r6865 | havoc | 2007-02-19 06:53:11 +0100 (Mon, 19 Feb 2007) | 2 lines

fix two 'wrong number of parameters' errors

------------------------------------------------------------------------
r6864 | havoc | 2007-02-19 02:52:37 +0100 (Mon, 19 Feb 2007) | 2 lines

fix an uninitialized variable

------------------------------------------------------------------------
r6863 | havoc | 2007-02-19 02:46:44 +0100 (Mon, 19 Feb 2007) | 2 lines

fixed parmcount check on VM_SV_AddStat from 2 parameters to 3

------------------------------------------------------------------------
r6862 | havoc | 2007-02-19 02:33:38 +0100 (Mon, 19 Feb 2007) | 7 lines

this patch may break things and needs testing
major cleanup of csqc and ssqc builtin tables
minimized differences between csqc and ssqc builtin tables (everything that can be implemented in both is implemented in both)
added VM_SAFEPARMCOUNTRANGE to allow a function to have, for example, 2-4 parameters (where as VM_SAFEPARMCOUNT requires it to be an exact match)
added VM_SAFEPARMCOUNT or VM_SAFEPARMCOUNTRANGE to ALL builtins, this may break buggy qc (and it's possible that one or more of these checks are wrong)
replaced CL_TraceBox with CL_Move, this is a proper csqc-entity aware version akin to SV_Move, it has a ton of parameters due to support for network entity collisions as well (ideally this needs cleanup somehow but I have no idea how, as non-csqc network entities do not share the prvm_edict_t system and do not have entity numbers in the csqc world)

------------------------------------------------------------------------
r6861 | havoc | 2007-02-19 02:24:44 +0100 (Mon, 19 Feb 2007) | 2 lines

fix shading seams along uv seams on compiled frame zero of mdl/md2/md3 models

------------------------------------------------------------------------
r6860 | havoc | 2007-02-19 02:15:58 +0100 (Mon, 19 Feb 2007) | 2 lines

fixed support of progs.dat files with important global and field names removed, such as omicron bot reporting that OP_STATE is not supported because it removed the field names

------------------------------------------------------------------------
r6858 | havoc | 2007-02-19 01:10:39 +0100 (Mon, 19 Feb 2007) | 3 lines

removed vm_cl_extensions (now uses vm_sv_extensions)
cleaned up fieldoffsets/globaloffsets/funcoffsets fetching code (including removal of some duplicates) and sorted the contents of the structs to match the new order of the code

------------------------------------------------------------------------
r6857 | havoc | 2007-02-19 00:39:54 +0100 (Mon, 19 Feb 2007) | 2 lines

fixed an evil ent->fields.vp access that was not using PRVM_EDICTFIELDVALUE

------------------------------------------------------------------------
r6856 | havoc | 2007-02-19 00:10:19 +0100 (Mon, 19 Feb 2007) | 2 lines

added an error message stating if an image file was loaded but decoding failed

------------------------------------------------------------------------
r6855 | havoc | 2007-02-18 13:57:43 +0100 (Sun, 18 Feb 2007) | 2 lines

added svc_trailparticles and svc_pointparticles, these are written by the trailparticles and pointparticles server builtins (matching the csqc ones), these can utilize any effect defined in effectinfo.txt without using csqc

------------------------------------------------------------------------
r6854 | havoc | 2007-02-18 13:49:24 +0100 (Sun, 18 Feb 2007) | 2 lines

renamed CL_Move to CL_Input to avoid confusion with the CL_Move that will be added (similar to SV_Move)

------------------------------------------------------------------------
r6853 | havoc | 2007-02-18 13:47:17 +0100 (Sun, 18 Feb 2007) | 2 lines

added generic collision functions Collision_ClipToGenericEntity, Collision_ClipToWorld, and Collision_CombineTraces to allow reduction of similar code in csqc and ssqc

------------------------------------------------------------------------
r6852 | havoc | 2007-02-18 13:45:26 +0100 (Sun, 18 Feb 2007) | 2 lines

changed fieldoffsets and globaloffsets to be integer array indices instead of byte offsets, this basically means d->ofs is no longer multiplied by 4 in PRVM_ED_FindFieldOffset and PRVM_ED_FindGlobalOffset

------------------------------------------------------------------------
r6851 | havoc | 2007-02-18 13:41:11 +0100 (Sun, 18 Feb 2007) | 4 lines

a cosmetic change as suggested by div0:
renamed PRVM_GETEDICTFIELDVALUE to PRVM_EDICTFIELDVALUE
renamed PRVM_GETGLOBALFIELDVALUE to PRVM_GLOBALFIELDVALUE

------------------------------------------------------------------------
r6850 | havoc | 2007-02-18 13:35:52 +0100 (Sun, 18 Feb 2007) | 2 lines

allow non-integer framerates for q3 shader animmap commands

------------------------------------------------------------------------
r6849 | havoc | 2007-02-18 12:53:09 +0100 (Sun, 18 Feb 2007) | 2 lines

fixed a bug with png loading on x86_64 platforms caused by libpng retardedness (it defines png_uint_32 as unsigned long, which is 64bit on such architectures, AND to make it worse this can be modified in pngconf.h on a per platform basis, so we detect the problem on big endian 64bit architectures and fix it there too)

------------------------------------------------------------------------
r6848 | black | 2007-02-17 12:27:09 +0100 (Sat, 17 Feb 2007) | 4 lines

Hopefully this fixes a bug introduced with the latest cleanup by LH.
Changed the menu code to always show the old quake menu if forceqmenu is set
(even if it lacks the gfx files).

------------------------------------------------------------------------
r6847 | havoc | 2007-02-16 23:25:44 +0100 (Fri, 16 Feb 2007) | 2 lines

reduced r_shadow_glossintensity from 2 to 1 by default

------------------------------------------------------------------------
r6846 | havoc | 2007-02-16 03:26:48 +0100 (Fri, 16 Feb 2007) | 2 lines

the record command now disconnects you if starting a new map, this fixes a crash if doing "playdemo demo1;record test;stop"

------------------------------------------------------------------------
r6845 | havoc | 2007-02-15 22:41:07 +0100 (Thu, 15 Feb 2007) | 2 lines

changed SCR_DrawConsole call in csqc mode to match non-csqc mode (now draws after sbar)

------------------------------------------------------------------------
r6844 | havoc | 2007-02-15 08:55:14 +0100 (Thu, 15 Feb 2007) | 2 lines

fix an uninitialized variable warnign

------------------------------------------------------------------------
r6843 | havoc | 2007-02-15 01:13:49 +0100 (Thu, 15 Feb 2007) | 3 lines

cleaned up client qc, menu qc, and server qc VM initialization a bit so they have shared field/global/function lookup code,
changed world.c to not be server specific, moved server-specific functions to sv_phys.c

------------------------------------------------------------------------
r6842 | havoc | 2007-02-15 01:11:29 +0100 (Thu, 15 Feb 2007) | 2 lines

added gl_lockarrays_minimumvertices cvar for testing

------------------------------------------------------------------------
r6841 | havoc | 2007-02-15 01:07:21 +0100 (Thu, 15 Feb 2007) | 2 lines

removed unused world_cs.c code

------------------------------------------------------------------------
r6840 | havoc | 2007-02-14 22:22:16 +0100 (Wed, 14 Feb 2007) | 3 lines

added a check for level changes which blocks prediction for 100ms at the beginning of the new level, and clears ping time and other information
refactored input parsing to buffer moves in sv_readmoves array, this means that it can now always trust the last move in the packet, never ignored like earlier ones (which are clearly repeats of earlier input)

------------------------------------------------------------------------
r6839 | havoc | 2007-02-14 22:09:55 +0100 (Wed, 14 Feb 2007) | 2 lines

some initial changes to support terrain texture blending someday

------------------------------------------------------------------------
r6838 | havoc | 2007-02-14 07:54:24 +0100 (Wed, 14 Feb 2007) | 2 lines

added bounding of info->particleaccumulator so that bogus values won't cause a very long loop

------------------------------------------------------------------------
r6837 | havoc | 2007-02-14 07:53:36 +0100 (Wed, 14 Feb 2007) | 2 lines

fix bug that caused trails to not appear at the right place

------------------------------------------------------------------------
r6836 | havoc | 2007-02-13 00:38:01 +0100 (Tue, 13 Feb 2007) | 2 lines

added cl_nettimesyncmode cvar to choose the method of synchronizing cl.time, it defaults to resetting the cl.time to the previous packet's time, but only when it is out of bounds (meaning it increases it if it is falling behind, and snaps it back to the previous packet time if it exceeds this packet's time, which eliminates accumulated error)

------------------------------------------------------------------------
r6835 | havoc | 2007-02-13 00:24:09 +0100 (Tue, 13 Feb 2007) | 2 lines

sendcvar now quotes the resulting sentcvar value

------------------------------------------------------------------------
r6834 | havoc | 2007-02-12 21:36:11 +0100 (Mon, 12 Feb 2007) | 2 lines

removed cl.timenonlerp (reverted to using cl.time)

------------------------------------------------------------------------
r6833 | havoc | 2007-02-12 20:27:57 +0100 (Mon, 12 Feb 2007) | 2 lines

changed particleaccumulator check to use >= 1 instead of > 0, hopefully this will fix an infinite loop I encountered in testing

------------------------------------------------------------------------
r6832 | havoc | 2007-02-12 17:44:09 +0100 (Mon, 12 Feb 2007) | 2 lines

fixed problems with network entity viewmodels not following csqc_origin (as set by csqc)

------------------------------------------------------------------------
r6831 | havoc | 2007-02-12 17:43:15 +0100 (Mon, 12 Feb 2007) | 2 lines

minor cleaning

------------------------------------------------------------------------
r6830 | havoc | 2007-02-12 17:42:46 +0100 (Mon, 12 Feb 2007) | 2 lines

disabled saveconfig when doing -benchmark

------------------------------------------------------------------------
r6828 | havoc | 2007-02-12 00:08:29 +0100 (Mon, 12 Feb 2007) | 2 lines

downloads of .cfg and dlcache/ files are now forbidden by default (cvar controlled)

------------------------------------------------------------------------
r6827 | havoc | 2007-02-11 23:43:43 +0100 (Sun, 11 Feb 2007) | 2 lines

reworked Image_HeightmapToNormalmap to use a somewhat blurrier but more consistent algorithm

------------------------------------------------------------------------
r6826 | havoc | 2007-02-11 18:44:59 +0100 (Sun, 11 Feb 2007) | 4 lines

modified Mod_LoadSkinFrame to set base = r_texture_notexture on failure, this reduced fallback code elsewhere
reworked Mod_BuildAliasSkinsFromSkinFiles, it no longer tries fallbacks if a skin texture fails to load
fixed a crash on missing meshes in a skin file (which are intentionally nodraw, just like in Quake3)

------------------------------------------------------------------------
r6825 | havoc | 2007-02-11 16:52:17 +0100 (Sun, 11 Feb 2007) | 2 lines

disabled cl.stairoffset adjustments when airborn

------------------------------------------------------------------------
r6824 | havoc | 2007-02-11 16:27:18 +0100 (Sun, 11 Feb 2007) | 2 lines

some optimizations of CL_UpdateNetworkEntity to lower cpu overhead of the client

------------------------------------------------------------------------
r6823 | havoc | 2007-02-11 03:12:16 +0100 (Sun, 11 Feb 2007) | 2 lines

fix gamedir error when connecting to quakeworld servers

------------------------------------------------------------------------
r6822 | havoc | 2007-02-11 02:59:02 +0100 (Sun, 11 Feb 2007) | 2 lines

added an extern for r_bloom_brighten to fix menu.c compilation

------------------------------------------------------------------------
r6821 | havoc | 2007-02-10 23:44:46 +0100 (Sat, 10 Feb 2007) | 2 lines

fixed r_bloom_brighten to use the correct range

------------------------------------------------------------------------
r6820 | havoc | 2007-02-10 23:43:41 +0100 (Sat, 10 Feb 2007) | 3 lines

added r_bloom_brighten modification in graphics options menu, this was already displayed but wasn't working, messing up all options after it
updated graphics options item count from 19 to 20

------------------------------------------------------------------------
r6819 | havoc | 2007-02-10 23:01:19 +0100 (Sat, 10 Feb 2007) | 2 lines

fix graphics options menu editing of bloom/scene brightness settings (they were swapped)

------------------------------------------------------------------------
r6818 | havoc | 2007-02-10 22:17:06 +0100 (Sat, 10 Feb 2007) | 3 lines

fix stupid bug in last patch that made entities not update
reworked priorities some more

------------------------------------------------------------------------
r6817 | havoc | 2007-02-10 21:31:19 +0100 (Sat, 10 Feb 2007) | 3 lines

fixed bug from lingering code that was resetting entity priority every frame
more tweaks to entity priority code

------------------------------------------------------------------------
r6816 | havoc | 2007-02-10 21:06:49 +0100 (Sat, 10 Feb 2007) | 2 lines

fix a stupid bug in transparent water detection for q1bsp, it now works

------------------------------------------------------------------------
r6815 | havoc | 2007-02-09 22:17:37 +0100 (Fri, 09 Feb 2007) | 2 lines

changed entity priority code again, it should have less 'starvation' issues now (high priority entities causing others to be missed)

------------------------------------------------------------------------
r6814 | havoc | 2007-02-09 05:36:48 +0100 (Fri, 09 Feb 2007) | 2 lines

reenabled exact portal culling of surface triangles, because it was not bugged after all

------------------------------------------------------------------------
r6813 | havoc | 2007-02-09 05:24:27 +0100 (Fri, 09 Feb 2007) | 2 lines

some minor state change optimizations on GL20 path, it now does even less per batch

------------------------------------------------------------------------
r6812 | havoc | 2007-02-09 04:26:24 +0100 (Fri, 09 Feb 2007) | 2 lines

made r_shadow_frontsidecasting cvar disable the portal culling features when it is casting from back sides (which portal culling can't work with)

------------------------------------------------------------------------
r6811 | havoc | 2007-02-09 04:22:34 +0100 (Fri, 09 Feb 2007) | 2 lines

added back portal culling to rtlights because svbsp code is not working as well as it's supposed to

------------------------------------------------------------------------
r6810 | havoc | 2007-02-09 02:19:05 +0100 (Fri, 09 Feb 2007) | 2 lines

fix Q3BSP map loader's sky surface detection so that it doesn't assume all submodels have sky if the base model does, this improves rendering performance a bit (by not scanning for sky in submodels that claim to have it but don't)

------------------------------------------------------------------------
r6809 | havoc | 2007-02-08 16:57:21 +0100 (Thu, 08 Feb 2007) | 12 lines

removed CL_UpdateEntities call in CSQC rendering code
changed r_refdef.lights from dlight_t * to rtlight_t (no longer a pointer)
modified CL_UpdateLights to setup the r_refdef.lights[] entry instead of merely pointing to the rtlight_t in the dlight_t struct
changed csqc dlight handling to comply with the spec (R_ClearScene resets r_refdef.numlights, then VM_R_AddEntities adds all engine-based entities and lights)
moved single-frame dlight spawning for rocket glow and such from CL_UpdateNetworkEntity to CL_LinkNetworkEntity (which is called by VM_R_AddEntities)
replaced all single-frame uses of CL_AllocDLight with R_RTLight_Update(&r_refdef.lights[r_refdef.numlights++], ...) calls, this includes lights such as muzzleflash, rocket glow, .glow_size lights, tenebrae dlights, etc
renamed CL_AllocDlight to CL_AllocLightFlash
renamed CL_DecayLights to CL_DecayLightFlashes
renamed CL_UpdateLights to CL_RelinkLightFlashes
renamed CL_ParticleEffect to CL_ParticleTrail and added spawndlight/spawnparticles boolean parameters, then added a CL_ParticleEffect which calls this with true for both
removed cubemapnum field from dlight_t

------------------------------------------------------------------------
r6808 | havoc | 2007-02-08 16:56:40 +0100 (Thu, 08 Feb 2007) | 2 lines

added DP_QC_STRFTIME extension to menu vm (somehow I missed this when committing earlier)

------------------------------------------------------------------------
r6807 | havoc | 2007-02-08 16:56:10 +0100 (Thu, 08 Feb 2007) | 2 lines

reworked entity priority handling in DP6/7 protocols to better utilize limited bandwidth and just be cleaner code in general

------------------------------------------------------------------------
r6806 | havoc | 2007-02-08 16:37:08 +0100 (Thu, 08 Feb 2007) | 2 lines

disabled use of certain prediction code when the server has blocked prediction

------------------------------------------------------------------------
r6805 | havoc | 2007-02-08 16:13:27 +0100 (Thu, 08 Feb 2007) | 2 lines

lowered minimum maxpacketsize from 100 bytes to 50 bytes (this means rate 1000 will be honored at the default sys_ticrate 0.05)

------------------------------------------------------------------------
r6803 | havoc | 2007-02-08 11:15:36 +0100 (Thu, 08 Feb 2007) | 2 lines

added DP_QC_STRFTIME extension

------------------------------------------------------------------------
r6802 | havoc | 2007-02-07 19:39:41 +0100 (Wed, 07 Feb 2007) | 2 lines

added a check for move->sequence that is more than 16 packets old to avoid having frozen players after a level change

------------------------------------------------------------------------
r6801 | havoc | 2007-02-06 09:43:08 +0100 (Tue, 06 Feb 2007) | 2 lines

some slight cleanup of CL_LerpPoint, and now does a bound() on cl.time as well as cl.timenonlerp whenever cl.mtime[] is updated

------------------------------------------------------------------------
r6800 | havoc | 2007-02-06 09:36:14 +0100 (Tue, 06 Feb 2007) | 2 lines

tolerate clients living up to one frame in the future, just to be more flexible with client prediction

------------------------------------------------------------------------
r6799 | havoc | 2007-02-06 09:18:50 +0100 (Tue, 06 Feb 2007) | 4 lines

no longer sends moves if time is not moving forward, except when paused (this fixes some bugs causing cl_movement 0 to lose impulse/buttons)
no longer repeats old moves if cl_movement is off (because they would serve no purpose)
eliminated cl.movemessages (now uses cl.movesequence for the same purpose)

------------------------------------------------------------------------
r6798 | havoc | 2007-02-06 06:38:08 +0100 (Tue, 06 Feb 2007) | 2 lines

fix very stupid typo in input merging when cl_movement is 0

------------------------------------------------------------------------
r6797 | havoc | 2007-02-05 18:53:30 +0100 (Mon, 05 Feb 2007) | 2 lines

disabled debug print I forgot about

------------------------------------------------------------------------
r6796 | havoc | 2007-02-05 18:45:59 +0100 (Mon, 05 Feb 2007) | 6 lines

redesigned input networking code (still same protocol) and did a lot of cleaning, now predicts movement even if server packets are lost
added cl_netinputpacketlosstolerance cvar (default 4, qw used 2, can be up to 16) to repeat old input messages in each packet so that they can only be lost by heavy packet loss
changed sv_clmovement_waitforinput default to 16 to match this capability
reworked a lot of timing code related to input networking
fixed some bugs when frametime is 0 in player physics

------------------------------------------------------------------------
r6795 | havoc | 2007-02-05 16:47:55 +0100 (Mon, 05 Feb 2007) | 2 lines

thanks to morfar for updating the Dev-C++ project file

------------------------------------------------------------------------
r6794 | havoc | 2007-02-05 14:32:09 +0100 (Mon, 05 Feb 2007) | 2 lines

changed default sv_clmovement_minping from 100 to 0

------------------------------------------------------------------------
r6793 | havoc | 2007-02-05 10:04:01 +0100 (Mon, 05 Feb 2007) | 2 lines

fixed double-jump bug in prediction when jumping up sides of crates or on stairs

------------------------------------------------------------------------
r6792 | havoc | 2007-02-05 09:55:12 +0100 (Mon, 05 Feb 2007) | 2 lines

fix q1bsp detection of stuck entities (needed some more parentheses)

------------------------------------------------------------------------
r6791 | havoc | 2007-02-05 09:41:34 +0100 (Mon, 05 Feb 2007) | 2 lines

removed an unneeded extern prototype

------------------------------------------------------------------------
r6790 | havoc | 2007-02-05 09:39:49 +0100 (Mon, 05 Feb 2007) | 2 lines

removed an unneeded cl.movement_replay = true; line

------------------------------------------------------------------------
r6789 | havoc | 2007-02-04 13:55:09 +0100 (Sun, 04 Feb 2007) | 2 lines

fix a couple printf format string warnings that only occur with COLLISIONPARANOID on

------------------------------------------------------------------------
r6788 | havoc | 2007-02-04 13:54:09 +0100 (Sun, 04 Feb 2007) | 2 lines

refactored end code in Collision_Trace*BrushFloat functions to fix a severe logic bug that caused players to get stuck inside eachother in nexuiz

------------------------------------------------------------------------
r6787 | havoc | 2007-02-04 12:27:42 +0100 (Sun, 04 Feb 2007) | 4 lines

minor optimization of surface scanning
minor optimization of leaf recursion
added a leafstack overflow check to visibility flooding

------------------------------------------------------------------------
r6786 | havoc | 2007-02-04 09:32:57 +0100 (Sun, 04 Feb 2007) | 2 lines

added r_showsurfaces 2 mode which shorts triangle draw order (to analyze whether models are optimized for vertex cache)

------------------------------------------------------------------------
r6785 | havoc | 2007-02-03 14:01:36 +0100 (Sat, 03 Feb 2007) | 2 lines

revised sv_clmovement_waitforinput default from 2 to 5 frames to have more tolerance for inconsistent packet timing

------------------------------------------------------------------------
r6782 | havoc | 2007-02-03 13:10:03 +0100 (Sat, 03 Feb 2007) | 2 lines

added DP_SV_PRINT extension

------------------------------------------------------------------------
r6781 | havoc | 2007-02-03 13:08:54 +0100 (Sat, 03 Feb 2007) | 2 lines

made CL_SetInfo check for more forbidden characters (key now refuses any form of whitespace, value now refuses \r and \n) and refactored the checking code to make it a bit cleaner

------------------------------------------------------------------------
r6780 | havoc | 2007-02-03 13:07:59 +0100 (Sat, 03 Feb 2007) | 2 lines

moved DP_QC_UNLIMITEDTEMPSTRINGS in extensions list to its proper place

------------------------------------------------------------------------
r6779 | havoc | 2007-02-03 09:49:02 +0100 (Sat, 03 Feb 2007) | 2 lines

added r_shadow_frontsidecasting cvar (default 1), this allows switching to back-side casting instead, however this has proven buggy so it is not to be used yet

------------------------------------------------------------------------
r6778 | havoc | 2007-02-03 09:40:38 +0100 (Sat, 03 Feb 2007) | 2 lines

optimized trimesh collision culling (this mostly affects patches)

------------------------------------------------------------------------
r6777 | havoc | 2007-02-03 07:33:07 +0100 (Sat, 03 Feb 2007) | 2 lines

fix really stupid typo in previous patch that caused a memory smash

------------------------------------------------------------------------
r6776 | havoc | 2007-02-03 06:19:55 +0100 (Sat, 03 Feb 2007) | 2 lines

fix bug in Collision_SnapCopyPoints that made it only snap the first vertex

------------------------------------------------------------------------
r6775 | havoc | 2007-02-03 05:03:01 +0100 (Sat, 03 Feb 2007) | 2 lines

removed single-quoted string support in console parser because it breaks the maplist in nexuiz

------------------------------------------------------------------------
r6774 | havoc | 2007-02-03 04:36:26 +0100 (Sat, 03 Feb 2007) | 2 lines

fixed two bugs that caused a constant state of "player stuck" (one was that it always thought this was a q1bsp/hlbsp map, and the other was that the q1bsp/hlbsp corner checking was checking the wrong locations)

------------------------------------------------------------------------
r6773 | havoc | 2007-02-03 04:08:57 +0100 (Sat, 03 Feb 2007) | 2 lines

fixed bug in AVI RIFF chunk 1GB size limiting code (it was not accounting for the index buffer size which will be written afterward) which was causing the chunk to often exceed 1GB

------------------------------------------------------------------------
r6772 | havoc | 2007-02-02 15:39:13 +0100 (Fri, 02 Feb 2007) | 2 lines

moved interpolation of viewangles when playing back demos or spectating someone to a better place, this should work better with csqc

------------------------------------------------------------------------
r6771 | tomaz | 2007-01-29 22:32:09 +0100 (Mon, 29 Jan 2007) | 2 lines

Updated the workspaces to include svbsp.c and svbsp.h

------------------------------------------------------------------------
r6770 | havoc | 2007-01-29 11:33:33 +0100 (Mon, 29 Jan 2007) | 2 lines

497

------------------------------------------------------------------------
r6769 | havoc | 2007-01-29 11:31:14 +0100 (Mon, 29 Jan 2007) | 2 lines

reverted r_bloom_colorsubtract and r_shadow_brighten defaults to 0.125 and 2

------------------------------------------------------------------------
r6768 | havoc | 2007-01-29 11:20:05 +0100 (Mon, 29 Jan 2007) | 2 lines

changed default r_shadow_gloss2intensity from 0.5 to 0.125, now looks more like tenebrae again (except a little better)

------------------------------------------------------------------------
r6767 | havoc | 2007-01-29 10:52:31 +0100 (Mon, 29 Jan 2007) | 2 lines

fix very stupid bug in svbsp calls that made only the first triangle of an occluding surface polygon be inserted into the svbsp, and some other cleanup/corrections

------------------------------------------------------------------------
r6766 | havoc | 2007-01-29 10:51:20 +0100 (Mon, 29 Jan 2007) | 2 lines

some minor optimizations, comment corrections, and changed debug polygon colors

------------------------------------------------------------------------
r6765 | havoc | 2007-01-29 08:51:07 +0100 (Mon, 29 Jan 2007) | 2 lines

fix stupid bug in insertion of occluder triangles in the svbsp code (it was stopping after adding the first one)

------------------------------------------------------------------------
r6763 | havoc | 2007-01-28 09:25:15 +0100 (Sun, 28 Jan 2007) | 2 lines

corrected OPTIONS_ITEMS and OPTIONS_GRAPHICS_ITEMS constants (the last 3 items of the graphics options submenu were not reachable)

------------------------------------------------------------------------
r6762 | havoc | 2007-01-28 05:14:59 +0100 (Sun, 28 Jan 2007) | 2 lines

fix stupid bug (dynamic shadowing from models was checking if NOSHADOW was set, not if it was clear)

------------------------------------------------------------------------
r6761 | havoc | 2007-01-28 03:57:51 +0100 (Sun, 28 Jan 2007) | 2 lines

implemented Shadow Volume BSP based culling of lit surfaces, this is slightly better than the existing portal culling code (or much better in the case of detail brush terrain in q3bsp where little culling was performed previously), and is now the only culling method used by rtlight compilation

------------------------------------------------------------------------
r6760 | havoc | 2007-01-28 03:55:15 +0100 (Sun, 28 Jan 2007) | 2 lines

added MATERIALFLAG_NOSHADOW in an effort to clean up the material checking in shadow code a bit

------------------------------------------------------------------------
r6759 | havoc | 2007-01-28 03:52:41 +0100 (Sun, 28 Jan 2007) | 3 lines

patch from Tomaz adding a proper matrix inverter, it should be able to invert any matrix that is possible to invert, but is VERY slow, and consequently Matrix4x4_Invert_Simple has been kept for speed reasons
it is probably possible to optimize this function significantly, and it would also be possible to add non-uniform-scaling inversion to Matrix4x4_Invert_Simple to make it more flexible

------------------------------------------------------------------------
r6758 | havoc | 2007-01-28 03:50:32 +0100 (Sun, 28 Jan 2007) | 2 lines

added Debug_Polygon functions for testing, these are currently abusing the CSQC polygon queue and have many stupid limitations which should be cleaned up at some point, but it is now possible to call these to draw things for debugging purposes

------------------------------------------------------------------------
r6757 | havoc | 2007-01-26 06:58:43 +0100 (Fri, 26 Jan 2007) | 3 lines

changed sbar stats (Monsters/Secrets/Time/map title) around a bit, inspired by a patch from steven a but not directly based on it
specific changes: Monsters/Secrets are now on top row (rather than left side), map filename (minus path/extension) and map title are shown, time moved to far right of second row

------------------------------------------------------------------------
r6756 | havoc | 2007-01-25 17:27:19 +0100 (Thu, 25 Jan 2007) | 2 lines

fixed renderflags handling in CSQC_AddRenderEdict

------------------------------------------------------------------------
r6755 | havoc | 2007-01-25 17:07:30 +0100 (Thu, 25 Jan 2007) | 2 lines

clients who are downloading can now receive chat messages and other notices

------------------------------------------------------------------------
r6754 | havoc | 2007-01-24 22:27:06 +0100 (Wed, 24 Jan 2007) | 2 lines

disabled use of Portal_PortalThroughPortalPlanes on triangles in exact triangle culling mode because it was falsely culling some polygons (particularly in start.bsp), this makes the culling less exact unfortunately

------------------------------------------------------------------------
r6753 | havoc | 2007-01-24 22:26:13 +0100 (Wed, 24 Jan 2007) | 2 lines

fixed bug where toggling r_shadow_realtime_world_compile would alter the culling boxes of the compiled rtlights when in the non-compiled state

------------------------------------------------------------------------
r6750 | havoc | 2007-01-24 19:40:26 +0100 (Wed, 24 Jan 2007) | 2 lines

added BX_WAL_SUPPORT to extensions list and documented it (.wal texture support has been in for a long time before this)

------------------------------------------------------------------------
r6749 | havoc | 2007-01-24 18:48:49 +0100 (Wed, 24 Jan 2007) | 5 lines

some cleanup of shader permutation handling
expanded shader permutation system to allow multiple shader source files (not sure if this will ever be used) rather than just "glsl/default.glsl"
added code support for geometry shaders (not actually hooked up because there's no GL_ARB_geometry_shader extension yet)
added flagging of which shader objects are needed by a given permutation (to allow vertex-only shaders for shadow volume projection and such, also not implemented)

------------------------------------------------------------------------
r6748 | havoc | 2007-01-24 15:21:05 +0100 (Wed, 24 Jan 2007) | 2 lines

fix a few typos in comments

------------------------------------------------------------------------
r6747 | havoc | 2007-01-24 15:19:39 +0100 (Wed, 24 Jan 2007) | 2 lines

replaced prvm_tempstringmemory cvar with automatic buffer growth (with a limit of 256MB)

------------------------------------------------------------------------
r6746 | havoc | 2007-01-24 05:15:45 +0100 (Wed, 24 Jan 2007) | 4 lines

redesigned tempstring system, now uses a fixed size buffer based on the prvm_tempstringmemory cvar (this is probably safe to automatically resize in the future but is not currently resized)
audited PRVM_G_STRING use in the engine (eliminated many NULL checks in functions because it never returns NULL)
added DP_QC_UNLIMITEDTEMPSTRINGS extension to indicate this new tempstring system's wonderous features (not yet documented)

------------------------------------------------------------------------
r6745 | havoc | 2007-01-24 04:56:16 +0100 (Wed, 24 Jan 2007) | 3 lines

added r_hdr_range cvar (which just divides r_bloom_colorscale and multiplies r_bloom_brighten)
changed default r_bloom_brighten from 2 to 1 and r_bloom_colorsubtract from 0.125 to 0, this gives a more color-preserving bloom effect and actually seems brighter in many cases

------------------------------------------------------------------------
r6744 | havoc | 2007-01-23 20:36:14 +0100 (Tue, 23 Jan 2007) | 2 lines

another minor cleanup for static entities related to delayed model loading (no bugs involved though)

------------------------------------------------------------------------
r6743 | havoc | 2007-01-23 20:34:20 +0100 (Tue, 23 Jan 2007) | 2 lines

fixed bug in CL_RelinkStaticEntities related to delayed model loading, now calls CL_UpdateRenderEntity so the culling box is correct

------------------------------------------------------------------------
r6742 | havoc | 2007-01-23 17:58:57 +0100 (Tue, 23 Jan 2007) | 2 lines

changed Cmd_StuffCmds_f to combine the entire set of commandline arguments into one string before calling Cbuf_InsertText, this fixes the reverse order execution bug (where +deathmatch 7 +map dpdm2 would execute deathmatch 7 AFTER starting the map, which was useless until a restart command was issued)

------------------------------------------------------------------------
r6741 | havoc | 2007-01-23 17:51:26 +0100 (Tue, 23 Jan 2007) | 2 lines

fix bug in GL_CullFace which was causing it to often malfunction

------------------------------------------------------------------------
r6740 | havoc | 2007-01-23 04:12:39 +0100 (Tue, 23 Jan 2007) | 2 lines

504 (-7)

------------------------------------------------------------------------
r6739 | havoc | 2007-01-23 04:02:53 +0100 (Tue, 23 Jan 2007) | 2 lines

changed the not-very-useful min/avg/max part of timedemo results to one-second min/avg/max

------------------------------------------------------------------------
r6738 | havoc | 2007-01-23 02:40:36 +0100 (Tue, 23 Jan 2007) | 3 lines

fixed bug in CSQC_AddRenderEdict (it was using the tempentity's modelindex rather than the vm entity, meaning that csqc entities never had a visible model)
reduced code by merging cl.csqc_model_precache lookups into CSQC_GetModelByIndex and CSQC_GetModelFromEntity functions

------------------------------------------------------------------------
r6737 | havoc | 2007-01-23 01:43:51 +0100 (Tue, 23 Jan 2007) | 2 lines

eliminated cl.csqc_entities array and related fields

------------------------------------------------------------------------
r6736 | havoc | 2007-01-23 01:27:49 +0100 (Tue, 23 Jan 2007) | 3 lines

significant cleanup of CL_UpdateEntities, GL_UpdateNetworkEntity, CL_LinkNetworkEntity, V_CalcRefdef handling, and CSQC issues related to these
eliminated linkframe from entity_t (this means CL_UpdateNetworkEntity may sometimes process an entity twice, and CL_LinkNetworkEntity is no longer recursive as it does not need to be)

------------------------------------------------------------------------
r6735 | havoc | 2007-01-23 00:16:00 +0100 (Tue, 23 Jan 2007) | 2 lines

fix a couple warnings (one of them more serious than the other)

------------------------------------------------------------------------
r6734 | havoc | 2007-01-22 23:14:47 +0100 (Mon, 22 Jan 2007) | 2 lines

added support for single-quoted strings in COM_ParseTokenConsole

------------------------------------------------------------------------
r6733 | havoc | 2007-01-22 23:13:51 +0100 (Mon, 22 Jan 2007) | 2 lines

removed \ escape character support from COM_ParseTokenConsole because it breaks \ bindings in configs and may have other issues

------------------------------------------------------------------------
r6732 | havoc | 2007-01-22 23:01:27 +0100 (Mon, 22 Jan 2007) | 3 lines

implemented csprogs.dat downloading with special dlcache/name.size.crc file naming, this is in need of testing
added csqc_progsize cvar to csqc signon process (still compatible with old servers)

------------------------------------------------------------------------
r6731 | havoc | 2007-01-22 20:31:49 +0100 (Mon, 22 Jan 2007) | 5 lines

two improvements to vid_restart in the SDL client: hardware gamma is now
restored after vid_restart, and the brief fullscreen window (used to reset
the SDL GL attributes) is now only used during vid_restart, not the initial
client startup

------------------------------------------------------------------------
r6730 | havoc | 2007-01-22 19:34:13 +0100 (Mon, 22 Jan 2007) | 2 lines

STAT_TOTALSECRETS and STAT_TOTALMONSTERS are now networked so deathmatch 7 mode in dpmod shows the total monsters now

------------------------------------------------------------------------
r6729 | havoc | 2007-01-22 19:20:05 +0100 (Mon, 22 Jan 2007) | 3 lines

modified droptofloor to treat trace.startsolid as an acceptable situation, this prevents many items falling out of various user-made maps (including a critial item in level x2m4 of X-Men: Ravages of Apocalypse)
added sv_gameplayfix_droptofloorstartsolid cvar to control this behavior

------------------------------------------------------------------------
r6728 | havoc | 2007-01-22 15:59:47 +0100 (Mon, 22 Jan 2007) | 2 lines

added framecount and framerate checks to PF_effect

------------------------------------------------------------------------
r6727 | havoc | 2007-01-22 15:53:52 +0100 (Mon, 22 Jan 2007) | 2 lines

added \' and \\ support to parsers, and added such escape code support to ' quoted strings and regular words

------------------------------------------------------------------------
r6726 | havoc | 2007-01-22 15:51:05 +0100 (Mon, 22 Jan 2007) | 2 lines

implemented \" and \n support in quoted string parsers (console and otherwise)

------------------------------------------------------------------------
r6725 | havoc | 2007-01-22 15:42:05 +0100 (Mon, 22 Jan 2007) | 4 lines

moved EF_MUZZLEFLASH checking to CL_MoveLerpEntityStates to make muzzleflashes reliably work when the client is running slower than the server
made muzzleflash 1.5x as large and 4x as bright as before, and fade in 50ms instead of 100ms
changed dlight decay to scale color instead of radius

------------------------------------------------------------------------
r6722 | havoc | 2007-01-22 14:37:39 +0100 (Mon, 22 Jan 2007) | 2 lines

tweaked default TE_TELEPORT effect, it now spawns one large very bright particle in the middle and 1/8th as many small particles, this should improve multiplayer performance on slow graphics cards, also doubled the brightness of the dlight created, and made it last a bit longer

------------------------------------------------------------------------
r6721 | havoc | 2007-01-22 14:22:46 +0100 (Mon, 22 Jan 2007) | 3 lines

improved SV_TestEntityPosition in q1bsp/hlbsp by checking the 8 corner points of the box, this fixes the misaligned double-doors bug in the Prydon Gate expansion "The Dark Age"
changed Stuck entity warning from developer 1 to developer 100 because it's annoying and not very helpful

------------------------------------------------------------------------
r6720 | havoc | 2007-01-22 14:20:29 +0100 (Mon, 22 Jan 2007) | 2 lines

client no longer tries to download missing files from server if it is hosting the server

------------------------------------------------------------------------
r6719 | havoc | 2007-01-22 13:06:42 +0100 (Mon, 22 Jan 2007) | 4 lines

changed FS_ChangeGamedir to FS_ChangeGameDirs and made it fail if any of the gamedirs are missing (if the failmissing parameter is set) and detect various other failures
FS_Init now checks if game directories are found and does a Sys_Error if not
now does a Host_Error if a QW server specifies an invalid gamedir (missing gamedir is ok however, because QW downloads files)

------------------------------------------------------------------------
r6718 | havoc | 2007-01-22 11:40:58 +0100 (Mon, 22 Jan 2007) | 2 lines

changed ping report name matching to allow scoreboard names to be longer than ping report names (because recent versions of ClanRing CTF seem to append READY on the scoreboard but not the ping report)

------------------------------------------------------------------------
r6717 | havoc | 2007-01-22 11:38:06 +0100 (Mon, 22 Jan 2007) | 2 lines

CL_Effect (called by svc_effect parsing) now sanity checks framerate and framecount

------------------------------------------------------------------------
r6716 | havoc | 2007-01-22 00:12:20 +0100 (Mon, 22 Jan 2007) | 2 lines

autodetect whether a map supports transparent water at load time

------------------------------------------------------------------------
r6715 | havoc | 2007-01-21 21:27:36 +0100 (Sun, 21 Jan 2007) | 6 lines

implemented individual file downloads on darkplaces servers
deferred loading of files until signon 2 (necessary for download system)
made loading of files operate in two passes, first for existing files and then again for files that need to be downloaded
added cl_joinbeforedownloadsfinish cvar to cause the game to begin after the map is loaded, before other downloads finish (not entirely sure this is a good idea, but it's cool)
added sv_allowdownloads cvar to allow enabling/disabling of downloads, and sv_allowdownloads_inarchive and sv_allowdownloads_archive cvars to allow server administrators to enable downloading files from archives or even whole archives if so desired (however the client does not currently request archives)

------------------------------------------------------------------------
r6714 | havoc | 2007-01-21 15:21:53 +0100 (Sun, 21 Jan 2007) | 3 lines

reorganized view rendering setup code a bit to reduce potential for state bugs (more thorough and consistent state resets now)
added support for glStencilOpSeparate function in OpenGL 2.0 (or GL_ATI_separate_stencil extension prior to that), so ATI cards should get a speed boost now, this path is now also used on NVIDIA hardware, but support for GL_EXT_stencil_two_side extension has been retained to support several other vendors

------------------------------------------------------------------------
r6713 | havoc | 2007-01-21 12:53:08 +0100 (Sun, 21 Jan 2007) | 2 lines

added some comments in Mod_LoadModel

------------------------------------------------------------------------
r6712 | havoc | 2007-01-21 12:52:29 +0100 (Sun, 21 Jan 2007) | 2 lines

fixed negative time delta problem with sbar item flashing

------------------------------------------------------------------------
r6711 | havoc | 2007-01-21 12:51:27 +0100 (Sun, 21 Jan 2007) | 2 lines

added FS_FileSize and made FS_FileExtension public

------------------------------------------------------------------------
r6710 | havoc | 2007-01-21 12:39:19 +0100 (Sun, 21 Jan 2007) | 3 lines

r_textshadow is now a saved cvar
the r_textshadow shadow color is now 1-red-green-blue (basically meaning it is black except for black text where it is white)

------------------------------------------------------------------------
r6709 | havoc | 2007-01-20 23:52:03 +0100 (Sat, 20 Jan 2007) | 2 lines

very minor cleaning

------------------------------------------------------------------------
r6708 | havoc | 2007-01-20 10:27:05 +0100 (Sat, 20 Jan 2007) | 2 lines

fix a crash in R_SkyStartFrame when there is no worldmodel

------------------------------------------------------------------------
r6707 | havoc | 2007-01-20 10:16:17 +0100 (Sat, 20 Jan 2007) | 2 lines

added FS_CheckNastyPath prototype to fs.h so that it can be used elsewhere

------------------------------------------------------------------------
r6706 | havoc | 2007-01-20 10:14:02 +0100 (Sat, 20 Jan 2007) | 2 lines

S_PrecacheSound now clears the SFXFLAG_FILEMISSING flag so that loading will try again on previously missing files whenever the level changes (particularly important if downloads or gamedir changes have occurred)

------------------------------------------------------------------------
r6703 | havoc | 2007-01-18 12:08:11 +0100 (Thu, 18 Jan 2007) | 3 lines

increased M_MAX_EDICTS to 32768
note to Black: 640k ought to be enough for everybody using the nexuiz menu, right? ;)

------------------------------------------------------------------------
r6702 | havoc | 2007-01-18 12:04:31 +0100 (Thu, 18 Jan 2007) | 2 lines

changed CL_MAX_EDICTS to match MAX_EDICTS

------------------------------------------------------------------------
r6701 | havoc | 2007-01-18 11:58:03 +0100 (Thu, 18 Jan 2007) | 2 lines

applied div0's patch to the tell command adding player number support (as opposed to the hard-to-type player names) as well as fixing a bug with quoted player names containing spaces accidentally sending part of the player name to the recipient (similar to the quake tell bug which sent the entire player name)

------------------------------------------------------------------------
r6700 | havoc | 2007-01-18 11:44:24 +0100 (Thu, 18 Jan 2007) | 2 lines

added collision_prefernudgedfraction cvar (defaults to 1), which should improve collision stability in 'wedge corner' cases (such as creases in terrain)

------------------------------------------------------------------------
r6699 | havoc | 2007-01-18 11:41:26 +0100 (Thu, 18 Jan 2007) | 2 lines

renamed r_bloomstate.vertex3f to r_screenvertex3f and made it constant

------------------------------------------------------------------------
r6698 | havoc | 2007-01-18 11:39:02 +0100 (Thu, 18 Jan 2007) | 2 lines

fixed problems with cl.time stepping backwards causing a black fade-in and other problems

------------------------------------------------------------------------
r6697 | havoc | 2007-01-18 09:49:50 +0100 (Thu, 18 Jan 2007) | 2 lines

support partial IP addresses in the ipv4 address parser, this fixes the 20+ second delay when parsing status messages on some modified quake servers that report only partial addresses (hiding the last octet)

------------------------------------------------------------------------
r6696 | havoc | 2007-01-18 08:04:14 +0100 (Thu, 18 Jan 2007) | 2 lines

expanded the Replacement Content section with some example filenames and other information

------------------------------------------------------------------------
r6695 | havoc | 2007-01-14 12:18:17 +0100 (Sun, 14 Jan 2007) | 2 lines

changed extResponse handler to quote the address string when passing it to the menu qc

------------------------------------------------------------------------
r6694 | havoc | 2007-01-14 11:19:20 +0100 (Sun, 14 Jan 2007) | 3 lines

patch from div0 that enables printf format warnings in gcc
patch from div0 that fixes a lot of printf format warnings (some quite bad)

------------------------------------------------------------------------
r6693 | havoc | 2007-01-14 11:09:16 +0100 (Sun, 14 Jan 2007) | 2 lines

patch from div0 that adds sv_random_seed for benchmarking servers with bots the same way repeatedly

------------------------------------------------------------------------
r6692 | havoc | 2007-01-14 11:05:49 +0100 (Sun, 14 Jan 2007) | 2 lines

patch from div0 to add sv_adminnick cvar which overrides hostname as the name to use in chat from the dedicated server console (or via rcon say and such)

------------------------------------------------------------------------
r6691 | havoc | 2007-01-14 11:03:13 +0100 (Sun, 14 Jan 2007) | 2 lines

cast time of received moves to float to prevent negative ping estimates when timer is degraded severely

------------------------------------------------------------------------
r6690 | havoc | 2007-01-14 10:59:26 +0100 (Sun, 14 Jan 2007) | 2 lines

added DP_MENU_EXTRESPONSEPACKET to extensions list

------------------------------------------------------------------------
r6689 | havoc | 2007-01-14 10:56:30 +0100 (Sun, 14 Jan 2007) | 2 lines

patch from div0 that adds a special "extResponse " type of packet that can be returned to menu qc as a string (to query current version of Nexuiz or anything else of that nature, requires special servers that return such packets, the packets are sent using the "packet" command which already existed from qw support)

------------------------------------------------------------------------
r6688 | havoc | 2007-01-14 10:53:31 +0100 (Sun, 14 Jan 2007) | 2 lines

patch from div0 to make DrawQ_ColoredString return the length of the printed text

------------------------------------------------------------------------
r6687 | havoc | 2007-01-14 10:51:52 +0100 (Sun, 14 Jan 2007) | 2 lines

patch from div0 to clamp ping reports to 1-9999 range in getinfo server queries

------------------------------------------------------------------------
r6686 | havoc | 2007-01-14 10:50:42 +0100 (Sun, 14 Jan 2007) | 2 lines

added -Wdeclaration-after-statement to warn about any use of C99 lazy variable declaration (which is not supported by MSVC)

------------------------------------------------------------------------
r6685 | havoc | 2007-01-12 04:40:35 +0100 (Fri, 12 Jan 2007) | 4 lines

changed Cmd_AddCommand to only work for console commands, not client commands executed on the server, Cmd_AddCommand_WithClientCommand has been added to allow separate command functions for console commands and client commands, this got rid of a lot of cmd_source == src_command checks
this refactoring fixes a security vulnerability in the clcommand builtin provided by KRIMZON_SV_PARSECLIENTCOMMAND, which was able to execute many commands on the server console, and that put the burden on the QC code to validate command safety, which was not intended
in short: this fixes a remote console command execution vulnerability that affected a few games/mods

------------------------------------------------------------------------
r6684 | havoc | 2007-01-12 01:34:19 +0100 (Fri, 12 Jan 2007) | 4 lines

gamedir is now checked by FS_CheckNastyPath
added special isgamedir flag to FS_CheckNastyPath to validate gamedir using more stringent checks than for normal filenames
added additional checks in FS_CheckNastyPath for things like . in path elements (still allowed in filename at end but no longer allowed in path elements at all)

------------------------------------------------------------------------
r6683 | havoc | 2007-01-11 05:48:25 +0100 (Thu, 11 Jan 2007) | 4 lines

implemented new bloom code (still not using GLSL, but the new bloom is much nicer and more configurable)
added r_shadow_glossexponent cvar to control width of specular highlights
changed r_shadow_glossexponent default from 8 to 32 (looks more like metal or wet stone)

------------------------------------------------------------------------
r6682 | havoc | 2007-01-11 05:45:12 +0100 (Thu, 11 Jan 2007) | 2 lines

implemented detection of GL_EXT_blend_subtract

------------------------------------------------------------------------
r6681 | havoc | 2007-01-11 05:43:48 +0100 (Thu, 11 Jan 2007) | 2 lines

try harder to identify little endian cpus when BYTE_ORDER is undefined

------------------------------------------------------------------------
r6680 | havoc | 2007-01-04 22:25:05 +0100 (Thu, 04 Jan 2007) | 2 lines

corrected comment on savings of the optimized skeletal cases

------------------------------------------------------------------------
r6675 | havoc | 2006-12-31 20:38:46 +0100 (Sun, 31 Dec 2006) | 4 lines

added r_shadow_glossexponent cvar to control specular power (sharpness)
changed default r_shadow_glossintensity from 1 to 2, r_shadow_gloss2intensity from 0.25 to 0.5, r_shadow_glossexponent from 8 to 32 (gloss is now much more metallic looking)
moved some stencil operation reset code to after the GL_EXT_stencil_two_side extension is turned off (just to be safer)

------------------------------------------------------------------------
r6674 | havoc | 2006-12-30 21:28:06 +0100 (Sat, 30 Dec 2006) | 2 lines

fix bug that made some models not cast shadows from the correct location

------------------------------------------------------------------------
r6673 | havoc | 2006-12-30 17:30:18 +0100 (Sat, 30 Dec 2006) | 2 lines

added r_shadows cvar which renders Quake3 cg_shadows 2 style stencil shadows from models

------------------------------------------------------------------------
r6672 | havoc | 2006-12-30 17:28:26 +0100 (Sat, 30 Dec 2006) | 2 lines

I don't know how this got committed

------------------------------------------------------------------------
r6671 | havoc | 2006-12-30 17:07:18 +0100 (Sat, 30 Dec 2006) | 2 lines

fix default modellight_lightdir shading direction in q1bsp (this has no effect since diffuse is black)

------------------------------------------------------------------------
r6670 | havoc | 2006-12-30 16:55:42 +0100 (Sat, 30 Dec 2006) | 2 lines

added a missing const modifier

------------------------------------------------------------------------
r6669 | havoc | 2006-12-30 10:30:33 +0100 (Sat, 30 Dec 2006) | 2 lines

fix stupid bug in CL_SetInfo when checking for pmodel/emodel as key (it was using Cmd_Argv)

------------------------------------------------------------------------
r6668 | havoc | 2006-12-28 02:49:03 +0100 (Thu, 28 Dec 2006) | 2 lines

patch from div0 that adds sv_public modes -2 (do not allow players to connect) and -1 (do not respond to queries)

------------------------------------------------------------------------
r6667 | havoc | 2006-12-24 13:34:20 +0100 (Sun, 24 Dec 2006) | 2 lines

made brush loader trust q3map2 brushes completely, still falls out of terrain maps using .ase models

------------------------------------------------------------------------
r6666 | havoc | 2006-12-24 10:38:01 +0100 (Sun, 24 Dec 2006) | 3 lines

changed collision brush loader to not discard planes that don't produce a polygon, this fixes many terrain and ramp problems in q3bsp (q3map2 inserted planes to fix these edge cases but the engine was discarding them)
optimized brush collision code to have more early out cases

------------------------------------------------------------------------
r6665 | havoc | 2006-12-24 02:16:05 +0100 (Sun, 24 Dec 2006) | 2 lines

set world mins/maxs/absmin/absmax at server startup

------------------------------------------------------------------------
r6664 | black | 2006-12-23 17:04:52 +0100 (Sat, 23 Dec 2006) | 3 lines

Init gl_main before gl_draw to make DP start from anywhere without crashing. Additionally it's more logical that way.
(If this breaks something, you can try to stone me or whoever who wrote the code in the first place ;))

------------------------------------------------------------------------
r6663 | havoc | 2006-12-22 14:05:38 +0100 (Fri, 22 Dec 2006) | 3 lines

raised MAX_TEXTUREUNITS from 16 to 64
fixed bug with backendimageunits/backendarrayunits not being limited to MAX_TEXTUREUNITS (caused memory corruption on NVIDIA GeForce 8 series which have 32 texture image units), backendunits was already limited properly

------------------------------------------------------------------------
r6662 | havoc | 2006-12-21 10:12:21 +0100 (Thu, 21 Dec 2006) | 2 lines

removed Q3TEXTUREFLAG_ALPHATEST uses in the code, fixing a bug that made alpha test surfaces not be alpha tested (now checks shader->layers[0].alphatest)

------------------------------------------------------------------------
r6661 | havoc | 2006-12-19 07:47:27 +0100 (Tue, 19 Dec 2006) | 3 lines

support for GL_ARB_texture_non_power_of_two extension (makes quake textures look a bit sharper on cards that support it and saves video memory)
known to be supported on NVIDIA Geforce 6 and above

------------------------------------------------------------------------
r6660 | havoc | 2006-12-18 19:11:08 +0100 (Mon, 18 Dec 2006) | 2 lines

added a missing extern

------------------------------------------------------------------------
r6659 | havoc | 2006-12-18 18:21:02 +0100 (Mon, 18 Dec 2006) | 2 lines

patch from div0 to fix screenshot naming when -game is used

------------------------------------------------------------------------
r6658 | havoc | 2006-12-17 19:25:46 +0100 (Sun, 17 Dec 2006) | 2 lines

implemented QW gamedir switching and manual gamedir switching (via "gamedir" command in console, can also use +gamedir on commandline), this may have lingering bugs

------------------------------------------------------------------------
r6657 | havoc | 2006-12-17 19:20:24 +0100 (Sun, 17 Dec 2006) | 2 lines

improved Mod_Q3BSP_LightPoint function to use r_refdef.lightstylevalue[0] to scale the color contribution, this means that dpmod darkmode works in q3bsp now

------------------------------------------------------------------------
r6656 | havoc | 2006-12-17 19:14:02 +0100 (Sun, 17 Dec 2006) | 2 lines

added snd_reload command to reload all sounds

------------------------------------------------------------------------
r6655 | havoc | 2006-12-17 19:11:01 +0100 (Sun, 17 Dec 2006) | 2 lines

removed unused packlist variable and pack->next field

------------------------------------------------------------------------
r6654 | havoc | 2006-12-16 22:42:33 +0100 (Sat, 16 Dec 2006) | 2 lines

added Cvar_UnlockDefaults function (not console accessible)

------------------------------------------------------------------------
r6653 | havoc | 2006-12-15 20:43:12 +0100 (Fri, 15 Dec 2006) | 2 lines

removed an unused extern for fs_modified

------------------------------------------------------------------------
r6652 | havoc | 2006-12-15 20:42:10 +0100 (Fri, 15 Dec 2006) | 2 lines

modified "stuffcmds" command (which runs commandline arguments preceded by + characters) to only do so once, this allows the quake.rc to be executed multiple times without executing commandline arguments multiple times

------------------------------------------------------------------------
r6651 | havoc | 2006-12-15 20:32:10 +0100 (Fri, 15 Dec 2006) | 2 lines

corrected some svc_nop's to clc_nop's (same value but more correct)

------------------------------------------------------------------------
r6650 | havoc | 2006-12-15 18:38:52 +0100 (Fri, 15 Dec 2006) | 2 lines

removed NET_MAXRATE (as it served no useful purpose), changed description of rate to say bytespersecond instead of 500-25000 (which was wrong, the limit was 1000-150000)

------------------------------------------------------------------------
r6649 | havoc | 2006-12-14 13:12:02 +0100 (Thu, 14 Dec 2006) | 2 lines

add a newline at the end of each exec'd config file

------------------------------------------------------------------------
r6648 | havoc | 2006-12-13 12:18:35 +0100 (Wed, 13 Dec 2006) | 2 lines

updated Dev-C++ project file from Spirit

------------------------------------------------------------------------
r6647 | havoc | 2006-12-12 07:28:54 +0100 (Tue, 12 Dec 2006) | 2 lines

display loading plaque much sooner in startup process, and draw it to GL_FRONT buffer rather than drawing it to the GL_BACK buffer and swapping, as if triple buffering is used the GL_BACK buffer might not be shown for some time, but the GL_FRONT buffer is instantaneous

------------------------------------------------------------------------
r6646 | havoc | 2006-12-11 17:39:13 +0100 (Mon, 11 Dec 2006) | 2 lines

moved health counter in quake hud back to its original position, no longer overlapping hipnotic key icons (for some reason Black's patch to add the nexuiz hud in revision 1.27 also moved the quake health counter, I can't discern why...)

------------------------------------------------------------------------
r6645 | havoc | 2006-12-11 11:07:47 +0100 (Mon, 11 Dec 2006) | 2 lines

optimized Mod_Alias_GetMesh_Vertices to eliminate memset calls and process arrays independently of eachother in the skeletal blending code, it also has an optimized case for one-bone vertices (the most common case)

------------------------------------------------------------------------
r6644 | havoc | 2006-12-11 11:06:01 +0100 (Mon, 11 Dec 2006) | 2 lines

changed demo playback csqc mismatch error to a warning

------------------------------------------------------------------------
r6643 | havoc | 2006-12-10 14:30:16 +0100 (Sun, 10 Dec 2006) | 2 lines

fix crash when a client reconnects to the same client slot, thanks to div0 for reporting and investigating this bug

------------------------------------------------------------------------
r6641 | havoc | 2006-12-08 16:18:19 +0100 (Fri, 08 Dec 2006) | 2 lines

patch from div0 that fixes rate limiting code to make use of sv_maxrate (as it was supposed to)

------------------------------------------------------------------------
r6640 | havoc | 2006-12-06 14:12:57 +0100 (Wed, 06 Dec 2006) | 4 lines

fixed bug where non-autosprite transparencies rendered in the same batch as autosprite transparencies were not rendered (fixes light cones disappearing in q3dm0, among other things), this occurred because the code that handles q3 shaders using "deformvertexes autosprite" changed the array pointers but never changed them back when rendering another q3 shader that does not use deformvertexes
minor cleanup of RSurf_ActiveEntity (now uses RSurf_CleanUp rather than duplicating code)
moved RSurf_CleanUp above RSurf_ActiveEntity

------------------------------------------------------------------------
r6639 | havoc | 2006-12-06 14:08:44 +0100 (Wed, 06 Dec 2006) | 2 lines

corrected a misspelling in a comment

------------------------------------------------------------------------
r6638 | havoc | 2006-12-06 12:05:41 +0100 (Wed, 06 Dec 2006) | 2 lines

improved warnings from drawstring/drawpic/drawfill functions (they now state the correct function name, and print the full warning message, previously they were truncated if it was only one problem)

------------------------------------------------------------------------
r6637 | havoc | 2006-12-06 12:04:46 +0100 (Wed, 06 Dec 2006) | 2 lines

fix connect error when csqc is not present (oops!)

------------------------------------------------------------------------
r6636 | havoc | 2006-12-06 10:04:48 +0100 (Wed, 06 Dec 2006) | 2 lines

fixed black models when csqc is active

------------------------------------------------------------------------
r6635 | havoc | 2006-12-06 09:34:35 +0100 (Wed, 06 Dec 2006) | 3 lines

fixed bug that caused csqc to only load after a map restart
rearranged entity linking when csqc is active to fix the lagging weapon model bug

------------------------------------------------------------------------
r6634 | havoc | 2006-12-06 09:07:40 +0100 (Wed, 06 Dec 2006) | 2 lines

fixed a bug with cl_movement prediction being applied during demo playback

------------------------------------------------------------------------
r6633 | havoc | 2006-12-05 10:00:09 +0100 (Tue, 05 Dec 2006) | 2 lines

fixed a bug with blank frames in sprites failing to produce a texture (fixes painkeep exploding shotgun shell sprites which became white rectangles on certain frames)

------------------------------------------------------------------------
r6629 | havoc | 2006-12-01 02:40:16 +0100 (Fri, 01 Dec 2006) | 2 lines

added con_closeontoggleconsole cvar based on Dresk's patch, but reduced to a minimal set of changes to one file rather than two

------------------------------------------------------------------------
r6628 | havoc | 2006-12-01 00:51:51 +0100 (Fri, 01 Dec 2006) | 2 lines

funky interlacing-like rendering feature from div0 (scr_stipple cvar)

------------------------------------------------------------------------
r6627 | havoc | 2006-11-25 02:28:12 +0100 (Sat, 25 Nov 2006) | 2 lines

patch from Dresk which adds DP_SV_ENTITYCONTENTSTRANSITION extension which calls a .contentstransition(oldcontents, newcontents) when the quake physics code detects a contents transition (empty to water for example)

------------------------------------------------------------------------
r6626 | havoc | 2006-11-24 23:55:08 +0100 (Fri, 24 Nov 2006) | 2 lines

patch from Dresk for DP_QC_STRINGCOLORFUNCTIONS extension (strlennocol measures length of string with color chars removed (useful for centering text), strdecolorize returns a string with color codes stripped)

------------------------------------------------------------------------
r6625 | havoc | 2006-11-24 21:32:54 +0100 (Fri, 24 Nov 2006) | 2 lines

added proper support for q3 shader animmap commands

------------------------------------------------------------------------
r6624 | havoc | 2006-11-23 20:35:52 +0100 (Thu, 23 Nov 2006) | 2 lines

cleaned up GL_DepthTest and GL_CULL_FACE state management (by adding GL_CullFace), may fix some problems with rtlighting on EF_NODEPTHTEST entities

------------------------------------------------------------------------
r6622 | havoc | 2006-11-23 01:06:38 +0100 (Thu, 23 Nov 2006) | 2 lines

added DP_ASINACOSATANATAN2TAN extension which adds common trig functions missing from standard QuakeC

------------------------------------------------------------------------
r6621 | havoc | 2006-11-17 16:47:22 +0100 (Fri, 17 Nov 2006) | 2 lines

added #define _FILE_OFFSET_BITS 64 to reduce problems with video recording on 32bit unix platforms (64bit Linux builds do not seem to have problems with this to begin with)

------------------------------------------------------------------------
r6620 | havoc | 2006-11-15 12:23:55 +0100 (Wed, 15 Nov 2006) | 3 lines

made cl_viewmodel_scale apply to csqc and gettaginfo
fixed bug with concat order in stereo rendering (it was offseting along X in worldspace due to wrong concat order)

------------------------------------------------------------------------
r6619 | havoc | 2006-11-15 10:33:22 +0100 (Wed, 15 Nov 2006) | 3 lines

fixed view location bugs in csqc; it was reading the player entity's render.origin field, which was broken...  removed the origin and angles fields from entity_render_t and eliminated all references
renamed CL_BoundingBoxForEntity to CL_UpdateRenderEntity and made it update the entity_render_t inversematrix and scale according to the matrix, and also calls R_LerpAnimation, this reduced code elsewhere

------------------------------------------------------------------------
r6618 | havoc | 2006-11-12 13:55:06 +0100 (Sun, 12 Nov 2006) | 2 lines

patch from div0 to fix a segfault in curl support when canceling a file that isn't being downloaded

------------------------------------------------------------------------
r6617 | havoc | 2006-11-09 11:16:16 +0100 (Thu, 09 Nov 2006) | 2 lines

patch from div0 that removes connect flood ban when a player disconnects (this prevents people from getting connect-flood-banned for simply reconnecting after a pk3 autodownload in Nexuiz)

------------------------------------------------------------------------
r6616 | havoc | 2006-11-06 09:48:43 +0100 (Mon, 06 Nov 2006) | 2 lines

found MATRIX4x4_OPENGLORIENTATION to be a speed loss using gcc 4.1.0 with x86_64 architecture, disabled it by default

------------------------------------------------------------------------
r6615 | havoc | 2006-11-06 09:25:26 +0100 (Mon, 06 Nov 2006) | 2 lines

implemented MATRIX4X4_OPENGLORIENTATION #define option, this is on by default and may improve performance compared to the D3D-style matrix orientation that was used before

------------------------------------------------------------------------
r6614 | havoc | 2006-11-06 09:23:43 +0100 (Mon, 06 Nov 2006) | 2 lines

changed md3 tag storage to be the original float[12] OpenGL-orientation format rather than a matrix4x4 which was wasting some space

------------------------------------------------------------------------
r6613 | havoc | 2006-11-06 08:31:00 +0100 (Mon, 06 Nov 2006) | 2 lines

more cleaning of matrix4x4_t struct access

------------------------------------------------------------------------
r6612 | havoc | 2006-11-06 07:13:54 +0100 (Mon, 06 Nov 2006) | 3 lines

cleaned up almost all direct indexing of matrix4x4_t structures to go through proper Matrix4x4 functions
removed some weird scaling code in gettaginfo QC builtin

------------------------------------------------------------------------
r6609 | havoc | 2006-10-23 12:34:09 +0200 (Mon, 23 Oct 2006) | 4 lines

implemented connect flood blocking (100% effective on connect floods with an interval of 5 seconds or less between connects from the same IP address, and limits connect floods slower than that to occupying 2 slots at once due to a 10 second timeout)
cleaned up connect packet handling code to be more readable and consistent
reenabled rejoin code (allowing players to resume the game if their client crashes crashes but comes back with the same port number - rather rare unless cl_port is used, but could help people who do use cl_port)

------------------------------------------------------------------------
r6608 | havoc | 2006-10-23 12:22:07 +0200 (Mon, 23 Oct 2006) | 2 lines

got rid of cl.qw_spectator flag because it can be determined by cl.scores[cl.playerentity].qw_spectator instead

------------------------------------------------------------------------
r6607 | havoc | 2006-10-20 17:57:17 +0200 (Fri, 20 Oct 2006) | 2 lines

attempt to avoid some Mem_Free errors on NULL pointers if there are no surfaces in the map

------------------------------------------------------------------------
r6606 | havoc | 2006-10-20 17:16:19 +0200 (Fri, 20 Oct 2006) | 2 lines

don't crash in scoreboard code when connected to a qw server as a spectator

------------------------------------------------------------------------
r6605 | havoc | 2006-10-18 11:08:50 +0200 (Wed, 18 Oct 2006) | 2 lines

fix bug with autosprite shaders when deformvertexes is applied twice during render of the same batch (why?  dunno, but it shouldn't break like this!)

------------------------------------------------------------------------
r6604 | havoc | 2006-10-18 05:52:49 +0200 (Wed, 18 Oct 2006) | 2 lines

added vid_stereobuffer cvar based on patch from syschuck on the alientrap forums

------------------------------------------------------------------------
r6603 | havoc | 2006-10-18 05:45:23 +0200 (Wed, 18 Oct 2006) | 2 lines

some clean up of math used to generate trace start/end in prydon cursor code

------------------------------------------------------------------------
r6602 | havoc | 2006-10-18 05:34:34 +0200 (Wed, 18 Oct 2006) | 2 lines

added cl_viewmodel_scale cvar which controls gun model size

------------------------------------------------------------------------
r6597 | havoc | 2006-10-03 22:22:58 +0200 (Tue, 03 Oct 2006) | 2 lines

added snd_soundradius cvar (default 1000 as before) to allow games (Nexuiz for instance) and people (mostly fans of dos quake's different sound radius) to adjust the sound radius

------------------------------------------------------------------------
r6596 | havoc | 2006-09-30 22:52:54 +0200 (Sat, 30 Sep 2006) | 2 lines

implemented condump command (I was told by [515] that he implemented this command but he never sent me the code in his patch and so I was incorrectly under the impression that it was in the engine)

------------------------------------------------------------------------
r6595 | havoc | 2006-09-20 08:37:04 +0200 (Wed, 20 Sep 2006) | 2 lines

fixed a (hopefully rare) bug affecting shalrath missiles which caused multiple missiles to explode on successive frames due to the large bounding boxes of the MOVETYPE_FLYMISSILE explosions causing a touch event on the other flying missiles that were not yet near the player, which caused them to explode even though they were being touched by an explosion that was SOLID_NOT

------------------------------------------------------------------------
r6594 | havoc | 2006-09-19 10:45:13 +0200 (Tue, 19 Sep 2006) | 2 lines

fix bug that often made enforcer laser bolts 'stick' in the air if a player is standing right next to the enforcer when it fires, this was due to some internal confusion over what constitutes a 'startsolid' case, this has been clarified so that SV_PushEntity only uses trace.bmodelstartsolid, just like the toss/bounce/fly/flymissile/bouncemissile physics expect

------------------------------------------------------------------------
r6593 | havoc | 2006-09-19 07:12:07 +0200 (Tue, 19 Sep 2006) | 2 lines

added GAME_DARSANA and GAME_CONTAGIONTHEORY

------------------------------------------------------------------------
r6592 | havoc | 2006-09-16 12:42:44 +0200 (Sat, 16 Sep 2006) | 2 lines

disabled junk tag writer that I wrote for byte by byte comparisons to mencoder-processed copies of my AVI files

------------------------------------------------------------------------
r6591 | havoc | 2006-09-16 12:40:17 +0200 (Sat, 16 Sep 2006) | 2 lines

removed some unused variables

------------------------------------------------------------------------
r6590 | havoc | 2006-09-16 12:25:05 +0200 (Sat, 16 Sep 2006) | 4 lines

removed video capture formats other than AVI I420 as it is the only useful format in practice (lots of jpeg/tga files is annoying to deal with, and few programs support rgb/yv12 raw dumps), this means no more .wav saving either and cleans the code a bit
fixed several bugs in sound system when saving avi (lingering .wav code)
added cl_capturevideo_realtime cvar to allow realtime capture if desired (requires a fast machine and can have A/V sync issues)

------------------------------------------------------------------------
r6589 | havoc | 2006-09-16 11:52:43 +0200 (Sat, 16 Sep 2006) | 2 lines

496

------------------------------------------------------------------------
r6588 | havoc | 2006-09-16 11:50:21 +0200 (Sat, 16 Sep 2006) | 2 lines

implemented direct AVI video capture using the I420 colorspace (aka Intel(r) 4:2:0 codec) with interleaved PCM audio, and would like to thank Microsoft(r) for wasting many hours of my time with AVI format insanity

------------------------------------------------------------------------
r6587 | havoc | 2006-09-16 10:40:15 +0200 (Sat, 16 Sep 2006) | 2 lines

changed VM_fopen and VM_fclose announcements to require developer >= 100 like the VM_fputs/VM_fgets functions do, and made them console prints instead of VM_Warning calls (not sure why they were to begin with)

------------------------------------------------------------------------
r6586 | havoc | 2006-09-15 04:07:09 +0200 (Fri, 15 Sep 2006) | 2 lines

hide warnings about missing gfx/crosshair* images

------------------------------------------------------------------------
r6585 | black | 2006-09-13 23:07:04 +0200 (Wed, 13 Sep 2006) | 5 lines

Try to fix a dedicated server crash by moving the two csqc_ cvar initializations
into SV_Init. This is a hack, however, so someone else please clean this up :)
The VM's internal name now is always "client", so this should make life easier
when debugging (note: this doesn't affect the progs filename used).

------------------------------------------------------------------------
r6584 | havoc | 2006-09-12 09:22:40 +0200 (Tue, 12 Sep 2006) | 2 lines

changed deluxemapping detection code to deal with odd bsp files produced by q3map2 that contain two lightmaps but the second one is completely unused and blank and thus not suitable as a deluxemap, this fixes black (or very dim) surfaces in some small maps when GLSL is enabled

------------------------------------------------------------------------
r6583 | havoc | 2006-09-12 08:17:54 +0200 (Tue, 12 Sep 2006) | 2 lines

moved VM_FILES and VM_SEARCHLIST stuff to prvm_prog_t

------------------------------------------------------------------------
r6582 | havoc | 2006-09-12 07:56:26 +0200 (Tue, 12 Sep 2006) | 2 lines

remove some unsafe optimizations in VM_Files_Init and VM_Files_CloseAll (using memset on the return value of an indexing macro is generally a bad idea, and doesn't improve code readability)

------------------------------------------------------------------------
r6581 | havoc | 2006-09-12 06:35:31 +0200 (Tue, 12 Sep 2006) | 2 lines

increased PRVM_MAX_STACK_DEPTH and PRVM_LOCALSTACK_SIZE at div0's request to reduce qc crashes with recursive rocket explosions in Nexuiz

------------------------------------------------------------------------
r6577 | havoc | 2006-09-01 11:35:38 +0200 (Fri, 01 Sep 2006) | 2 lines

changed description for gl_finish cvar according to esteel's suggestion

------------------------------------------------------------------------
r6576 | havoc | 2006-08-29 14:58:45 +0200 (Tue, 29 Aug 2006) | 2 lines

another patch from div0 to improve ping parsing behavior in the event that multiple ping reports are received after a query (due to packets backlogging)

------------------------------------------------------------------------
r6575 | havoc | 2006-08-29 06:50:40 +0200 (Tue, 29 Aug 2006) | 2 lines

another patch from div0 to fix ping report parsing

------------------------------------------------------------------------
r6574 | havoc | 2006-08-27 12:13:24 +0200 (Sun, 27 Aug 2006) | 3 lines

patch from div0 to fix ping report parsing where the first player slots are empty
fixed bug in negative ping parser (it was not skipping the - when it was negative)

------------------------------------------------------------------------
r6573 | havoc | 2006-08-27 11:23:07 +0200 (Sun, 27 Aug 2006) | 2 lines

greatly improved chances of connecting to a proquake server on the first try, by sending an svc_nop immediately upon connect

------------------------------------------------------------------------
r6572 | havoc | 2006-08-27 10:53:29 +0200 (Sun, 27 Aug 2006) | 2 lines

fix bug with gun bobbing in demo playback (where input packets are not sent, and thus the prediction replay was not occurring...)

------------------------------------------------------------------------
r6571 | havoc | 2006-08-27 10:52:53 +0200 (Sun, 27 Aug 2006) | 2 lines

fix a bug with the divide by zero warning in the QC VM, it was not updating the relevant xfunction/xstatement variables

------------------------------------------------------------------------
r6570 | havoc | 2006-08-27 10:20:44 +0200 (Sun, 27 Aug 2006) | 2 lines

changed default timeformat (related to timestamps cvar for logging)

------------------------------------------------------------------------
r6569 | sajt | 2006-08-26 10:41:31 +0200 (Sat, 26 Aug 2006) | 2 lines

Fix for people with proper compilers :)

------------------------------------------------------------------------
r6568 | havoc | 2006-08-26 09:02:49 +0200 (Sat, 26 Aug 2006) | 7 lines

CSQC fixes (less broken, still not spec compliant)
CSQC can now link the same entity multiple times (each time modified differently) as per the CSQC spec (this is mainly useful for rendering multi-model players based on one csqc entity, like Quake3's cgame does)
changed DrawQ functions to automatically set up 2D rendering if previous rendering was of a 3D view (necessary change for proper CSQC support)
changed QuakeC rint builtin implementation to handle very large values (outside of int range) and possibly run a little bit faster, note that it still rounds toward the nearest integer, away from zero (as intended)
refactored gun bob, damage kick fade, and stair smoothing code to eliminate a 'multiple fade steps per frame' bug
renamed the misnamed VM_ftoi function to VM_ftoe, in accordance with the menu QC builtin ftoe

------------------------------------------------------------------------
r6567 | havoc | 2006-08-25 17:33:33 +0200 (Fri, 25 Aug 2006) | 2 lines

accidentally removed -fno-strict-aliasing

------------------------------------------------------------------------
r6566 | havoc | 2006-08-25 14:48:54 +0200 (Fri, 25 Aug 2006) | 2 lines

fix csqc support on dedicated servers (now CRC's the csqc_progname file at level start and sends that to clients, so it does not need to actually load the csqc_progname itself)

------------------------------------------------------------------------
r6565 | havoc | 2006-08-25 14:27:02 +0200 (Fri, 25 Aug 2006) | 2 lines

fix the jittery gun bug related to onground changing rapidly

------------------------------------------------------------------------
r6564 | havoc | 2006-08-25 14:18:13 +0200 (Fri, 25 Aug 2006) | 2 lines

disabled support for csqc entities in CL_SelectTraceLine

------------------------------------------------------------------------
r6563 | havoc | 2006-08-25 10:53:39 +0200 (Fri, 25 Aug 2006) | 2 lines

changed release optimizations from -O2 -ffast-math -funroll-loops to simply -O2, this produced a 0.3% fps loss in my most extreme testing on x86_64, which does not seem significant, and gcc 4.1.0 was breaking the Nexuiz menu with the -funsafe-math-optimizations option (part of -ffast-math)

------------------------------------------------------------------------
r6562 | black | 2006-08-21 13:19:41 +0200 (Mon, 21 Aug 2006) | 2 lines

Fix a stupid typo in the sbar's ctf flag icon filenames.

------------------------------------------------------------------------
r6561 | havoc | 2006-08-21 09:40:40 +0200 (Mon, 21 Aug 2006) | 2 lines

nexuiz hud change to show flag status in CTF

------------------------------------------------------------------------
r6560 | havoc | 2006-08-19 06:25:06 +0200 (Sat, 19 Aug 2006) | 2 lines

patch from div to fix icc warnings

------------------------------------------------------------------------
r6559 | havoc | 2006-08-16 09:17:21 +0200 (Wed, 16 Aug 2006) | 2 lines

changed several '^' checks to STRING_COLOR_TAG as they should be

------------------------------------------------------------------------
r6558 | havoc | 2006-08-16 09:13:29 +0200 (Wed, 16 Aug 2006) | 3 lines

reorganized Host_Init a bit, merged away a few functions (such as COM_CheckRegistered and COM_InitArgv) and changed some others, now registers several cvars earlier in the startup process
integrated patch from div0 for sys_colortranslation and sys_specialcharactertranslation cvars which control the translation of color codes and Quake characters for terminal output on stdout, this gets rid of the hideous ^7 on every line and makes colored text show up properly using ANSI color codes on most platforms (on windows the color codes are simply stripped because ANSI is not supported by windows terminals)

------------------------------------------------------------------------
r6557 | havoc | 2006-08-15 01:46:30 +0200 (Tue, 15 Aug 2006) | 2 lines

no longer has time or team columns in non-QW games

------------------------------------------------------------------------
r6556 | havoc | 2006-08-15 00:55:34 +0200 (Tue, 15 Aug 2006) | 2 lines

patch from div0: clamp "ping" reply valies in 0..9999 to prevent misparsing in case of uninitialized ping values

------------------------------------------------------------------------
r6555 | havoc | 2006-08-15 00:54:32 +0200 (Tue, 15 Aug 2006) | 2 lines

patch from div0: Send download requirements at an earlier time to cause less message spam with the disconnect-and-reconnect download method

------------------------------------------------------------------------
r6554 | havoc | 2006-08-15 00:54:01 +0200 (Tue, 15 Aug 2006) | 2 lines

oops forgot this from the cd loop/play named tracks patch

------------------------------------------------------------------------
r6553 | havoc | 2006-08-15 00:53:15 +0200 (Tue, 15 Aug 2006) | 6 lines

patch from div0:
instead of downloading in game and reloading the map when it is done (which
caused crashes because of multiple world models in the model list and didn't
also reload sounds and models), disconnect while downloading and execute the
connect command to reconnect later

------------------------------------------------------------------------
r6552 | havoc | 2006-08-15 00:51:43 +0200 (Tue, 15 Aug 2006) | 10 lines

patch from div0:
fix console weirdnesses:
* empty lines kill command history (instead don't add empty lines to the history)
* cursor position and history line length were done the wrong way, positioning
  the cursor outside of the line or only recalling part of a line

NOTE: maybe it is better to move the Con_Printf BELOW the return so an empty
prompt isn't even displayed? bash does not do it like that, IRC clients do it
like that, and personally I don't care

------------------------------------------------------------------------
r6551 | havoc | 2006-08-15 00:49:49 +0200 (Tue, 15 Aug 2006) | 2 lines

patch from div0: cd loop and cd play commands now support named tracks (explicitly specifying a music track to play) as well as numbered (cd/fake cd)

------------------------------------------------------------------------
r6549 | havoc | 2006-08-14 07:14:24 +0200 (Mon, 14 Aug 2006) | 2 lines

reenabled the quake 'fall out of level' bug, to make the scorpion near the start of hip1m2 fall out of the ceiling as it was meant to (this probably fixes a lot of other bugs in various broken maps)

------------------------------------------------------------------------
r6548 | havoc | 2006-08-10 11:35:30 +0200 (Thu, 10 Aug 2006) | 2 lines

494

------------------------------------------------------------------------
r6545 | havoc | 2006-08-05 22:03:21 +0200 (Sat, 05 Aug 2006) | 2 lines

hush warnings about strcat and other redefinitions by undefining them first

------------------------------------------------------------------------
r6544 | molivier | 2006-08-05 14:31:03 +0200 (Sat, 05 Aug 2006) | 2 lines

Removed all calls to strcpy; most of them are now calls to strlcpy or memcpy.

------------------------------------------------------------------------
r6543 | molivier | 2006-08-05 14:30:03 +0200 (Sat, 05 Aug 2006) | 2 lines

The inclusion of pthread.h was missing

------------------------------------------------------------------------
r6542 | molivier | 2006-08-04 13:37:32 +0200 (Fri, 04 Aug 2006) | 2 lines

Replaced all calls to str[n]cat and strncpy by calls to strlcat and strlcpy respectively

------------------------------------------------------------------------
r6541 | havoc | 2006-08-03 17:25:42 +0200 (Thu, 03 Aug 2006) | 2 lines

fix memory alignment issue when saving odd-width screenshots (set GL_PACK_ALIGNMENT to 1), thanks div0

------------------------------------------------------------------------
r6540 | havoc | 2006-07-31 20:39:19 +0200 (Mon, 31 Jul 2006) | 2 lines

more tweaks trying to improve precision on q3map2-compiled terrain models in q3bsp

------------------------------------------------------------------------
r6539 | havoc | 2006-07-31 15:57:42 +0200 (Mon, 31 Jul 2006) | 2 lines

trying to improve terrain collision brush issues in q3bsp

------------------------------------------------------------------------
r6538 | havoc | 2006-07-31 12:00:45 +0200 (Mon, 31 Jul 2006) | 2 lines

added gamepad/joystick support to the SDL client, this uses completely different cvars from the windows one, and is noticably less weird as a result :)

------------------------------------------------------------------------
r6537 | havoc | 2006-07-31 11:59:14 +0200 (Mon, 31 Jul 2006) | 2 lines

improved plane distance epsilon checking and improved precision when converting brush planes to polygons (by finding a roughly minimal bounding box for the plane to polygon projection), this should reduce collision brush issues on modeled terrain in q3bsp maps

------------------------------------------------------------------------
r6535 | havoc | 2006-07-26 15:57:58 +0200 (Wed, 26 Jul 2006) | 2 lines

491

------------------------------------------------------------------------
r6534 | havoc | 2006-07-26 15:51:03 +0200 (Wed, 26 Jul 2006) | 2 lines

fixed an improperly filed change request

------------------------------------------------------------------------
r6533 | havoc | 2006-07-26 15:43:53 +0200 (Wed, 26 Jul 2006) | 2 lines

495

------------------------------------------------------------------------
r6532 | black | 2006-07-26 12:35:38 +0200 (Wed, 26 Jul 2006) | 3 lines

'Catch' divisions by zero in the VM:
print a warning if developer >= 1 and return 0.0 as result of the operation.

------------------------------------------------------------------------
r6531 | havoc | 2006-07-26 07:24:48 +0200 (Wed, 26 Jul 2006) | 2 lines

498

------------------------------------------------------------------------
r6530 | havoc | 2006-07-26 07:19:31 +0200 (Wed, 26 Jul 2006) | 2 lines

use VM_Warning instead of Con_Printf+PRVM_PrintState

------------------------------------------------------------------------
r6529 | havoc | 2006-07-26 07:16:42 +0200 (Wed, 26 Jul 2006) | 4 lines

changed PF_WARNING to not do a return
changed PF_WARNING define to VM_Warning function
changed Con_Printf warnings in QC builtins to VM_Warning calls

------------------------------------------------------------------------
r6526 | havoc | 2006-07-25 12:38:17 +0200 (Tue, 25 Jul 2006) | 2 lines

print out profile report above runaway loop counter error

------------------------------------------------------------------------
r6525 | havoc | 2006-07-25 08:33:48 +0200 (Tue, 25 Jul 2006) | 2 lines

enabled player scoreboard in coop (note that this overrides the intermission screen)

------------------------------------------------------------------------
r6524 | havoc | 2006-07-24 06:03:36 +0200 (Mon, 24 Jul 2006) | 3 lines

some cleanups and improved warnings
added Prydon campaign to multiplayer setup menu, fixed a bizarre crash in game episode lookup code by rewriting it

------------------------------------------------------------------------
r6523 | havoc | 2006-07-23 13:41:34 +0200 (Sun, 23 Jul 2006) | 2 lines

Mathieu should have set the snd_* cvars properly, not poking .integer

------------------------------------------------------------------------
r6522 | havoc | 2006-07-23 13:00:35 +0200 (Sun, 23 Jul 2006) | 2 lines

disabled WAVE_FORMAT_EXTENSIBLE support as it does not seem to be working

------------------------------------------------------------------------
r6521 | havoc | 2006-07-22 12:36:47 +0200 (Sat, 22 Jul 2006) | 2 lines

added libpng.so fallback name, primarily for FreeBSD

------------------------------------------------------------------------
r6520 | havoc | 2006-07-22 00:55:51 +0200 (Sat, 22 Jul 2006) | 2 lines

remove testing prints (forgot to remove them before commiting)

------------------------------------------------------------------------
r6519 | havoc | 2006-07-21 12:19:31 +0200 (Fri, 21 Jul 2006) | 2 lines

fix bug with items in a trap door in the ceiling in some usermade maps that made them ride the door panels into the walls rather than fall

------------------------------------------------------------------------
r6518 | havoc | 2006-07-21 09:16:18 +0200 (Fri, 21 Jul 2006) | 2 lines

reverting DirectSound buffer position wrapping code to something similar to the old code (except using % instead of &)

------------------------------------------------------------------------
r6517 | havoc | 2006-07-20 06:29:54 +0200 (Thu, 20 Jul 2006) | 2 lines

changed SECONDARY_BUFFER_SIZE to be a multiple of 32768 so that it is roughly a power of 2...

------------------------------------------------------------------------
r6516 | havoc | 2006-07-19 11:44:04 +0200 (Wed, 19 Jul 2006) | 2 lines

471

------------------------------------------------------------------------
r6515 | havoc | 2006-07-19 06:50:45 +0200 (Wed, 19 Jul 2006) | 2 lines

changed Draw_CachePic to load both tga/png/jpg and lmp/wad images at once and take the pic size from the lmp/wad, and cleaned up parts of wad and lmp loading, eliminated SwapPic

------------------------------------------------------------------------
r6514 | havoc | 2006-07-19 00:27:06 +0200 (Wed, 19 Jul 2006) | 2 lines

don't crash if r_restart is used in startup scripts before anything starts the video system (fixed this by starting video system in r_restart if necessary)

------------------------------------------------------------------------
r6513 | havoc | 2006-07-18 01:24:30 +0200 (Tue, 18 Jul 2006) | 2 lines

enabled old quake-style connection/query packets when hosting servers for old protocols, this should allow DP to host compatible NQ servers and such

------------------------------------------------------------------------
r6512 | havoc | 2006-07-18 01:19:46 +0200 (Tue, 18 Jul 2006) | 2 lines

fix a buffer overflow bug in InfoString_SetValue (thanks div0!), and increase userinfo and serverinfo strings to 1280 bytes each (from 196 and 512 respectively)

------------------------------------------------------------------------
r6511 | havoc | 2006-07-10 09:56:26 +0200 (Mon, 10 Jul 2006) | 2 lines

added detection of 4 more surfaceparms to hush warnings

------------------------------------------------------------------------
r6510 | havoc | 2006-07-10 09:35:06 +0200 (Mon, 10 Jul 2006) | 2 lines

changed how ping report hiding operates, so that it only hides one ping report for each ping command issued by the scoreboard

------------------------------------------------------------------------
r6509 | havoc | 2006-07-10 08:58:17 +0200 (Mon, 10 Jul 2006) | 2 lines

fix bug where realtime was used instead of cl.time in player times on scoreboard

------------------------------------------------------------------------
r6508 | havoc | 2006-07-09 11:54:52 +0200 (Sun, 09 Jul 2006) | 2 lines

added bestweapon command

------------------------------------------------------------------------
r6507 | havoc | 2006-07-09 10:34:39 +0200 (Sun, 09 Jul 2006) | 2 lines

added ping and status command output parsing in the client, currently this is used to get pings in the scoreboard on Quake servers (and of course older DP servers), the server sends a pingplreport command after the human-readable ping report so that the packet loss display works (but only if the server supports this), changed client to send ping command instead of pings (at least until the next protocol version increase) and the client will not print ping report messages while the scoreboard is displayed.  the status command parsing is not actually used at this time but could be the basis of iplog support

------------------------------------------------------------------------
r6506 | havoc | 2006-07-09 10:28:43 +0200 (Sun, 09 Jul 2006) | 2 lines

cleaned up cl_netinputpacketspersecond code a little for more readability (no change in behavior)

------------------------------------------------------------------------
r6505 | havoc | 2006-07-08 11:34:54 +0200 (Sat, 08 Jul 2006) | 2 lines

hide ping and packetloss displays if the values are both 0 (bots and local player for instance)

------------------------------------------------------------------------
r6504 | havoc | 2006-07-08 11:24:58 +0200 (Sat, 08 Jul 2006) | 3 lines

added ping and packet loss display to scoreboard, and pings/pingplreport commands to make it work without changing protocol and without breaking demo compatibility either, this can work on any server that supports the pings command and replies with pingplreport
revised scoreboard layout and added column titles above it

------------------------------------------------------------------------
r6503 | molivier | 2006-07-08 10:59:55 +0200 (Sat, 08 Jul 2006) | 2 lines

Added 3D sound support to the Win32 backend (DirectSound and MMSYSTEM), i.e. to the WGL version

------------------------------------------------------------------------
r6502 | havoc | 2006-07-07 06:19:55 +0200 (Fri, 07 Jul 2006) | 2 lines

changed most COM_ParseToken calls to COM_ParseTokenConsole, this fixed the kills listing in the savegame menu

------------------------------------------------------------------------
r6501 | havoc | 2006-07-07 06:19:05 +0200 (Fri, 07 Jul 2006) | 2 lines

whitespace on blank lines removed

------------------------------------------------------------------------
r6499 | havoc | 2006-07-04 09:03:18 +0200 (Tue, 04 Jul 2006) | 2 lines

fixed transfusion data check (the mainmenu item numbering starts at 1, not 0)

------------------------------------------------------------------------
r6498 | molivier | 2006-07-03 21:46:07 +0200 (Mon, 03 Jul 2006) | 2 lines

Cleaned the ugly code I committed for DP_FS_BASEDIR support (the environment variable is now only defined when needed)

------------------------------------------------------------------------
r6496 | havoc | 2006-07-03 09:31:55 +0200 (Mon, 03 Jul 2006) | 2 lines

fix issue with DP_FS_BASEDIR on Mac

------------------------------------------------------------------------
r6495 | havoc | 2006-07-03 03:31:21 +0200 (Mon, 03 Jul 2006) | 2 lines

made nexuiz missing data fallback menu apply to all games when their main menu image is missing (the Open Console and Quit options are more useful than a bunch of checker squares)

------------------------------------------------------------------------
r6494 | havoc | 2006-07-03 02:56:42 +0200 (Mon, 03 Jul 2006) | 2 lines

force a gamma update if v_hwgamma value changes between 1 and 2

------------------------------------------------------------------------
r6493 | havoc | 2006-07-03 02:11:03 +0200 (Mon, 03 Jul 2006) | 2 lines

added v_hwgamma 2 (forced gamma, ignores driver returning failure) for testing

------------------------------------------------------------------------
r6492 | havoc | 2006-07-03 02:02:30 +0200 (Mon, 03 Jul 2006) | 3 lines

clean up of FL_ONGROUND checks in MOVE_TOSS/FLY/FLYMISSILE/BOUNCE/BOUNCEMISSILE/STEP code, this fixes items and monsters sometimes being left floating in the air after a trap door opens or when riding a func_train (most notably in the lava room of r1m5 of mission pack 2)
added sv_gameplayfix_upwardvelocityclearsongroundflag cvar to allow the upward velocity gameplay fix to be disabled if desired

------------------------------------------------------------------------
r6491 | havoc | 2006-07-03 00:50:20 +0200 (Mon, 03 Jul 2006) | 2 lines

fixed DP_FS_BASEDIR passing to gcc by adding single quotes around the entire contents of the -D parameter

------------------------------------------------------------------------
r6490 | sajt | 2006-07-01 00:45:58 +0200 (Sat, 01 Jul 2006) | 2 lines

Patch from div0 to fix autosprite

------------------------------------------------------------------------
r6489 | sajt | 2006-06-28 10:30:26 +0200 (Wed, 28 Jun 2006) | 2 lines

Patch from div0 to fix skyboxes in downloaded maps

------------------------------------------------------------------------
r6488 | sajt | 2006-06-28 10:11:31 +0200 (Wed, 28 Jun 2006) | 2 lines

Fixed a bug in Matrix4x4_CopyTranslateOnly... which is never called. Oh well.

------------------------------------------------------------------------
r6487 | molivier | 2006-06-25 19:42:37 +0200 (Sun, 25 Jun 2006) | 2 lines

Removed the extra definitions of hton[sl] and ntoh[sl] since apparently they are not necessary on any platform DP supports

------------------------------------------------------------------------
r6486 | molivier | 2006-06-25 19:35:17 +0200 (Sun, 25 Jun 2006) | 2 lines

You can now set a different default base directory at compile time, by defining DP_FS_BASEDIR to the new value (ex: make DP_FS_BASEDIR=/usr/local/games/quake release)

------------------------------------------------------------------------
r6485 | molivier | 2006-06-25 19:00:07 +0200 (Sun, 25 Jun 2006) | 2 lines

Decreased the OSS buffer size, and cleaned some code

------------------------------------------------------------------------
r6484 | molivier | 2006-06-23 21:51:29 +0200 (Fri, 23 Jun 2006) | 2 lines

The name of the SDL config program used by the makefiles is now configurable thanks to the SDL_CONFIG variable (ex: make SDL_CONFIG=sdl11-config sdl-release). Its default value is "sdl-config"

------------------------------------------------------------------------
r6483 | havoc | 2006-06-23 08:31:32 +0200 (Fri, 23 Jun 2006) | 2 lines

fix gamma 'flicker' bug caused by gamma_forcenextframe being repeatedly set when gamma fails

------------------------------------------------------------------------
r6482 | havoc | 2006-06-22 07:58:02 +0200 (Thu, 22 Jun 2006) | 2 lines

fix some stupid bugs in gamma update code (why didn't I remove the forcenextframe variable?)

------------------------------------------------------------------------
r6481 | molivier | 2006-06-20 21:38:20 +0200 (Tue, 20 Jun 2006) | 2 lines

Made S_ChooseCheaperFormat() a bit smarter

------------------------------------------------------------------------
r6480 | molivier | 2006-06-15 08:13:08 +0200 (Thu, 15 Jun 2006) | 2 lines

Fixed OGG Vorbis code when using OGGs with a sound frequency smaller than the sound output frequency (the code was wrongly using the OGG sound format instead of the output sound format to compute the streaming buffer size). Thanks to Dresk for reporting this problem

------------------------------------------------------------------------
r6479 | havoc | 2006-06-14 18:22:11 +0200 (Wed, 14 Jun 2006) | 2 lines

reduce runaway loop counter limit from 1 billion to 10 million, as 1 billion takes a while

------------------------------------------------------------------------
r6478 | havoc | 2006-06-14 15:48:27 +0200 (Wed, 14 Jun 2006) | 2 lines

added a section on replacement content, and some other edits

------------------------------------------------------------------------
r6477 | havoc | 2006-06-13 18:25:55 +0200 (Tue, 13 Jun 2006) | 2 lines

made FromString reject empty strings

------------------------------------------------------------------------
r6476 | havoc | 2006-06-13 15:09:23 +0200 (Tue, 13 Jun 2006) | 2 lines

changed r_gls_deluxemapping 2 to not attempt to do fake deluxemapping on vertex lit surfaces

------------------------------------------------------------------------
r6475 | havoc | 2006-06-13 11:15:36 +0200 (Tue, 13 Jun 2006) | 2 lines

patch from div0 to make universal-binary builds of darkplaces possible on Mac OS X

------------------------------------------------------------------------
r6474 | havoc | 2006-06-12 23:25:29 +0200 (Mon, 12 Jun 2006) | 2 lines

modified VID_RestoreSystemGamma to force a gamma update on next frame (if it turned off hardware gamma temporarily)

------------------------------------------------------------------------
r6473 | havoc | 2006-06-12 23:24:48 +0200 (Mon, 12 Jun 2006) | 2 lines

don't set vid_activewindow to false in Map/Unmap events, just in FocusIn/FocusOut

------------------------------------------------------------------------
r6472 | havoc | 2006-06-12 22:24:27 +0200 (Mon, 12 Jun 2006) | 2 lines

check if master server address string is empty when sending heartbeats and master queries

------------------------------------------------------------------------
r6471 | havoc | 2006-06-12 14:43:47 +0200 (Mon, 12 Jun 2006) | 2 lines

updated GLSL shader to match the one in Nexuiz 2.0, this fixes reliefmapping/offsetmapping on models, and improves performance on NVIDIA by using more half-precision math

------------------------------------------------------------------------
r6470 | sajt | 2006-06-12 05:38:04 +0200 (Mon, 12 Jun 2006) | 2 lines

Added libcurl.[ch] to MSVC project files

------------------------------------------------------------------------
r6469 | havoc | 2006-06-12 01:24:18 +0200 (Mon, 12 Jun 2006) | 2 lines

added HDR bloom feature, not very different from bloom but looks better, runs a bit slower

------------------------------------------------------------------------
r6468 | havoc | 2006-06-11 17:35:41 +0200 (Sun, 11 Jun 2006) | 2 lines

don't allow $ expansion or sendcvar on rcon_password (added CVAR_PRIVATE flag for this purpose)

------------------------------------------------------------------------
r6467 | havoc | 2006-06-11 17:35:08 +0200 (Sun, 11 Jun 2006) | 2 lines

don't draw notify lines while r_letterbox is on

------------------------------------------------------------------------
r6466 | molivier | 2006-06-11 16:13:09 +0200 (Sun, 11 Jun 2006) | 2 lines

Fixed audio capture when the sound engine wasn't restarted right before the capture (thanks to FrikaC for reporting the bug)

------------------------------------------------------------------------
r6465 | havoc | 2006-06-11 15:50:25 +0200 (Sun, 11 Jun 2006) | 3 lines

removed crosshair_static cvar (now only the hud crosshair remains)
merged r_crosshairs.c into sbar.c

------------------------------------------------------------------------
r6464 | havoc | 2006-06-11 15:23:40 +0200 (Sun, 11 Jun 2006) | 2 lines

removed team colored crosshair feature, removed crosshair brightness cvar, renamed crosshair_alpha to crosshair_color_alpha

------------------------------------------------------------------------
r6463 | havoc | 2006-06-11 15:18:01 +0200 (Sun, 11 Jun 2006) | 2 lines

removed crosshair_flashspeed and crosshair_flashrange cvars (flashing is now gone)

------------------------------------------------------------------------
r6462 | havoc | 2006-06-11 15:12:07 +0200 (Sun, 11 Jun 2006) | 2 lines

changed the default crosshair textures to use greyscale instead of alpha fading

------------------------------------------------------------------------
r6461 | havoc | 2006-06-11 15:03:45 +0200 (Sun, 11 Jun 2006) | 2 lines

added crosshair_useteamcolor, crosshair_color_red, crosshair_color_green, and crosshair_color_blue cvars

------------------------------------------------------------------------
r6460 | havoc | 2006-06-11 14:46:07 +0200 (Sun, 11 Jun 2006) | 2 lines

fixed 'slow gravity' bug when cl_movement players are not replying to all server frames

------------------------------------------------------------------------
r6459 | molivier | 2006-06-11 11:30:59 +0200 (Sun, 11 Jun 2006) | 2 lines

Fixed the 5.1 speaker layout when using SDL on Win32 (thanks to Willis for the report)

------------------------------------------------------------------------
r6458 | molivier | 2006-06-10 20:22:20 +0200 (Sat, 10 Jun 2006) | 2 lines

Added snd_channellayout to configure the speaker layout dynamically (0: auto, 1: standard, 2: ALSA)

------------------------------------------------------------------------
r6457 | molivier | 2006-06-10 16:23:26 +0200 (Sat, 10 Jun 2006) | 2 lines

When we're recording a demo, we must not stop rendering sound even when the application becomes inactive

------------------------------------------------------------------------
r6456 | molivier | 2006-06-10 16:00:25 +0200 (Sat, 10 Jun 2006) | 2 lines

Removed some debug printings, and made some others requiring developer >= 100. Reset the soundcard after opening in the OSS module.

------------------------------------------------------------------------
r6455 | havoc | 2006-06-10 14:19:57 +0200 (Sat, 10 Jun 2006) | 2 lines

disabled the broken cl_autodemo feature until Sajt fixes it

------------------------------------------------------------------------
r6454 | havoc | 2006-06-09 19:30:56 +0200 (Fri, 09 Jun 2006) | 3 lines

changed cvar default setup code such that cvar default strings are locked after executing default.cfg the first time (that is to say, their current values are copied into their default strings at this point), this fixes unsaved cvar problems in nexuiz caused by the default string being out of date on cvars that were modified by default.cfg
changed Reset To Defaults option in menu to use a newly added cvar_resettodefaults_all command before execing default.cfg to reset the binds

------------------------------------------------------------------------
r6453 | havoc | 2006-06-09 15:50:50 +0200 (Fri, 09 Jun 2006) | 2 lines

trust the q3bsp NODRAW flag rather than the shader

------------------------------------------------------------------------
r6451 | havoc | 2006-06-09 11:49:36 +0200 (Fri, 09 Jun 2006) | 3 lines

don't allocate a mempool or texture pool if a model file is not found (prevents buildup of 'progs/beam.mdl' memory/texture pools if it is not found)
audited 'if mod->loaded' checks to be more sure about unloading models even if they failed to load

------------------------------------------------------------------------
r6450 | havoc | 2006-06-09 09:50:42 +0200 (Fri, 09 Jun 2006) | 2 lines

fixed another C99 lazy variable declaration bug in div0's physics patch

------------------------------------------------------------------------
r6449 | havoc | 2006-06-09 09:35:41 +0200 (Fri, 09 Jun 2006) | 2 lines

another curl message patch from div0

------------------------------------------------------------------------
r6448 | havoc | 2006-06-09 09:34:12 +0200 (Fri, 09 Jun 2006) | 2 lines

libcurl.2.dylib is apparently compatible for our purposes and neatly adds Mac OS X Panther support

------------------------------------------------------------------------
r6447 | havoc | 2006-06-09 09:30:17 +0200 (Fri, 09 Jun 2006) | 2 lines

fix typo that caused crashes in detection of model animation in models with only one frame

------------------------------------------------------------------------
r6446 | havoc | 2006-06-09 09:04:40 +0200 (Fri, 09 Jun 2006) | 2 lines

another patch from div0 to curl messages

------------------------------------------------------------------------
r6445 | havoc | 2006-06-09 08:50:19 +0200 (Fri, 09 Jun 2006) | 2 lines

fix for continuously spewed curl error messages

------------------------------------------------------------------------
r6444 | havoc | 2006-06-09 07:28:07 +0200 (Fri, 09 Jun 2006) | 2 lines

oops, forgot these

------------------------------------------------------------------------
r6443 | havoc | 2006-06-09 04:03:34 +0200 (Fri, 09 Jun 2006) | 2 lines

web download patch from div0, this adds the "curl" console command, and the ability for servers to send a set of conditional curl commands which will download pk3 archives if specific files are missing

------------------------------------------------------------------------
r6442 | havoc | 2006-06-09 03:56:11 +0200 (Fri, 09 Jun 2006) | 2 lines

nexuiz prediction patch from div0, this adds two new cl_movement_airaccel_* cvars which change air control physics

------------------------------------------------------------------------
r6441 | molivier | 2006-06-08 23:39:20 +0200 (Thu, 08 Jun 2006) | 2 lines

The BSD audio module had the same bug as the OSS module (incorrectly reporting "audio can't keep up")

------------------------------------------------------------------------
r6440 | havoc | 2006-06-08 14:35:10 +0200 (Thu, 08 Jun 2006) | 2 lines

fixed r_drawportals

------------------------------------------------------------------------
r6439 | havoc | 2006-06-08 13:16:52 +0200 (Thu, 08 Jun 2006) | 2 lines

fixed collision bug on q3 light cones and other non-solid brushes that are not axial, now uses only the brush's supercontents value, not its surface textures

------------------------------------------------------------------------
r6438 | havoc | 2006-06-08 13:00:21 +0200 (Thu, 08 Jun 2006) | 2 lines

no longer converts vertex-morph model formats to float arrays, instead keeping their geometry in the original formats from disk, this saves 1.2MB of memory in e1m2 and might slightly improve load times, it also preserves vertex normals to get rid of shading artifacts on texcoord seams

------------------------------------------------------------------------
r6437 | havoc | 2006-06-08 12:57:55 +0200 (Thu, 08 Jun 2006) | 2 lines

added more image search paths so that md2 model skins load properly again, and to reduce problems for tenebrae model packs

------------------------------------------------------------------------
r6435 | havoc | 2006-06-07 10:49:56 +0200 (Wed, 07 Jun 2006) | 2 lines

don't crash if a quake button entity is on its alternate frames but doesn't actually have any to show

------------------------------------------------------------------------
r6434 | havoc | 2006-06-07 10:33:57 +0200 (Wed, 07 Jun 2006) | 2 lines

don't crash if key bindings functions are called with bogus keynums

------------------------------------------------------------------------
r6433 | havoc | 2006-06-07 10:33:21 +0200 (Wed, 07 Jun 2006) | 2 lines

fix a < 256 check that should have been < MAX_LIGHTSTYLES

------------------------------------------------------------------------
r6432 | havoc | 2006-06-07 08:34:11 +0200 (Wed, 07 Jun 2006) | 2 lines

ignore GL_EXT_texture3D extension if it reports a bogus GL_MAX_3D_TEXTURE_SIZE

------------------------------------------------------------------------
r6431 | havoc | 2006-06-07 08:30:49 +0200 (Wed, 07 Jun 2006) | 2 lines

extra check for gl_texture3d

------------------------------------------------------------------------
r6430 | havoc | 2006-06-07 08:28:30 +0200 (Wed, 07 Jun 2006) | 2 lines

fix typo

------------------------------------------------------------------------
r6429 | havoc | 2006-06-07 08:20:18 +0200 (Wed, 07 Jun 2006) | 2 lines

fix maps/ check to use 5 characters, not 4

------------------------------------------------------------------------
r6428 | havoc | 2006-06-07 08:19:54 +0200 (Wed, 07 Jun 2006) | 2 lines

prevent Image_MipReduce from getting stuck in an infinite loop on 3D textures

------------------------------------------------------------------------
r6427 | havoc | 2006-06-07 08:03:29 +0200 (Wed, 07 Jun 2006) | 2 lines

added stack trace printout to VM_remove warnings

------------------------------------------------------------------------
r6426 | havoc | 2006-06-07 08:02:59 +0200 (Wed, 07 Jun 2006) | 2 lines

don't save cvars that are at their default value

------------------------------------------------------------------------
r6425 | havoc | 2006-06-07 08:02:37 +0200 (Wed, 07 Jun 2006) | 2 lines

fixed an unregistered cvar

------------------------------------------------------------------------
r6424 | havoc | 2006-06-07 06:52:25 +0200 (Wed, 07 Jun 2006) | 2 lines

disabled loading of csprogs.dat if developer is less than 100

------------------------------------------------------------------------
r6423 | havoc | 2006-06-07 06:11:45 +0200 (Wed, 07 Jun 2006) | 2 lines

added DP_GFX_EXTERNALTEXTURES_PERMAP extension

------------------------------------------------------------------------
r6422 | havoc | 2006-06-06 13:12:52 +0200 (Tue, 06 Jun 2006) | 2 lines

commented out S_StartSound <whatever> not precached message because it happens constantly if the file could not be found

------------------------------------------------------------------------
r6421 | molivier | 2006-06-06 08:21:47 +0200 (Tue, 06 Jun 2006) | 2 lines

Attempt to fix speaker layout for 5.1 and 7.1 sound, on Windows and Mac OS X; the sound engine now builds its speaker layout based on the OS and the snd_swapstereo cvar. Plus a minor fix for the OSS sound module (was incorrectly reporting "audio can't keep up")

------------------------------------------------------------------------
r6420 | molivier | 2006-06-06 08:14:34 +0200 (Tue, 06 Jun 2006) | 2 lines

Use our usual defines for detecting the OS type

------------------------------------------------------------------------
r6416 | molivier | 2006-06-05 00:58:52 +0200 (Mon, 05 Jun 2006) | 2 lines

Fixed the "nosound" cvar. Thanks to Willis for having reported this bug

------------------------------------------------------------------------
r6415 | molivier | 2006-06-04 12:57:24 +0200 (Sun, 04 Jun 2006) | 25 lines

- the Linux sound modules (ALSA and OSS) are now write-based, instead of
mmap-based. It should fix the problems with inboard sound cards
- added 3 cvars controlling the sound output format: snd_speed,
snd_channels, and snd_width (default values: 48000, 2, and 2
respectively). They're saved in the config file.
- the checks for command line options and environment variables
modifying the sound output format are now common to all modules. The
command line options supported are: -sndmono, -sndstereo, -sndquad,
-sndspeed, and -sndbits. The environment variables supported are:
QUAKE_SOUND_CHANNELS, QUAKE_SOUND_SPEED, and QUAKE_SOUND_SAMPLEBITS.
- added a (still dumb) function to figure out a better sound format when
the initialization of the sound card failed
- sound modules can now suggest a sound format if the initialization of
the sound card failed
- you can now do a "snd_restart" while having modified snd_width and/or
snd_channel. Doing a snd_restart with a modified snd_speed isn't yet
supported, it will fall back to the previous speed
- The WGL video module was blocking the sound output when the
application window lost the focus. Now, this code is shared and the AGL,
GLX and SDL video modules implement such a mecanism
- A lot of minor fixes, changes, factorizations and rewrites all over
the sound engine code and its modules
- added CeilPowerOf2() in the math library
- fixed BSDmakefile for NetBSD

------------------------------------------------------------------------
r6414 | havoc | 2006-06-04 09:29:19 +0200 (Sun, 04 Jun 2006) | 2 lines

cl_bobmodel is now a saved cvar

------------------------------------------------------------------------
r6410 | havoc | 2006-06-01 08:59:30 +0200 (Thu, 01 Jun 2006) | 2 lines

removed TE_VORESPIKE, no idea how it came into existence and it was never used

------------------------------------------------------------------------
r6409 | havoc | 2006-05-30 22:53:57 +0200 (Tue, 30 May 2006) | 2 lines

don't allow runaway loops caused by Con_Print during notify/console drawing

------------------------------------------------------------------------
r6408 | havoc | 2006-05-30 12:42:21 +0200 (Tue, 30 May 2006) | 6 lines

fixed several crashes in video capture code when files fail to open
eliminated cl_capturevideo_sound cvar (now always on)
made sound capture non-realtime, by syncing sound mixer to capture frame while capture is active, this sounds horrible while recording but produces perfectly synced sound output to the .wav file
now numbers dpvideo files when saving, each one a higher number than the previous (the next number to use is saved to config), this allows capturing many short video clips without stopping to process the files
what this means: cl_capturevideo is now much more useful than before.

------------------------------------------------------------------------
r6407 | havoc | 2006-05-30 12:37:19 +0200 (Tue, 30 May 2006) | 2 lines

fix unintended use of alpha test on 2d graphics (hud/menu/etc)

------------------------------------------------------------------------
r6406 | molivier | 2006-05-29 13:59:46 +0200 (Mon, 29 May 2006) | 2 lines

Updated Dev-C++ project files

------------------------------------------------------------------------
r6405 | havoc | 2006-05-29 07:54:07 +0200 (Mon, 29 May 2006) | 2 lines

changed color control menu correction value to 0.5 (medium grey on linear color monitors)

------------------------------------------------------------------------
r6404 | havoc | 2006-05-29 07:51:24 +0200 (Mon, 29 May 2006) | 2 lines

fixed repeated gamma ramp setting attempts in case of failure (again)

------------------------------------------------------------------------
r6403 | havoc | 2006-05-28 23:19:45 +0200 (Sun, 28 May 2006) | 2 lines

fix bug that caused constant gamma ramp setting in windows in cases of failure

------------------------------------------------------------------------
r6402 | havoc | 2006-05-28 22:43:18 +0200 (Sun, 28 May 2006) | 2 lines

disable canjump check until it's fixed

------------------------------------------------------------------------
r6401 | havoc | 2006-05-28 21:38:41 +0200 (Sun, 28 May 2006) | 2 lines

further tweaks to prediction

------------------------------------------------------------------------
r6400 | havoc | 2006-05-28 21:36:23 +0200 (Sun, 28 May 2006) | 2 lines

fix a bug where dedicated servers might not respond to typing in the server console if no map is currently running (which is rare)

------------------------------------------------------------------------
r6399 | havoc | 2006-05-28 09:27:18 +0200 (Sun, 28 May 2006) | 2 lines

added a few more GLSL shader program setting calls in R_RenderScene just to prevent problems if a model/map rendering call leaves a GLSL program active

------------------------------------------------------------------------
r6398 | havoc | 2006-05-28 03:26:06 +0200 (Sun, 28 May 2006) | 2 lines

added sv_clmovement_* cvars to disable movement prediction of players, or disable it only when their ping is below a certain value (by default 100ms)

------------------------------------------------------------------------
r6397 | havoc | 2006-05-28 02:23:59 +0200 (Sun, 28 May 2006) | 2 lines

no longer sets model->loaded if the model file was not found, since the old Mod_CheckLoaded code is long gone

------------------------------------------------------------------------
r6396 | havoc | 2006-05-27 22:12:03 +0200 (Sat, 27 May 2006) | 2 lines

remove an unused variable

------------------------------------------------------------------------
r6395 | havoc | 2006-05-27 22:07:34 +0200 (Sat, 27 May 2006) | 2 lines

centering of notify lines in nexuiz now ignores color codes

------------------------------------------------------------------------
r6394 | havoc | 2006-05-27 21:58:53 +0200 (Sat, 27 May 2006) | 2 lines

centerprint no longer counts color codes when centering lines

------------------------------------------------------------------------
r6393 | havoc | 2006-05-26 05:09:02 +0200 (Fri, 26 May 2006) | 2 lines

don't hexdump png images while reading them (why did it do this??)

------------------------------------------------------------------------
r6392 | havoc | 2006-05-26 03:04:39 +0200 (Fri, 26 May 2006) | 2 lines

fix bug that was preventing rcon_address from working

------------------------------------------------------------------------
r6391 | havoc | 2006-05-26 03:00:09 +0200 (Fri, 26 May 2006) | 2 lines

implemented sv_gameplayfix_qwplayerphysics

------------------------------------------------------------------------
r6390 | havoc | 2006-05-26 01:46:11 +0200 (Fri, 26 May 2006) | 2 lines

fix a typo

------------------------------------------------------------------------
r6389 | havoc | 2006-05-26 01:28:03 +0200 (Fri, 26 May 2006) | 2 lines

try not to kick players for supposed speed cheating when float time degrades too much

------------------------------------------------------------------------
r6388 | havoc | 2006-05-26 01:27:24 +0200 (Fri, 26 May 2006) | 2 lines

fixed sv_waterfriction code so it is now used

------------------------------------------------------------------------
r6387 | havoc | 2006-05-26 01:22:06 +0200 (Fri, 26 May 2006) | 2 lines

added sv_waterfriction, sv_airaccelerate, sv_wateraccelerate cvars (and corresponding cl_movement_ cvars), now physics are about as configurable as quakeworld

------------------------------------------------------------------------
r6386 | havoc | 2006-05-25 09:48:33 +0200 (Thu, 25 May 2006) | 2 lines

patch from div0 that allows loading new pak/pk3 archives while running

------------------------------------------------------------------------
r6385 | havoc | 2006-05-25 09:41:38 +0200 (Thu, 25 May 2006) | 2 lines

patch from div0 that makes togglemenu support a parameter (either 1 or 0) to not toggle but instead set the menu on or off

------------------------------------------------------------------------
r6384 | havoc | 2006-05-25 09:39:44 +0200 (Thu, 25 May 2006) | 2 lines

changed matchpattern to take a const char *

------------------------------------------------------------------------
r6380 | havoc | 2006-05-25 06:12:05 +0200 (Thu, 25 May 2006) | 2 lines

replaced cl_beams_relative cvar with cl_beams_quakepositionhack and cl_beams_instantaimhack and rewrote the relevant code, it now works like quake (except with instant aiming in the case of the instantaimhack) and applies only to your player

------------------------------------------------------------------------
r6379 | havoc | 2006-05-25 05:57:50 +0200 (Thu, 25 May 2006) | 2 lines

changed qc profiling to use doubles instead of ints for profile counters, so it can now count beyond 4 billion

------------------------------------------------------------------------
r6378 | havoc | 2006-05-25 05:54:31 +0200 (Thu, 25 May 2006) | 2 lines

increased runaway jump count limit to 1000000000

------------------------------------------------------------------------
r6377 | havoc | 2006-05-25 05:49:59 +0200 (Thu, 25 May 2006) | 2 lines

calculate bounding box properly for psk models, and a cleanup of bounding box generation code for mdl/md2/md3 models

------------------------------------------------------------------------
r6376 | havoc | 2006-05-25 05:46:21 +0200 (Thu, 25 May 2006) | 4 lines

fixed crashes when changing a few settings while playing a demo
fixed repeated jumping bug in cl_movement code
fixed crashes that would occur if playing a QW demo (not yet supported)

------------------------------------------------------------------------
r6375 | havoc | 2006-05-25 05:43:58 +0200 (Thu, 25 May 2006) | 3 lines

fix crash when entering "color" command while playing a demo
fixed values printed by bottomcolor/topcolor commands (so bottomcolor no longer reports the whole color like color does, instead just the pants color)

------------------------------------------------------------------------
r6374 | havoc | 2006-05-25 05:41:51 +0200 (Thu, 25 May 2006) | 2 lines

fix playback of demos after playing on a quakeworld server

------------------------------------------------------------------------
r6373 | havoc | 2006-05-25 05:41:01 +0200 (Thu, 25 May 2006) | 3 lines

display qw spectators as spectators on the scoreboard
fix a crash if holding showscores while playing a demo

------------------------------------------------------------------------
r6372 | havoc | 2006-05-24 00:54:30 +0200 (Wed, 24 May 2006) | 2 lines

remove some r_render checks, and added an r_render check to vid_sdl.c VID_Finish

------------------------------------------------------------------------
r6370 | havoc | 2006-05-17 10:18:06 +0200 (Wed, 17 May 2006) | 2 lines

471

------------------------------------------------------------------------
r6369 | havoc | 2006-05-15 04:40:36 +0200 (Mon, 15 May 2006) | 2 lines

patch from Dresk that adds a doom3-like "toggle" console command

------------------------------------------------------------------------
r6368 | havoc | 2006-05-12 10:11:46 +0200 (Fri, 12 May 2006) | 2 lines

reorganized a lot of renderer variables into r_refdef, and split some things out of r_refdef into r_view and r_viewcache, this reorganization brings DP closer to being able to render to textures

------------------------------------------------------------------------
r6367 | havoc | 2006-05-12 09:33:09 +0200 (Fri, 12 May 2006) | 2 lines

undo something not meant to be committed yet

------------------------------------------------------------------------
r6366 | havoc | 2006-05-12 09:06:22 +0200 (Fri, 12 May 2006) | 2 lines

fix two implicit conversions

------------------------------------------------------------------------
r6365 | havoc | 2006-05-12 09:05:32 +0200 (Fri, 12 May 2006) | 2 lines

fix s->waterlevel = 0 and such

------------------------------------------------------------------------
r6364 | havoc | 2006-05-11 11:20:29 +0200 (Thu, 11 May 2006) | 2 lines

removed the clearing of the root bone in .psa animations, to fix bugs (sorry, this was experimental and apparently broken)

------------------------------------------------------------------------
r6363 | havoc | 2006-05-11 11:03:10 +0200 (Thu, 11 May 2006) | 2 lines

fix a warning

------------------------------------------------------------------------
r6362 | havoc | 2006-05-10 13:52:21 +0200 (Wed, 10 May 2006) | 2 lines

redesigned skeletal model loading and rendering to use matrix-palette animation (still in software, but that may change at some point), this improved nexuiz -benchmark demos/demo1 framerates by 11.3%

------------------------------------------------------------------------
r6361 | havoc | 2006-05-10 13:16:44 +0200 (Wed, 10 May 2006) | 2 lines

added Vector4Set macro

------------------------------------------------------------------------
r6360 | havoc | 2006-05-10 12:14:26 +0200 (Wed, 10 May 2006) | 4 lines

some clean up of packet parsing
merged most of the server info parsing code between the two cases (DP server and QW server), and reimplemented server info parsing for NQ servers
enabled ping/ack packet processing

------------------------------------------------------------------------
r6359 | havoc | 2006-05-10 10:26:44 +0200 (Wed, 10 May 2006) | 2 lines

setinfo *ip on every network connection (currently only meaningful to QW reconnect command, but potentially useful), and removed some unneeded setinfo's since the cvars/commands now work properly

------------------------------------------------------------------------
r6358 | havoc | 2006-05-10 10:24:54 +0200 (Wed, 10 May 2006) | 2 lines

improved setinfo handling so that quakeworld works much better now (name/topcolor/bottomcolor/skin/team/noaim are handled properly now), this means TeamFortress won't kick clients for not responding to team/skin cvars, and is fully playable

------------------------------------------------------------------------
r6357 | havoc | 2006-05-10 10:02:45 +0200 (Wed, 10 May 2006) | 2 lines

removed all 3 uses of the brown-text message prefix in the server

------------------------------------------------------------------------
r6356 | havoc | 2006-05-10 09:59:45 +0200 (Wed, 10 May 2006) | 2 lines

added a comment

------------------------------------------------------------------------
r6355 | havoc | 2006-05-10 08:02:04 +0200 (Wed, 10 May 2006) | 2 lines

cleanup of chat prefix character handling, this fixes a bug that was removing quake's brown characters at the beginning of a line

------------------------------------------------------------------------
r6354 | havoc | 2006-05-09 17:26:00 +0200 (Tue, 09 May 2006) | 2 lines

significantly reworked the cl_movement code, now predicts quakeworld almost completely correctly (only some issues with the different nature of stair stepping, and other differences compared to the FlyMove function on the servers which affect sliding in grooves)

------------------------------------------------------------------------
r6353 | havoc | 2006-05-09 17:22:46 +0200 (Tue, 09 May 2006) | 3 lines

don't shuffle servers around when pings come in later and are identical to the existing ones (I.E. made the sort be a stable sort)
fixed a bug that caused qwmaster query packets to be bigger than necessary (was writing 7 bytes, should have been 3 bytes)

------------------------------------------------------------------------
r6352 | havoc | 2006-05-09 17:18:50 +0200 (Tue, 09 May 2006) | 2 lines

do q1bsp lighting checks starting with + 0.125 unit Z offset to improve chances of finding a lighting value rather than returning black when a model origin is almost stuck in the floor

------------------------------------------------------------------------
r6351 | havoc | 2006-05-09 01:39:56 +0200 (Tue, 09 May 2006) | 2 lines

split R_DrawTextureSurfaceList code into several functions and added separate multitexture-combine/singletexture paths

------------------------------------------------------------------------
r6350 | havoc | 2006-05-08 12:35:32 +0200 (Mon, 08 May 2006) | 2 lines

fix NUL termination issue on the test string by not actually printing the packet

------------------------------------------------------------------------
r6349 | havoc | 2006-05-08 12:33:02 +0200 (Mon, 08 May 2006) | 2 lines

fixes to the test program

------------------------------------------------------------------------
r6348 | havoc | 2006-05-08 12:22:10 +0200 (Mon, 08 May 2006) | 2 lines

lhnet fixes - now calls WSAStartup during LHNET_Init and WSAShutdown during LHNET_Shutdown, so gethostbyname will work on windows without any sockets open (as long as LHNET_Init has been called of course), fixed a few things that were breaking compilation with -DSTANDALONETEST and added a new simpler and more useful standalone test program which is now used by default (edit the #if if you want the old one instead)

------------------------------------------------------------------------
r6347 | havoc | 2006-05-08 07:21:14 +0200 (Mon, 08 May 2006) | 2 lines

fix really stupid bug in qw download code which was saving the same file repeatedly (it wasn't resetting the buffer position on each new download)

------------------------------------------------------------------------
r6345 | havoc | 2006-05-01 14:30:03 +0200 (Mon, 01 May 2006) | 2 lines

fix bug with gl_combine 0 transparent water rendering in q1bsp (alpha was not being stored, leaving garbage (typically 0) in the vertex alpha, making the water disappear)

------------------------------------------------------------------------
r6344 | havoc | 2006-05-01 14:14:02 +0200 (Mon, 01 May 2006) | 2 lines

fix a type (description as part of value on r_textshadow)

------------------------------------------------------------------------
r6343 | havoc | 2006-05-01 14:05:34 +0200 (Mon, 01 May 2006) | 3 lines

optimized rtlighting passes by using RSurf_DrawBatch_Simple, this took a lot of code restructuring but the resulting code is definitely a lot faster
fixed bugs in RSurf_DrawBatch_Lightmap related changes

------------------------------------------------------------------------
r6342 | havoc | 2006-05-01 11:00:22 +0200 (Mon, 01 May 2006) | 4 lines

restructured RSurf_DrawLightmap to become RSurf_DrawBatch_Lightmap which processes all arrays and sets things up perfectly, then renders all the surfaces with a call to R_DrawBatch_Simple
added dynamic surface-merging to R_DrawBatch_Simple, depending on the new r_batchmode cvar it either renders surfaces individually (as before), consecutively (consecutively numbered surfaces are rendered with one call for their combined triangle elements range), or by memcpy merging elements into one array (this has rather chaotic vertex ranges so gl_lockarrays is disabled in this code because it is a consistent speed loss in this case)
this optimization increased fps by 4.7% in timedemo bigass1, and offers bigger gains in very high poly q1bsp and q3bsp maps

------------------------------------------------------------------------
r6341 | havoc | 2006-04-30 05:42:04 +0200 (Sun, 30 Apr 2006) | 3 lines

changed svc_setangle to cause interpolated turning when spectating (two or more consecutive frames with a svc_setangle message), and instant entity updates when teleporting (just one svc_setangle) so you no longer fly through the level when teleporting
changed cl_beams_relative to only apply to the local player (unless set to a value of 2 or higher)

------------------------------------------------------------------------
r6340 | havoc | 2006-04-28 03:21:54 +0200 (Fri, 28 Apr 2006) | 2 lines

treat AltGr key as ALT for bind purposes

------------------------------------------------------------------------
r6339 | black | 2006-04-27 22:23:42 +0200 (Thu, 27 Apr 2006) | 6 lines

Add _DrawQ_ProcessDrawFlag to clean-up the glblend setup code.
Add CL_Video_KeyEvent and support for it to Key_Event, now the the fullscreen video
is closed automatically when you hit enter, space or escape and the video system catches all
input (no more accidentially nagivating around in the menu).
(Please test this and report bugs to black@icculus.org if you find any)

------------------------------------------------------------------------
r6338 | havoc | 2006-04-27 04:54:45 +0200 (Thu, 27 Apr 2006) | 2 lines

fixed fullbright support in glsl path

------------------------------------------------------------------------
r6337 | sajt | 2006-04-27 02:58:09 +0200 (Thu, 27 Apr 2006) | 2 lines

Removed myself from all the todo items. I no longer mind if none of these are ever implemented/fixed, and I check the cvs often enough that I'll see if they ever are. Feel free to remove any of these altogether, e.g. mirrors, hub save, skyrooms...

------------------------------------------------------------------------
r6336 | sajt | 2006-04-27 02:49:46 +0200 (Thu, 27 Apr 2006) | 2 lines

*** empty log message ***

------------------------------------------------------------------------
r6335 | havoc | 2006-04-26 16:34:29 +0200 (Wed, 26 Apr 2006) | 2 lines

added proper liquidfriction support

------------------------------------------------------------------------
r6334 | havoc | 2006-04-26 16:22:55 +0200 (Wed, 26 Apr 2006) | 2 lines

optimized handling of decals, which increased timedemo bigass1.dem from 185fps to 191fps, also partially implemented airfriction and liquidfriction

------------------------------------------------------------------------
r6333 | havoc | 2006-04-26 15:12:43 +0200 (Wed, 26 Apr 2006) | 2 lines

a simple optimization to particle allocation, increased bigass1.dem performance from 184fps to 185fps

------------------------------------------------------------------------
r6332 | havoc | 2006-04-26 14:57:21 +0200 (Wed, 26 Apr 2006) | 2 lines

now does batching of transparent surfaces, such as particles, this raised performance in bigass1.dem from 143fps to 184fps (it uses a lot of particles)

------------------------------------------------------------------------
r6331 | havoc | 2006-04-26 12:20:45 +0200 (Wed, 26 Apr 2006) | 2 lines

added a lot more CHECKGLERROR macro calls, to identify precisely where any error occurs

------------------------------------------------------------------------
r6330 | havoc | 2006-04-26 11:09:19 +0200 (Wed, 26 Apr 2006) | 2 lines

changed back to 1 second intervals on fps math

------------------------------------------------------------------------
r6329 | havoc | 2006-04-26 11:08:55 +0200 (Wed, 26 Apr 2006) | 2 lines

changed the Cvar_Command: prints to developer.integer >= 100

------------------------------------------------------------------------
r6328 | havoc | 2006-04-25 15:21:24 +0200 (Tue, 25 Apr 2006) | 3 lines

reenabled support of find() with an empty string as the search value, this fixes the Blood Mage monster movement
slight optimization to findflags and findchainflags

------------------------------------------------------------------------
r6327 | havoc | 2006-04-25 15:20:05 +0200 (Tue, 25 Apr 2006) | 2 lines

added prvm_printfunction command which prints an assembly dump of the specified qc function, with coloring and optionally statement profiling to show how many times each statement has been executed (prvm_statementprofiling must be on for this), also heavily modified statement printing to be more readable

------------------------------------------------------------------------
r6326 | havoc | 2006-04-25 08:14:44 +0200 (Tue, 25 Apr 2006) | 3 lines

significant optimizations to the progs interpreter, changed the runaway loop counter to only count jump instructions (if/ifnot/goto), and redesigned the profile counting to use pointer math on batches of instructions instead of counting each instruction individually
changed prvm_profile report to show callcount before statements and builtincost, changed the sorting order to use summed callcount+statements+builtincost (and this made it print call counts for builtin functions as well)

------------------------------------------------------------------------
r6325 | havoc | 2006-04-25 02:34:02 +0200 (Tue, 25 Apr 2006) | 2 lines

reenabled the 'stick in place if stuck in a solid' code, but changed it to only apply for bmodelstartsolid, this prevents monsters from falling out of the level even if they're stuck in a wall, for consistency with stock quake

------------------------------------------------------------------------
r6324 | havoc | 2006-04-21 01:55:54 +0200 (Fri, 21 Apr 2006) | 3 lines

changed particle trail handling so that the TE_TEI_G3 effect can spawn particles along the beam just like trails can
cleaned up particle texture generation, no longer generates them if loading from disk, now also allows all 64 slots to be used (except the beam one) by generating generic texcoords for all of them

------------------------------------------------------------------------
r6323 | havoc | 2006-04-21 01:54:12 +0200 (Fri, 21 Apr 2006) | 2 lines

added keyup function for menu qc at Black's request

------------------------------------------------------------------------
r6322 | havoc | 2006-04-20 17:52:12 +0200 (Thu, 20 Apr 2006) | 2 lines

replaced rainsplash animation with just a single particle which expands over time to free up significant space in the particlefont (also added sizeincrease parameter support to effectinfo.txt accordingly)

------------------------------------------------------------------------
r6321 | havoc | 2006-04-20 17:48:55 +0200 (Thu, 20 Apr 2006) | 2 lines

don't complain about shaders with no layers

------------------------------------------------------------------------
r6320 | havoc | 2006-04-20 12:55:47 +0200 (Thu, 20 Apr 2006) | 2 lines

grab mouse when using menu while watching demos (important for nexuiz)

------------------------------------------------------------------------
r6319 | havoc | 2006-04-20 12:55:00 +0200 (Thu, 20 Apr 2006) | 2 lines

fix some model lighting bugs in the GLSL surface renderer related to stale lightmaps still being bound

------------------------------------------------------------------------
r6318 | havoc | 2006-04-20 11:17:21 +0200 (Thu, 20 Apr 2006) | 2 lines

allow changelevel to stop demos (necessary for nexuiz menu)

------------------------------------------------------------------------
r6317 | havoc | 2006-04-20 11:12:59 +0200 (Thu, 20 Apr 2006) | 2 lines

fix missing newline on unknown opcode warning in progs loader

------------------------------------------------------------------------
r6316 | havoc | 2006-04-20 09:57:38 +0200 (Thu, 20 Apr 2006) | 2 lines

renamed scr_screenshot_gamma to scr_screenshot_gammaboost and changed default to 1, this means all screenshots will be unmodified unless the user specifically changes the setting, rather than saving them very bright by default

------------------------------------------------------------------------
r6315 | havoc | 2006-04-20 09:46:09 +0200 (Thu, 20 Apr 2006) | 2 lines

optimized LoadTGA to have fast paths for all formats, rather than one unified loading loop that tried to support all formats, this saves 1.15 seconds of load time in nexuiz on my machine (before: 2.32 seconds spent in LoadTGA, after: 1.17 seconds)

------------------------------------------------------------------------
r6314 | havoc | 2006-04-20 05:43:20 +0200 (Thu, 20 Apr 2006) | 2 lines

significant surface renderer optimizations

------------------------------------------------------------------------
r6313 | havoc | 2006-04-20 03:47:26 +0200 (Thu, 20 Apr 2006) | 2 lines

added GL_AlphaTest function to enable/disable GL_ALPHA_TEST

------------------------------------------------------------------------
r6312 | havoc | 2006-04-19 15:33:05 +0200 (Wed, 19 Apr 2006) | 2 lines

precache scoreboard title, intermission pics, and finale pic

------------------------------------------------------------------------
r6311 | havoc | 2006-04-19 09:04:05 +0200 (Wed, 19 Apr 2006) | 2 lines

removed the flawed detection of modelspace deluxemaps (it was always concluding they were modelspace because of unused black pixels and such), now assumes q3bsp deluxemaps are always modelspace

------------------------------------------------------------------------
r6310 | havoc | 2006-04-18 13:24:19 +0200 (Tue, 18 Apr 2006) | 2 lines

another attempt to fix the warnings

------------------------------------------------------------------------
r6309 | havoc | 2006-04-18 13:19:02 +0200 (Tue, 18 Apr 2006) | 2 lines

attempting to fix a warning about setjmp clobbering variables

------------------------------------------------------------------------
r6308 | havoc | 2006-04-18 13:10:10 +0200 (Tue, 18 Apr 2006) | 2 lines

fix a bug in AUTOSPRITE2 code caused by overzealous optimization, thanks to Elric for reporting this

------------------------------------------------------------------------
r6307 | havoc | 2006-04-18 12:44:11 +0200 (Tue, 18 Apr 2006) | 5 lines

reworked most of q3bsp q3 shader loading, now supports more shader effects (the first layer's blendfunc is now used for rendering), still no multilayer stuff though, and still no tcgen environment so some surfaces now look worse because their first pass is an environment effect, but most others look better...
q3 fog shaders are usually invisible now (looks better than blinding white surfaces)
added support for more hacky q3 shaders (like sky shaders that don't have surfaceparm sky, and transparent shaders that don't have surfaceparm trans)
added support for alpha test in q3 shaders (improves some shaders)

------------------------------------------------------------------------
r6306 | havoc | 2006-04-18 12:37:43 +0200 (Tue, 18 Apr 2006) | 2 lines

reset a bit more state each frame

------------------------------------------------------------------------
r6305 | havoc | 2006-04-18 08:28:17 +0200 (Tue, 18 Apr 2006) | 2 lines

conback lives...  again!

------------------------------------------------------------------------
r6304 | havoc | 2006-04-18 08:19:10 +0200 (Tue, 18 Apr 2006) | 2 lines

removed showfps mode 2 (which was weird), modified showfps 1 to use 0.1 second polling intervals so it updates much more often

------------------------------------------------------------------------
r6303 | havoc | 2006-04-18 08:16:13 +0200 (Tue, 18 Apr 2006) | 2 lines

conback support is dead.

------------------------------------------------------------------------
r6301 | havoc | 2006-04-18 08:03:37 +0200 (Tue, 18 Apr 2006) | 2 lines

removed scr_conspeed, now always instantaneous console opening/closing

------------------------------------------------------------------------
r6300 | havoc | 2006-04-18 07:49:22 +0200 (Tue, 18 Apr 2006) | 8 lines

rewrote timing code, now a much better and very different sleeping method, no longer wastes any cpu time
changed timing code to have independent sleeping for client and server frames in a listen server
changed console execution to occur in sync with server frames if a server is running, this fixes frikbot loading of .way files
eliminated several host_* variables, replaced host_realframetime with cl.realframetime (which is how long since the last client frame)
removed the clamping of sys_ticrate to >= 0.1, so now sys_ticrate 0 is allowed (run as fast as possible), as well as silly values like 0.001
removed serverprofile cvar as it was not easy to preserve it in the rewritten timing
merged Host_FilterTime, Host_ServerFrame, Host_Frame, _Host_Frame into Host_Main (which also calls Host_Init), this eliminates some duplicate code in all the sys_ modules

------------------------------------------------------------------------
r6299 | havoc | 2006-04-17 03:58:32 +0200 (Mon, 17 Apr 2006) | 2 lines

batch by lightmap as well as texture, this cures problems with vertex lit surfaces in deluxemapped q3bsp files (the vertex lit surfaces can't be deluxemapped)

------------------------------------------------------------------------
r6298 | havoc | 2006-04-16 13:38:37 +0200 (Sun, 16 Apr 2006) | 2 lines

no longer recalculated q3bsp surface normals, this makes q3map2 'phong shading' features work, no more seams on terrain and such

------------------------------------------------------------------------
r6297 | havoc | 2006-04-16 13:37:07 +0200 (Sun, 16 Apr 2006) | 2 lines

fix crash when loading .dpm models

------------------------------------------------------------------------
r6296 | havoc | 2006-04-16 13:36:20 +0200 (Sun, 16 Apr 2006) | 2 lines

changed where vertex coloring is applied in the fragment shader, this fixes problems with vertex colored surfaces (note: does not help deluxemapping mode, there is another bug affecting that)

------------------------------------------------------------------------
r6295 | havoc | 2006-04-16 12:19:05 +0200 (Sun, 16 Apr 2006) | 2 lines

modified Mod_BuildTextureVectorsAndNormals to become Mod_BuildTextureVectorsFromNormals, this is in preparation for properly honoring the surface normals in models and maps (doesn't do anything yet)

------------------------------------------------------------------------
r6294 | havoc | 2006-04-16 11:34:02 +0200 (Sun, 16 Apr 2006) | 2 lines

commented out r_texture_fogintensity texture generation as it's not used anywhere

------------------------------------------------------------------------
r6293 | havoc | 2006-04-16 11:30:21 +0200 (Sun, 16 Apr 2006) | 2 lines

fix bug in glsl surface shader setup code which was breaking fog

------------------------------------------------------------------------
r6292 | havoc | 2006-04-16 11:21:17 +0200 (Sun, 16 Apr 2006) | 6 lines

eliminated rmeshstate_t .pointer_vertex and .pointer_color (now must use R_Mesh_VertexPointer and R_Mesh_ColorPointer instead - in a lot of code these don't need to be called as often)
renamed R_Mesh_State to R_Mesh_TextureState
made an alternate variant of R_Mesh_TextureState called R_Mesh_ResetTextureState which acts like it was given an empty rmeshstate_t (but is faster than R_Mesh_TextureState)
moved R_Mesh_VertexPointer and R_Mesh_TexCoordPointer calls out of the inner loops of the GLSL surface path
other related cleanups

------------------------------------------------------------------------
r6291 | havoc | 2006-04-16 08:44:17 +0200 (Sun, 16 Apr 2006) | 2 lines

redesigned some of the model animation code, should be a speed gain (no longer processes animation multiple times on models with multiple textures), and executes less code per surface (should speed up map rendering)

------------------------------------------------------------------------
r6290 | havoc | 2006-04-16 08:40:20 +0200 (Sun, 16 Apr 2006) | 2 lines

fixed zym loading bugs that made models lose surfaces

------------------------------------------------------------------------
r6289 | molivier | 2006-04-16 08:28:28 +0200 (Sun, 16 Apr 2006) | 2 lines

AGL fixes: fixed a crash when switching to and from fullscreen several times; explicitely release the display when closing the video module; fixed initial test in VID_Shutdown(); a bit of code cleaning

------------------------------------------------------------------------
r6288 | havoc | 2006-04-16 06:02:32 +0200 (Sun, 16 Apr 2006) | 2 lines

use entity bbox for network culling if model was not found (this allows dedicated servers to run properly without models installed)

------------------------------------------------------------------------
r6287 | havoc | 2006-04-16 03:08:00 +0200 (Sun, 16 Apr 2006) | 3 lines

some cleanup of Mod_Alias_GetMesh_Vertex3f
fixed md3 animation loading bug (this was causing all frames other than 0 to be corrupt)

------------------------------------------------------------------------
r6286 | molivier | 2006-04-15 13:33:29 +0200 (Sat, 15 Apr 2006) | 2 lines

Fixes and cleanups related to the recent AGL patches

------------------------------------------------------------------------
r6285 | havoc | 2006-04-15 10:24:35 +0200 (Sat, 15 Apr 2006) | 2 lines

added darkplaces-agl to .cvsignore

------------------------------------------------------------------------
r6284 | havoc | 2006-04-15 10:14:55 +0200 (Sat, 15 Apr 2006) | 2 lines

fix more warnings

------------------------------------------------------------------------
r6283 | havoc | 2006-04-15 10:13:14 +0200 (Sat, 15 Apr 2006) | 2 lines

added -framework AGL to the Mac OSX client libs to make it compile

------------------------------------------------------------------------
r6282 | havoc | 2006-04-15 10:04:10 +0200 (Sat, 15 Apr 2006) | 2 lines

fix some warnings

------------------------------------------------------------------------
r6281 | havoc | 2006-04-15 09:53:27 +0200 (Sat, 15 Apr 2006) | 2 lines

fix really stupid typo in SV_Move code, this cures the 'monsters walking through walls' bug

------------------------------------------------------------------------
r6280 | havoc | 2006-04-15 08:46:09 +0200 (Sat, 15 Apr 2006) | 2 lines

fix clientside bmodel collisions (now can walk around on the start.bsp main room floor, lifts, be blocked by doors, etc)

------------------------------------------------------------------------
r6279 | havoc | 2006-04-15 08:45:12 +0200 (Sat, 15 Apr 2006) | 2 lines

prints entity number of MOVETYPE_PUSH entities without models (this is mostly useful to level designers who accidentally left a brushless door lying around)

------------------------------------------------------------------------
r6278 | havoc | 2006-04-15 08:44:03 +0200 (Sat, 15 Apr 2006) | 2 lines

additional debugging code

------------------------------------------------------------------------
r6277 | havoc | 2006-04-15 08:41:22 +0200 (Sat, 15 Apr 2006) | 2 lines

fixed stair step up bug in cl_movement code which caused prediction to go through walls in some cases

------------------------------------------------------------------------
r6276 | havoc | 2006-04-15 08:38:09 +0200 (Sat, 15 Apr 2006) | 3 lines

fixed really stupid typo in CL_TraceBox regarding bmodel entity collisions (doors and such) which was breaking their collisions
eliminated CL_PointQ1Contents

------------------------------------------------------------------------
r6275 | havoc | 2006-04-14 05:46:39 +0200 (Fri, 14 Apr 2006) | 2 lines

audit of checkstuck/unstickentity code and relates stuff, this seems to fix the falling out of level bug

------------------------------------------------------------------------
r6274 | havoc | 2006-04-14 05:45:43 +0200 (Fri, 14 Apr 2006) | 3 lines

better SUPERCONTENTS masks for a few TraceBox and PointContents calls
slight cleanups

------------------------------------------------------------------------
r6273 | havoc | 2006-04-13 18:48:09 +0200 (Thu, 13 Apr 2006) | 2 lines

moved SVC_PARTICLE code to fallback code, this does allow effectinfo.txt to override SVC_PARTICLE but that isn't recommended

------------------------------------------------------------------------
r6272 | havoc | 2006-04-13 18:41:23 +0200 (Thu, 13 Apr 2006) | 2 lines

stop complaining about SVC_PARTICLE

------------------------------------------------------------------------
r6271 | havoc | 2006-04-13 18:33:19 +0200 (Thu, 13 Apr 2006) | 2 lines

two Mac OSX fixes from ds01 on alientrap forums - input fixed, and fullscren fixed

------------------------------------------------------------------------
r6270 | havoc | 2006-04-13 00:41:27 +0200 (Thu, 13 Apr 2006) | 2 lines

changed cshifts[] to use floats instead of ints, this reduces framerate dependence (where damage flashes faded faster at lower framerates)

------------------------------------------------------------------------
r6269 | havoc | 2006-04-13 00:40:32 +0200 (Thu, 13 Apr 2006) | 2 lines

Sys_Sleep more to save cpu time

------------------------------------------------------------------------
r6268 | havoc | 2006-04-13 00:40:14 +0200 (Thu, 13 Apr 2006) | 2 lines

don't hide console when entering a map, only do so for timedemo

------------------------------------------------------------------------
r6266 | havoc | 2006-04-11 23:47:51 +0200 (Tue, 11 Apr 2006) | 2 lines

MacOSX g++ setjmp fix from div0

------------------------------------------------------------------------
r6265 | black | 2006-04-11 13:31:04 +0200 (Tue, 11 Apr 2006) | 3 lines

This works for me, works on Windows according to MSDN and should also work
everywhere else according to the C standard.

------------------------------------------------------------------------
r6264 | havoc | 2006-04-11 00:03:40 +0200 (Tue, 11 Apr 2006) | 2 lines

reverted Black's change to the effectinfo.txt color command

------------------------------------------------------------------------
r6263 | black | 2006-04-10 22:41:57 +0200 (Mon, 10 Apr 2006) | 3 lines

An attempt to fix the particle color bug (it coudlnt read hex values).
Also extend it to make it support "R G B" color pairs.

------------------------------------------------------------------------
r6262 | havoc | 2006-04-09 03:11:39 +0200 (Sun, 09 Apr 2006) | 2 lines

do apply mixahead math as int

------------------------------------------------------------------------
r6261 | havoc | 2006-04-08 22:02:56 +0200 (Sat, 08 Apr 2006) | 2 lines

fix cl.completed_time math after that last commit

------------------------------------------------------------------------
r6260 | havoc | 2006-04-08 20:56:35 +0200 (Sat, 08 Apr 2006) | 3 lines

made darkplaces able to compile as C++ again, and fixed all conversion warnings when doing so
changed several malloc and free calls to Z_Malloc and Z_Free

------------------------------------------------------------------------
r6259 | havoc | 2006-04-08 18:17:06 +0200 (Sat, 08 Apr 2006) | 2 lines

default sv_gameplayfix_stepdown to 0 because it's generally undesirable

------------------------------------------------------------------------
r6258 | havoc | 2006-04-04 21:08:45 +0200 (Tue, 04 Apr 2006) | 2 lines

466

------------------------------------------------------------------------
r6251 | havoc | 2006-04-04 16:01:23 +0200 (Tue, 04 Apr 2006) | 2 lines

increased sv_maxrate limit to 150000 from 25000

------------------------------------------------------------------------
r6249 | havoc | 2006-04-04 15:51:22 +0200 (Tue, 04 Apr 2006) | 2 lines

added particle effect scripting using effectinfo.txt, this means configurable effects in any game that wishes to do so

------------------------------------------------------------------------
r6248 | havoc | 2006-04-04 15:49:12 +0200 (Tue, 04 Apr 2006) | 2 lines

don't render skymasking polygons when noclipping

------------------------------------------------------------------------
r6247 | havoc | 2006-04-04 15:36:21 +0200 (Tue, 04 Apr 2006) | 2 lines

added some extra prints to net_slistqw to figure out which masters are working, and removed a few duplicate references to the id qw masters from the list

------------------------------------------------------------------------
r6228 | havoc | 2006-04-02 10:12:44 +0200 (Sun, 02 Apr 2006) | 4 lines

some cleanup of the GLSL shader, no longer uses #ifdef variable declarations because the shader compiler removes unused variables anyway, and now always calculates the eye vector for simplicity reasons
removed the SURFACENORMALIZE option (now always on, since it doesn't cost much render time and was on by default)
removed all use and detection of half floats (these were originally around 11% speedup on GF6 hardware but but in more recent drivers they've dropped to around 3-6%, and spit out a lot of warnings during shader compilation with no apparent way to fix the warnings)

------------------------------------------------------------------------
r6227 | havoc | 2006-04-02 10:05:42 +0200 (Sun, 02 Apr 2006) | 2 lines

removed a piece of debugging code

------------------------------------------------------------------------
r6220 | havoc | 2006-04-01 15:49:46 +0200 (Sat, 01 Apr 2006) | 2 lines

rewrote much of SV_Trace_Toss to fix bugs (it basically wasn't working, though I was unable to figure out why)

------------------------------------------------------------------------
r6216 | havoc | 2006-03-31 05:38:34 +0200 (Fri, 31 Mar 2006) | 2 lines

print out the contents of the GLSL shader when it is compiled when using developer 100 or higher

------------------------------------------------------------------------
r6215 | havoc | 2006-03-29 15:25:09 +0200 (Wed, 29 Mar 2006) | 2 lines

fix a crash in r_showsurfaces

------------------------------------------------------------------------
r6214 | havoc | 2006-03-29 14:54:11 +0200 (Wed, 29 Mar 2006) | 2 lines

optimizations to surface rendering setup

------------------------------------------------------------------------
r6212 | havoc | 2006-03-29 13:11:46 +0200 (Wed, 29 Mar 2006) | 3 lines

eliminated model->meshlist, replaced with an embedded model->surfmesh to cut down on pointer indirections, this also eliminated surface->groupmesh
some minor optimizations of code to keep track of ent->model in a local variable rather than dereferencing ent every time

------------------------------------------------------------------------
r6211 | havoc | 2006-03-29 13:08:11 +0200 (Wed, 29 Mar 2006) | 2 lines

very very minor optimization

------------------------------------------------------------------------
r6210 | havoc | 2006-03-29 13:04:08 +0200 (Wed, 29 Mar 2006) | 2 lines

added LDFLAGS_SDL to the pmake file

------------------------------------------------------------------------
r6209 | havoc | 2006-03-29 12:54:31 +0200 (Wed, 29 Mar 2006) | 2 lines

remove a superfluous -L

------------------------------------------------------------------------
r6208 | havoc | 2006-03-29 12:52:14 +0200 (Wed, 29 Mar 2006) | 2 lines

merged special SUNOS LDFLAGS_UNIXCL into LDFLAGS_SUNOSCL to eliminate an ifeq which was breaking on pmake

------------------------------------------------------------------------
r6207 | havoc | 2006-03-29 12:51:31 +0200 (Wed, 29 Mar 2006) | 2 lines

remove the -f makefile.bsd

------------------------------------------------------------------------
r6206 | havoc | 2006-03-29 12:37:23 +0200 (Wed, 29 Mar 2006) | 2 lines

renamed makefile.bsd to BSDmakefile so that pmake will automatically find it (no -f necessary), thanks to div0 for the tip

------------------------------------------------------------------------
r6205 | havoc | 2006-03-29 11:18:50 +0200 (Wed, 29 Mar 2006) | 3 lines

no longer uses multiple meshes for model loading, they each use one mesh for all surfaces combined
now puts all q3bsp map geometry into one mesh at load rather than splitting it into 65536 vertex meshes to crutch up broken drivers (they've been fixed already so this is no longer necessary)

------------------------------------------------------------------------
r6204 | havoc | 2006-03-29 11:14:28 +0200 (Wed, 29 Mar 2006) | 2 lines

in Host_ServerFrame, give the server a bit more execution time

------------------------------------------------------------------------
r6203 | havoc | 2006-03-29 08:50:53 +0200 (Wed, 29 Mar 2006) | 2 lines

default scr_menuforcewhiledisconnected to 0

------------------------------------------------------------------------
r6202 | havoc | 2006-03-29 02:31:12 +0200 (Wed, 29 Mar 2006) | 2 lines

added rampsize parameter to BuildGammaTable8 and 16

------------------------------------------------------------------------
r6201 | havoc | 2006-03-28 15:09:42 +0200 (Tue, 28 Mar 2006) | 2 lines

an optimization to call XF86VidModeGetGammaRampSize only when opening the window, and assume the rampsize doesn't change after that

------------------------------------------------------------------------
r6200 | havoc | 2006-03-28 15:02:06 +0200 (Tue, 28 Mar 2006) | 3 lines

modified gamma handling, now VID_UpdateGamma is only called from VID_Finish, and VID_SetGamma/VID_GetGamma/VID_UpdateGamma take rampsize parameters
VID_UpdateGamma now supports ramp sizes other than 256, and automatically allocates memory accordingly, this allows hardware gamma on X11 to work on Quadro cards (which report 1024 gamma entries according to div0), and allows any other platform to do whatever it wishes

------------------------------------------------------------------------
r6199 | havoc | 2006-03-28 12:17:21 +0200 (Tue, 28 Mar 2006) | 2 lines

added loading of hmap2 .dlit tangentspace deluxemap files and a rather lame method of lightstyle support (blending the deluxemaps according to lightstyles, not rendering them separately like it should)

------------------------------------------------------------------------
r6196 | havoc | 2006-03-28 05:01:52 +0200 (Tue, 28 Mar 2006) | 2 lines

added two more psk/psa versions reported by Kazashi

------------------------------------------------------------------------
r6195 | havoc | 2006-03-28 03:04:23 +0200 (Tue, 28 Mar 2006) | 2 lines

patch from div0 to fix disappearing items in nexuiz (trace_* globals in qc were not being cleared before calling touch)

------------------------------------------------------------------------
r6194 | havoc | 2006-03-26 10:09:45 +0200 (Sun, 26 Mar 2006) | 2 lines

fixed r_speeds stats with r_showsurfaces 1 mode

------------------------------------------------------------------------
r6193 | havoc | 2006-03-26 09:17:32 +0200 (Sun, 26 Mar 2006) | 3 lines

added r_showsurfaces rendering mode which illustrates how many surfaces are on screen (and renders REALLY FAST)
moved r_showcollisionbrushes code to gl_rmain.c

------------------------------------------------------------------------
r6192 | havoc | 2006-03-26 08:43:50 +0200 (Sun, 26 Mar 2006) | 4 lines

eliminated the hacky r_showtris code, now r_glsl 1 mode works with r_showtris
rewrote r_showtris and r_shownormals to use opaque lines that write to the depth buffer, this makes them show up quite clearly in all cases
moved r_showtris and r_shownormals code into R_DrawSurfaces

------------------------------------------------------------------------
r6191 | havoc | 2006-03-26 05:28:37 +0200 (Sun, 26 Mar 2006) | 2 lines

disable skymasking in q3bsp because it causes issues with q3map2 sky tricks (and reenabled the skipping of skymasking on hlbsp also)

------------------------------------------------------------------------
r6190 | havoc | 2006-03-26 04:26:44 +0200 (Sun, 26 Mar 2006) | 2 lines

fixed bug that was preventing some deluxemapped q3bsp files from being identified as deluxemapped

------------------------------------------------------------------------
r6189 | havoc | 2006-03-25 23:31:21 +0100 (Sat, 25 Mar 2006) | 2 lines

448

------------------------------------------------------------------------
r6188 | sajt | 2006-03-25 11:56:16 +0100 (Sat, 25 Mar 2006) | 2 lines

452

------------------------------------------------------------------------
r6187 | sajt | 2006-03-25 08:58:18 +0100 (Sat, 25 Mar 2006) | 4 lines

cl_autodemo, when set to true, automatically records every game you play. The filename of the demo is determined by cl_autodemo_nameformat (UNIX time string) and the map name.

Note - I'm pretty sure this currently lumps all games played successively into one demo. Feel free to fix that :)

------------------------------------------------------------------------
r6186 | sajt | 2006-03-25 08:25:45 +0100 (Sat, 25 Mar 2006) | 3 lines

'Cruft' removal (removed GAME_FNIGGIUM)
Fixed a very minor 'potential' leak in JPEG loading

------------------------------------------------------------------------
r6185 | havoc | 2006-03-23 13:34:27 +0100 (Thu, 23 Mar 2006) | 2 lines

fix some TraceBox calls that weren't updated like they should have been, so they were using a totally bogus bounding box

------------------------------------------------------------------------
r6184 | havoc | 2006-03-23 13:33:46 +0100 (Thu, 23 Mar 2006) | 2 lines

fix EF_SELECTABLE flickering bug with prydon cursor

------------------------------------------------------------------------
r6183 | havoc | 2006-03-23 13:04:10 +0100 (Thu, 23 Mar 2006) | 2 lines

and a GL_DepthMask call

------------------------------------------------------------------------
r6177 | havoc | 2006-03-23 12:53:11 +0100 (Thu, 23 Mar 2006) | 2 lines

changed several DPrint's and developer cvar checks to higher developer cvar levels (>= 10 and >= 100 for example), this makes developer 1 much more pleasant to use, also changed the memory clearing on free to depend on developer_memorydebug (which is already quite slow) rather than developer (which shouldn't slow things down much)

------------------------------------------------------------------------
r6176 | havoc | 2006-03-23 12:49:22 +0100 (Thu, 23 Mar 2006) | 2 lines

a GL_DepthTest call I forgot in the last commit

------------------------------------------------------------------------
r6175 | havoc | 2006-03-23 12:47:11 +0100 (Thu, 23 Mar 2006) | 3 lines

fixed bug that made light filter cubemaps not work in GLSL mode (was binding a cubemap as a 2D texture...  oops)
fixed bug that made sky brush entities not appear when not looking at sky brushes in the world (GL_DepthTest/GL_DepthMask were messed up)

------------------------------------------------------------------------
r6174 | havoc | 2006-03-23 12:44:47 +0100 (Thu, 23 Mar 2006) | 2 lines

corrected PFLAGS_FULLDYNAMIC pitch angle handling

------------------------------------------------------------------------
r6173 | havoc | 2006-03-23 12:43:46 +0100 (Thu, 23 Mar 2006) | 2 lines

fix bugs with bbox vs bbox traces (the collision box's planes didn't have correct contents/surfaceflags/texture information)

------------------------------------------------------------------------
r6172 | havoc | 2006-03-23 12:41:34 +0100 (Thu, 23 Mar 2006) | 2 lines

fixed really stupid bug in Matrix4x4_Normalize - it was transposing the matrix (a legacy of the fact it was based on Invert_Simple)

------------------------------------------------------------------------
r6170 | havoc | 2006-03-23 03:34:51 +0100 (Thu, 23 Mar 2006) | 2 lines

add back a cls.signon = 0 in the SpawnServer code that is necessary to prevent crashes on level change in singleplayer and listen servers

------------------------------------------------------------------------
r6169 | havoc | 2006-03-23 03:34:16 +0100 (Thu, 23 Mar 2006) | 2 lines

added more validation of clipnodes loaded from a q1bsp file

------------------------------------------------------------------------
r6168 | havoc | 2006-03-22 10:18:03 +0100 (Wed, 22 Mar 2006) | 2 lines

another WIN32_LEAN_AND_MEAN patch from Willis, this one for non-SDL client and dedicated server

------------------------------------------------------------------------
r6166 | havoc | 2006-03-22 09:51:35 +0100 (Wed, 22 Mar 2006) | 2 lines

implemented DP_TRACE_HITCONTENTSMASK_SURFACEINFO extension, this allows QC to find out if a projectile hit sky, among other capabilities

------------------------------------------------------------------------
r6165 | havoc | 2006-03-22 06:22:21 +0100 (Wed, 22 Mar 2006) | 3 lines

changed collision code to report supercontents, surfaceflags, and texture that was hit in a trace (even if it has to fake the information for q1bsp)
decals no longer stick to sky (except in stock id1 q1bsp maps which have CONTENTS_SOLID sky)

------------------------------------------------------------------------
r6164 | havoc | 2006-03-21 11:36:25 +0100 (Tue, 21 Mar 2006) | 2 lines

448

------------------------------------------------------------------------
r6163 | havoc | 2006-03-21 11:31:54 +0100 (Tue, 21 Mar 2006) | 2 lines

fixed bug that made deluxemapping gloss appear even with rtworld on

------------------------------------------------------------------------
r6162 | havoc | 2006-03-21 11:28:43 +0100 (Tue, 21 Mar 2006) | 2 lines

fix alpha blended textures in GLSL lighting path

------------------------------------------------------------------------
r6161 | havoc | 2006-03-21 10:56:14 +0100 (Tue, 21 Mar 2006) | 2 lines

changed all Draw_CachePic calls to precache the pic except for two calls in the menu qc vm

------------------------------------------------------------------------
r6160 | havoc | 2006-03-21 10:55:27 +0100 (Tue, 21 Mar 2006) | 2 lines

fix a crash that could occur if resizing the resize buffer twice in one upload call, and also fix a bug where the player setup menu's translated player pic was being treated as a subimage update which doesn't work because that image is scaled up, not a natural power of 2

------------------------------------------------------------------------
r6159 | havoc | 2006-03-21 10:07:34 +0100 (Tue, 21 Mar 2006) | 2 lines

slight readability improvement to PointInfrontOfTriangle

------------------------------------------------------------------------
r6158 | havoc | 2006-03-21 10:06:02 +0100 (Tue, 21 Mar 2006) | 4 lines

removed detection of GL_NV_texture_shader extension which was previously used for the geforce3 water shader that was removed a long time ago
removed support for GL_DSDT_NV textures (which were only used for the geforce3 water shader)
removed code pertaining to GL_NV_vertex_array_range (which hasn't been supported for a very long time)

------------------------------------------------------------------------
r6157 | havoc | 2006-03-21 09:49:42 +0100 (Tue, 21 Mar 2006) | 2 lines

removed TEXF_FRAGMENT support from texture manager and merged gltextureimage_t into gltexture_t to save some memory and reduce code complexity

------------------------------------------------------------------------
r6156 | molivier | 2006-03-21 07:52:58 +0100 (Tue, 21 Mar 2006) | 2 lines

Minor changes to get rid of functions deprecated in Mac OS X 10.4

------------------------------------------------------------------------
r6155 | havoc | 2006-03-21 07:49:25 +0100 (Tue, 21 Mar 2006) | 2 lines

modified Q1BSP loader to generate lightmap fragments on its own, rather than relying on the texture manager, this greatly shortens r_texturestats reports and reduces memory usage a bit (less gltexture_t structures), and modified R_UpdateTexture to be able to update fragments

------------------------------------------------------------------------
r6154 | havoc | 2006-03-21 06:49:29 +0100 (Tue, 21 Mar 2006) | 5 lines

renamed varray_ arrays to rsurface_array_, and they are no longer used outside the surface rendering code, additionally they are now dynamically resized (saves a little memory)
audited a lot of memory allocations and fixed a few significant leaks
removed Host_ClearMemory as it was causing several memory leaks, and split cls.mempool into cls.levelmempool and cls.permanentmempool, cls.levelmempool is now emptied each level load (this also fixes those same leaks)
merged r_shadow_mempool into r_main_mempool

------------------------------------------------------------------------
r6153 | havoc | 2006-03-21 04:03:26 +0100 (Tue, 21 Mar 2006) | 4 lines

removed the USETEXMATRIX define (now always on), reduced varray_texcoord3f to only have one array rather than 4 (as the others are no longer needed with USETEXMATRIX), removed varray_texcoord2f, removed earray_element3i
changed many simple uses of varray_* arrays to use stack arrays instead
this reduces memory usage by 1MB

------------------------------------------------------------------------
r6152 | havoc | 2006-03-21 03:27:02 +0100 (Tue, 21 Mar 2006) | 2 lines

removed unused R_Mesh_CacheArray stuff

------------------------------------------------------------------------
r6151 | havoc | 2006-03-21 03:23:27 +0100 (Tue, 21 Mar 2006) | 4 lines

moved SCR_UpdateScreen and SCR_DrawScreen code to cl_screen.c and rearranged them somewhat
moved DrawQ_ functions to gl_draw.c and eliminated r_refdef.drawqueue (this saves some memory and makes all the 2D code more efficient)
disabled unused R_Mesh_CacheArray stuff in gl_backend.c

------------------------------------------------------------------------
r6150 | havoc | 2006-03-21 02:18:34 +0100 (Tue, 21 Mar 2006) | 2 lines

fixed one more cvar declaration that was missing a comma

------------------------------------------------------------------------
r6149 | havoc | 2006-03-21 02:15:43 +0100 (Tue, 21 Mar 2006) | 2 lines

fixed value/description of r_textshadow

------------------------------------------------------------------------
r6148 | havoc | 2006-03-21 00:09:24 +0100 (Tue, 21 Mar 2006) | 2 lines

fixed stuck entity warnings when they should not have been occurring, by adding trace.bmodelstartsolid as a separate thing to check

------------------------------------------------------------------------
r6147 | havoc | 2006-03-20 23:31:10 +0100 (Mon, 20 Mar 2006) | 2 lines

enabled fullbrights on liquid textures in q1bsp loading, this fixes the black lava bug

------------------------------------------------------------------------
r6146 | havoc | 2006-03-20 07:13:30 +0100 (Mon, 20 Mar 2006) | 2 lines

fix crash when using r_editlights mode

------------------------------------------------------------------------
r6145 | havoc | 2006-03-20 07:08:51 +0100 (Mon, 20 Mar 2006) | 2 lines

fix nail and explosion sound defaults

------------------------------------------------------------------------
r6144 | havoc | 2006-03-20 06:51:30 +0100 (Mon, 20 Mar 2006) | 4 lines

cl_movement 0 should no longer be causing an input replay (which was slow and pointless), though I don't know how it was doing so before...
added code to prevent pogostick jumping in the cl_movement prediction (since the qc prevents pogostick jumping, it was inaccurate to simulate it clientside)
changed view/gun bobbing to use cl.movement_velocity for the xyspeed math, this greatly improves the clientside prediction

------------------------------------------------------------------------
r6143 | havoc | 2006-03-20 05:01:50 +0100 (Mon, 20 Mar 2006) | 2 lines

WIN32_LEAN_AND_MEAN patch from Willis to speed up MSVC compilation

------------------------------------------------------------------------
r6142 | havoc | 2006-03-20 05:01:09 +0100 (Mon, 20 Mar 2006) | 2 lines

added reliefmapping (behaves exactly like offsetmapping, but a slightly different look), removed r_glsl_offsetmapping_bias setting

------------------------------------------------------------------------
r6141 | havoc | 2006-03-19 22:15:02 +0100 (Sun, 19 Mar 2006) | 5 lines

fixed deluxemapping
added r_glsl_deluxemapping cvar (2 forces fake deluxemapping on any level, kind of interesting to see)
added modelspace deluxemapping (automatically detects whether deluxemaps are modelspace or tangentspace at load time)
changed offsetmapping shader to be more perspective correct

------------------------------------------------------------------------
r6140 | havoc | 2006-03-19 22:12:26 +0100 (Sun, 19 Mar 2006) | 2 lines

added one more r_speeds 2 report item, to ensure that "clear" is really measuring only the clearing process

------------------------------------------------------------------------
r6139 | sajt | 2006-03-18 13:17:01 +0100 (Sat, 18 Mar 2006) | 2 lines

This made the cvar completion so much more readable

------------------------------------------------------------------------
r6138 | sajt | 2006-03-18 13:12:57 +0100 (Sat, 18 Mar 2006) | 2 lines

I was just joking

------------------------------------------------------------------------
r6137 | sajt | 2006-03-18 13:11:13 +0100 (Sat, 18 Mar 2006) | 2 lines

nitpicky

------------------------------------------------------------------------
r6136 | havoc | 2006-03-18 11:08:09 +0100 (Sat, 18 Mar 2006) | 2 lines

added r_glsl_restart command, and modified shaderstring loading back to the old way (reload the file on every permutation compile) for simplicity

------------------------------------------------------------------------
r6135 | havoc | 2006-03-18 06:20:17 +0100 (Sat, 18 Mar 2006) | 2 lines

one more correction

------------------------------------------------------------------------
r6134 | havoc | 2006-03-18 06:18:27 +0100 (Sat, 18 Mar 2006) | 2 lines

fix stupid but non-harmful bug in RSurf_DrawLightmap code

------------------------------------------------------------------------
r6133 | havoc | 2006-03-18 06:08:48 +0100 (Sat, 18 Mar 2006) | 2 lines

fixed an uninitialized variable warning (which was true)

------------------------------------------------------------------------
r6132 | havoc | 2006-03-18 05:28:17 +0100 (Sat, 18 Mar 2006) | 4 lines

reduced number of image extensions checked by doing more intelligent path examination, and changing q1bsp loader to prepend textures/, this allows it to not check any prefixes in the image loader itself (except in a few cases in nexuiz)
changed image loader to not check override/ unless running GAME_TENEBRAE
removed several unused image functions

------------------------------------------------------------------------
r6131 | havoc | 2006-03-17 08:50:50 +0100 (Fri, 17 Mar 2006) | 2 lines

updated default.glsl

------------------------------------------------------------------------
r6130 | havoc | 2006-03-17 08:49:01 +0100 (Fri, 17 Mar 2006) | 2 lines

added deluxemapping (per pixel lighting using lightmaps in specially compiled q3bsp maps)

------------------------------------------------------------------------
r6129 | havoc | 2006-03-17 07:34:13 +0100 (Fri, 17 Mar 2006) | 2 lines

updated default glsl shader

------------------------------------------------------------------------
r6128 | havoc | 2006-03-17 07:33:11 +0100 (Fri, 17 Mar 2006) | 4 lines

added GLSL shader path for normal rendering stage, reworked a lot of things to do this
removed .lights file loading and the corresponding directional model shading (these were only produced by hlight for q1bsp, very rare files) so that the GLSL normal rendering stage would not have to deal with .lights files
changed R_CompleteLightPoint to properly match rtlight shading, not the old dlights, this allowed removal of the old lightmap_* rtlight fields

------------------------------------------------------------------------
r6127 | havoc | 2006-03-17 07:29:12 +0100 (Fri, 17 Mar 2006) | 2 lines

446

------------------------------------------------------------------------
r6126 | havoc | 2006-03-17 07:27:07 +0100 (Fri, 17 Mar 2006) | 2 lines

modified R_GetTexture to return the texnum of r_texture_white if given NULL

------------------------------------------------------------------------
r6125 | havoc | 2006-03-17 04:59:23 +0100 (Fri, 17 Mar 2006) | 2 lines

remove fullbright flag on lava and teleport textures

------------------------------------------------------------------------
r6123 | sajt | 2006-03-17 02:28:42 +0100 (Fri, 17 Mar 2006) | 2 lines

Yes, that was a rather silly typo!

------------------------------------------------------------------------
r6122 | havoc | 2006-03-16 23:58:21 +0100 (Thu, 16 Mar 2006) | 2 lines

added v_deathtiltangle cvar to allow changing of the roll angle used while dead, at RenegadeC's request

------------------------------------------------------------------------
r6121 | havoc | 2006-03-15 14:19:36 +0100 (Wed, 15 Mar 2006) | 6 lines

cleaning up GLSL code
moved GLSL shader setup to gl_rmain.c and made it more general, not specifically lighting shaders
cache locations of GLSL shader variables for faster access (instead of looking them up every time it renders something)
GLSL shader reworked to support deluxemap rendering and lightmap rendering, to be used in the future
merged glsl/light.frag and glsl/light.vert into glsl/default.glsl using VERTEX_SHADER and FRAGMENT_SHADER defines to differentiate parts of it

------------------------------------------------------------------------
r6120 | havoc | 2006-03-15 14:16:19 +0100 (Wed, 15 Mar 2006) | 2 lines

changed skybox string from size 64 to MAX_QPATH (which is 64)

------------------------------------------------------------------------
r6119 | molivier | 2006-03-15 11:54:27 +0100 (Wed, 15 Mar 2006) | 2 lines

Removed cgame.c, cgamevm.c, ui.c, cg_math.h, cgame_api.h, cgamevm.h, and ui.h from the MSVC projects

------------------------------------------------------------------------
r6118 | havoc | 2006-03-15 09:02:43 +0100 (Wed, 15 Mar 2006) | 2 lines

slight optimization of model purging and the like, and a failed attempt to make mod_known be a dynamic array

------------------------------------------------------------------------
r6117 | havoc | 2006-03-15 08:02:56 +0100 (Wed, 15 Mar 2006) | 5 lines

moved many cl_ prefixed variables into cl. or cls.
made most menu functions static
removed WORKINGLQUAKE support from cl_particles.c and moved particle allocation to cl_main.c (where all the other arrays are allocated)
renamed cl_activevideos to cl_num_videos and videoarray to cl_videos (did not move these into cls. however)

------------------------------------------------------------------------
r6116 | havoc | 2006-03-15 07:08:15 +0100 (Wed, 15 Mar 2006) | 2 lines

don't set qc impulse more than once per packet

------------------------------------------------------------------------
r6115 | havoc | 2006-03-15 02:01:53 +0100 (Wed, 15 Mar 2006) | 2 lines

removed cgame and ui code (both unused), this reduces memory use a bit

------------------------------------------------------------------------
r6114 | havoc | 2006-03-15 01:42:48 +0100 (Wed, 15 Mar 2006) | 2 lines

added LAN search for quakeworld servers

------------------------------------------------------------------------
r6113 | havoc | 2006-03-15 01:35:08 +0100 (Wed, 15 Mar 2006) | 2 lines

split up net_slist into net_slist and net_slistqw, and modified menu accordingly to have two search options

------------------------------------------------------------------------
r6112 | havoc | 2006-03-14 05:39:14 +0100 (Tue, 14 Mar 2006) | 2 lines

fix crosshair 6, and allow custom crosshairs up to 32

------------------------------------------------------------------------
r6111 | sajt | 2006-03-12 03:36:58 +0100 (Sun, 12 Mar 2006) | 2 lines

Fix in Nexuiz's fallback menu to avoid ending up with a blank screen

------------------------------------------------------------------------
r6110 | sajt | 2006-03-12 02:04:12 +0100 (Sun, 12 Mar 2006) | 2 lines

r_nearclip cvar

------------------------------------------------------------------------
r6109 | sajt | 2006-03-12 01:23:44 +0100 (Sun, 12 Mar 2006) | 2 lines

Added some non-crucial header files to the VC++6 projects. The .dev files need them too, not sure what compiler those files are for though.

------------------------------------------------------------------------
r6108 | havoc | 2006-03-11 21:17:23 +0100 (Sat, 11 Mar 2006) | 2 lines

fix typo

------------------------------------------------------------------------
r6107 | havoc | 2006-03-11 20:01:54 +0100 (Sat, 11 Mar 2006) | 2 lines

use hash lookups in Cvar_FindVar, this gives a ~40% increase in fps with high numbers of bots in nexuiz

------------------------------------------------------------------------
r6106 | havoc | 2006-03-11 19:28:00 +0100 (Sat, 11 Mar 2006) | 2 lines

refactored _Mem_Free into _Mem_FreeBlock which takes a memheader_t * and _Mem_Free which converts a void * to the content area of the memory, to a memheader_t * and calls _Mem_FreeBlock - now _Mem_FreePool and _Mem_EmptyPool can call that directly, which avoids a Mem_IsAllocated error that I don't understand

------------------------------------------------------------------------
r6105 | havoc | 2006-03-11 19:10:56 +0100 (Sat, 11 Mar 2006) | 2 lines

added back brackets so that developer isn't forced to 100 on startup every time

------------------------------------------------------------------------
r6104 | havoc | 2006-03-11 18:33:31 +0100 (Sat, 11 Mar 2006) | 2 lines

oops, accidentally set developer to 100 by default

------------------------------------------------------------------------
r6103 | havoc | 2006-03-11 18:24:10 +0100 (Sat, 11 Mar 2006) | 2 lines

changed VID_Finish to take an allowmousegrab parameter, this avoids mousegrab on the initial loading screen (before +vid_mouse 1 on commandline is executed)

------------------------------------------------------------------------
r6102 | havoc | 2006-03-11 18:23:09 +0100 (Sat, 11 Mar 2006) | 2 lines

init host_framecount to 0, just a cleanup

------------------------------------------------------------------------
r6101 | havoc | 2006-03-11 18:22:22 +0100 (Sat, 11 Mar 2006) | 2 lines

fix bug in [515]'s csqc code - it was using the literal number 64 for the max players, not MAX_SCOREBOARD as it should

------------------------------------------------------------------------
r6100 | havoc | 2006-03-11 18:11:23 +0100 (Sat, 11 Mar 2006) | 2 lines

fix incredibly stupid bug in Memory_Init, it was clearing the pool chain AFTER allocating two pools

------------------------------------------------------------------------
r6099 | havoc | 2006-03-11 18:10:55 +0100 (Sat, 11 Mar 2006) | 2 lines

cleaned up the stupid forcedeveloper hack, now changes the default string of the cvar before it is registered, this is much cleaner

------------------------------------------------------------------------
r6098 | havoc | 2006-03-11 17:59:04 +0100 (Sat, 11 Mar 2006) | 2 lines

moved -developer code to the very beginning of Host_Init, and added a -developer2 option for heavy memory debugging from the beginning

------------------------------------------------------------------------
r6097 | havoc | 2006-03-11 17:58:28 +0100 (Sat, 11 Mar 2006) | 2 lines

moved name in memory pools to a different part of the structure, to make ddd displays read better

------------------------------------------------------------------------
r6096 | havoc | 2006-03-11 17:57:48 +0100 (Sat, 11 Mar 2006) | 2 lines

fix skinfile memory leaks on ZYM, DPM, and PSK model loaders, and move the skinfile allocations to the model's memory pool even though they are temporary

------------------------------------------------------------------------
r6095 | havoc | 2006-03-11 17:19:18 +0100 (Sat, 11 Mar 2006) | 2 lines

moved Log_Start call into SCR_BeginLoadingPlaque (which occurs as soon as a map or demo loads, or when config parsing is done)

------------------------------------------------------------------------
r6094 | havoc | 2006-03-11 00:47:18 +0100 (Sat, 11 Mar 2006) | 2 lines

446

------------------------------------------------------------------------
r6093 | havoc | 2006-03-11 00:45:42 +0100 (Sat, 11 Mar 2006) | 2 lines

default sv_jumpstep to 0 to not allow players to jump places they should not be able to go in quake (each game/mod can set this in its default.cfg if it is desired)

------------------------------------------------------------------------
r6092 | havoc | 2006-03-11 00:23:21 +0100 (Sat, 11 Mar 2006) | 2 lines

fixed cl_activebeams handling, now beams work again

------------------------------------------------------------------------
r6089 | havoc | 2006-03-10 06:21:43 +0100 (Fri, 10 Mar 2006) | 2 lines

fixed bug that caused SV_SpawnServer to fail to send reconnect commands to clients (it was using sv.reliable_datagram which is immediately cleared and thus not sent)

------------------------------------------------------------------------
r6088 | havoc | 2006-03-10 06:19:54 +0100 (Fri, 10 Mar 2006) | 2 lines

when loading a savegame, use the saved v_angle value, not angles which usually lacks pitch, this fixes the lack of view pitch when loading games

------------------------------------------------------------------------
r6087 | havoc | 2006-03-10 06:18:39 +0100 (Fri, 10 Mar 2006) | 2 lines

fixed bug that allowed the quake2 stair jump to work

------------------------------------------------------------------------
r6086 | havoc | 2006-03-10 05:02:56 +0100 (Fri, 10 Mar 2006) | 2 lines

don't clear player entity when loading a savegame

------------------------------------------------------------------------
r6085 | havoc | 2006-03-10 03:37:40 +0100 (Fri, 10 Mar 2006) | 4 lines

changed TraceBox functions to take start,mins,maxs,end like they did in Quake, this is a slight optimization to traceline and pointcontents tests and q1bsp tracing, but mostly just cleans up the code
removed some old code from q3bsp TraceLine/TraceBox functions
changed segmentmins/maxs and nodesegmentmins/maxs calculations to have a 1 unit enlargement on all comparisons, this might improve reliability of TraceBox, but probably not

------------------------------------------------------------------------
r6084 | havoc | 2006-03-10 03:31:42 +0100 (Fri, 10 Mar 2006) | 2 lines

fixed bullets-going-through-walls bug in q3bsp collision code, this was a really nasty bug in the midfrac calculations (it was calculating the midfrac for the partially clipped line segment and then acting as if that was a fraction of the complete line segment...  this caused many problems)

------------------------------------------------------------------------
r6083 | havoc | 2006-03-09 17:19:23 +0100 (Thu, 09 Mar 2006) | 2 lines

fixed bug that caused ClientDisconnect to not be called on bots in their first level (it did get called on their second level onward), this fix does however assume the QC code will call ClientConnect every time it uses spawnclient

------------------------------------------------------------------------
r6082 | havoc | 2006-03-08 16:53:47 +0100 (Wed, 08 Mar 2006) | 2 lines

made zym and dpm model loaders warn and ignore the model if it is missing geometry or frames

------------------------------------------------------------------------
r6081 | havoc | 2006-03-08 02:13:29 +0100 (Wed, 08 Mar 2006) | 2 lines

some work on SV_TestEntityPosition and entity unsticking, now only checks against bmodels

------------------------------------------------------------------------
r6080 | havoc | 2006-03-07 21:39:58 +0100 (Tue, 07 Mar 2006) | 2 lines

some win64 fixes from Willis

------------------------------------------------------------------------
r6079 | havoc | 2006-03-07 15:18:05 +0100 (Tue, 07 Mar 2006) | 3 lines

rearranged surface renderer some more
added tangent/normal generation flags to RSurf_SetVertexPointer, this eliminated the various calls to Mod_BuildTextureVectorsAndNormals and Mod_BuildNormals during rendering, so RSurf_SetVertexPointer is now the only function that sets up rsurface_* variables

------------------------------------------------------------------------
r6078 | havoc | 2006-03-07 12:22:16 +0100 (Tue, 07 Mar 2006) | 2 lines

simplified cl_particles_quality handling, shouldn't affect particle lifetime anymore now

------------------------------------------------------------------------
r6077 | havoc | 2006-03-07 12:21:49 +0100 (Tue, 07 Mar 2006) | 2 lines

fix r_speeds 1 so that it works again

------------------------------------------------------------------------
r6076 | havoc | 2006-03-07 11:49:16 +0100 (Tue, 07 Mar 2006) | 3 lines

fixed pogostick/doublejump bug when running id1 qc with a client sending input packets less frequently than server frames
moved ping time calculation out of SV_ApplyClientMove and back into SV_ReadClientMove

------------------------------------------------------------------------
r6075 | molivier | 2006-03-07 11:14:28 +0100 (Tue, 07 Mar 2006) | 2 lines

Modified ResampleSfx for a small speed gain

------------------------------------------------------------------------
r6074 | molivier | 2006-03-06 11:16:16 +0100 (Mon, 06 Mar 2006) | 2 lines

Added "SDL/include" to the include paths and "SDL/lib" to the library paths (allow easy compilation with SDL when the SDL SDK isn't already integrated in MSVC; just unzip "SDL-devel-1.2.x-VC6.zip" in the darkplaces folder, rename its folder to "SDL" and voila!)

------------------------------------------------------------------------
r6073 | havoc | 2006-03-04 22:31:37 +0100 (Sat, 04 Mar 2006) | 2 lines

upped player limit (MAX_SCOREBOARD) from 64 to 255, and corrected my email address in the menu

------------------------------------------------------------------------
r6072 | havoc | 2006-03-04 19:49:26 +0100 (Sat, 04 Mar 2006) | 2 lines

commented out a line as suggested by Spike, to fix a crash when length is 0, this matches the behavior of md4

------------------------------------------------------------------------
r6071 | havoc | 2006-03-04 19:48:37 +0100 (Sat, 04 Mar 2006) | 2 lines

added LittleLong around the checksums to fix endian-ness issues in QW

------------------------------------------------------------------------
r6068 | havoc | 2006-03-04 16:04:28 +0100 (Sat, 04 Mar 2006) | 2 lines

add SV_VM block around SV_DropClient call in NetConn_ServerFrame to fix a crash when players time out

------------------------------------------------------------------------
r6067 | havoc | 2006-03-04 15:52:53 +0100 (Sat, 04 Mar 2006) | 2 lines

some cleanup of surface->cached_dlight handling to fix the broken unlit q1bsp handling (it was not appearing fullbright as it should), and this also is a slight optimization

------------------------------------------------------------------------
r6066 | black | 2006-03-04 15:45:35 +0100 (Sat, 04 Mar 2006) | 2 lines

Fix a bug in the video system.

------------------------------------------------------------------------
r6065 | havoc | 2006-03-04 15:36:50 +0100 (Sat, 04 Mar 2006) | 2 lines

forgot to include this in the previous commit

------------------------------------------------------------------------
r6064 | havoc | 2006-03-04 15:33:22 +0100 (Sat, 04 Mar 2006) | 2 lines

unmerge OpenVideo code, back to the proper multilayer system it was

------------------------------------------------------------------------
r6063 | havoc | 2006-03-04 14:38:03 +0100 (Sat, 04 Mar 2006) | 2 lines

changed Q1BSP LoadEdges out of bounds error into just a warning

------------------------------------------------------------------------
r6062 | havoc | 2006-03-04 11:50:37 +0100 (Sat, 04 Mar 2006) | 2 lines

fix a const warning

------------------------------------------------------------------------
r6061 | havoc | 2006-03-04 11:49:23 +0100 (Sat, 04 Mar 2006) | 2 lines

fix duplicate definition of identitymatrix (search and replace accident)

------------------------------------------------------------------------
r6060 | havoc | 2006-03-04 11:48:40 +0100 (Sat, 04 Mar 2006) | 2 lines

fix typo

------------------------------------------------------------------------
r6059 | havoc | 2006-03-04 11:47:37 +0100 (Sat, 04 Mar 2006) | 2 lines

eliminated calls to Matrix4x4_CreateIdentity (now copies from the already existing global identitymatrix struct) and changed all references to r_identitymatrix to refer to identitymatrix

------------------------------------------------------------------------
r6058 | havoc | 2006-03-04 10:24:21 +0100 (Sat, 04 Mar 2006) | 6 lines

replaced sbarpic_t with cachepic_t in sbar code (saves a bit of memory)
changed DrawQ_SuperPic and DrawQ_Pic to take a cachepic_t * instead of a pic name (this speeds up the sbar code by not using name lookups constantly)
removed DrawQ_Fill (use DrawQ_Pic with NULL pic instead)
changed crosshair/editlights cursors to use r_crosshairs array initialized at startup instead of constantly calling Draw_CachePic
changed Host_Init to call SCR_BeginLoadingPlaque instead of Host_StartVideo (which is called by SCR_BeginLoadingPlaque)

------------------------------------------------------------------------
r6057 | havoc | 2006-03-04 10:23:32 +0100 (Sat, 04 Mar 2006) | 2 lines

454

------------------------------------------------------------------------
r6056 | havoc | 2006-03-04 10:23:05 +0100 (Sat, 04 Mar 2006) | 2 lines

added SDL_APPACTIVE checking so that vid_hidden is now set correctly, this turns off rendering when minimized

------------------------------------------------------------------------
r6055 | havoc | 2006-03-04 08:14:10 +0100 (Sat, 04 Mar 2006) | 2 lines

optimizations and refactoring to get a small (1-2%) speed gain

------------------------------------------------------------------------
r6054 | havoc | 2006-03-04 07:13:50 +0100 (Sat, 04 Mar 2006) | 2 lines

added a fast path for queries on "sv_gravity" in CG_Frame (which is unused)

------------------------------------------------------------------------
r6053 | havoc | 2006-03-04 06:40:06 +0100 (Sat, 04 Mar 2006) | 2 lines

optimized entity handling in cgame.c (not used) so that it doesn't drag down framerates doing nothing

------------------------------------------------------------------------
r6052 | havoc | 2006-03-04 03:45:32 +0100 (Sat, 04 Mar 2006) | 2 lines

fix a C99 lazy variable issue with non-C99 compilers

------------------------------------------------------------------------
r6051 | havoc | 2006-03-03 16:02:56 +0100 (Fri, 03 Mar 2006) | 2 lines

now only compiles GLSL shaders on demand, this improves startup times (but causes some pausing when new combinations occur - which usually only happens on new levels)

------------------------------------------------------------------------
r6050 | havoc | 2006-03-03 15:51:07 +0100 (Fri, 03 Mar 2006) | 2 lines

move SV_ClearDatagram call to eliminate missing weapon/pickup effects bug when using cl_movement 1

------------------------------------------------------------------------
r6049 | molivier | 2006-03-02 17:46:30 +0100 (Thu, 02 Mar 2006) | 2 lines

Fallback to "vorbis.dll" and "vorbisfile.dll" if "libvorbis.dll" and "libvorbisfile.dll" can't be loaded

------------------------------------------------------------------------
r6048 | molivier | 2006-03-02 16:47:38 +0100 (Thu, 02 Mar 2006) | 2 lines

Added mdfour.[ch] to the MSVC project files

------------------------------------------------------------------------
r6047 | havoc | 2006-02-28 13:19:54 +0100 (Tue, 28 Feb 2006) | 2 lines

filter servers by "gameversion" cvar, which is now also exposed in the serverinfo

------------------------------------------------------------------------
r6046 | havoc | 2006-02-28 09:17:49 +0100 (Tue, 28 Feb 2006) | 2 lines

only query QuakeWorld servers when in GAME_NORMAL mode

------------------------------------------------------------------------
r6045 | havoc | 2006-02-28 07:29:59 +0100 (Tue, 28 Feb 2006) | 2 lines

casts to fix warnings in MSVC x64, thanks Willis

------------------------------------------------------------------------
r6044 | havoc | 2006-02-28 07:00:27 +0100 (Tue, 28 Feb 2006) | 2 lines

patch from div0 to fix a comment

------------------------------------------------------------------------
r6043 | havoc | 2006-02-28 06:41:39 +0100 (Tue, 28 Feb 2006) | 3 lines

reduced number of GAME_NEXUIZ checks in the engine (added cl_sound and sv_sound cvars to change or disable engine-triggered sounds), removed some old unused nexuiz menu code (now that the fallbac
k prevents you from even reaching the singleplayer menu)

------------------------------------------------------------------------
r6042 | havoc | 2006-02-27 03:19:30 +0100 (Mon, 27 Feb 2006) | 2 lines

fix the minutes display on the QW scoreboard

------------------------------------------------------------------------
r6041 | havoc | 2006-02-27 03:15:48 +0100 (Mon, 27 Feb 2006) | 2 lines

MorphOS networking support patch from bigfoot

------------------------------------------------------------------------
r6040 | havoc | 2006-02-27 03:15:10 +0100 (Mon, 27 Feb 2006) | 2 lines

added MorphOS labeling

------------------------------------------------------------------------
r6039 | havoc | 2006-02-26 12:00:19 +0100 (Sun, 26 Feb 2006) | 3 lines

vast improvements in qw server listings in the server browser
now DP servers and QW servers are color coded differently, and player count is color coded (red if empty or full, yellow if less than 4 players, white otherwise, useful for quickly identifying the busy servers)

------------------------------------------------------------------------
r6038 | havoc | 2006-02-26 10:39:59 +0100 (Sun, 26 Feb 2006) | 2 lines

added qw master support to server query system, and added 16 masters (15 of which from FTEQW), now the server browser is flooded with QW servers

------------------------------------------------------------------------
r6037 | havoc | 2006-02-26 10:37:52 +0100 (Sun, 26 Feb 2006) | 2 lines

improved packet command to have more escape codes (like \0)

------------------------------------------------------------------------
r6036 | havoc | 2006-02-26 10:36:46 +0100 (Sun, 26 Feb 2006) | 2 lines

fix crash in nq connect (oops)

------------------------------------------------------------------------
r6035 | havoc | 2006-02-26 07:15:17 +0100 (Sun, 26 Feb 2006) | 2 lines

added support for qw movevars (sent in server join, and sometimes a couple of them are updated during the game) in the cl_movement physics

------------------------------------------------------------------------
r6034 | havoc | 2006-02-26 04:15:05 +0100 (Sun, 26 Feb 2006) | 2 lines

fix the timeout problem with cl_movement 1 mode on QW servers, but the prediction still needs work to make use of movevars

------------------------------------------------------------------------
r6033 | havoc | 2006-02-26 04:00:47 +0100 (Sun, 26 Feb 2006) | 2 lines

qw support is 99% working

------------------------------------------------------------------------
r6031 | havoc | 2006-02-25 15:13:18 +0100 (Sat, 25 Feb 2006) | 2 lines

added md4four map checksumming, since QW servers seem to be very picky about map checksums matching

------------------------------------------------------------------------
r6030 | havoc | 2006-02-25 14:21:54 +0100 (Sat, 25 Feb 2006) | 2 lines

QW support getting very close

------------------------------------------------------------------------
r6029 | havoc | 2006-02-25 11:11:36 +0100 (Sat, 25 Feb 2006) | 2 lines

QW support getting closer

------------------------------------------------------------------------
r6028 | havoc | 2006-02-25 10:59:58 +0100 (Sat, 25 Feb 2006) | 2 lines

moved parse_model_precache and parse_sound_precache to cl.model_names and cl.sound_names respectively

------------------------------------------------------------------------
r6027 | havoc | 2006-02-25 09:56:03 +0100 (Sat, 25 Feb 2006) | 2 lines

fix typos that caused colormod to malfunction when hosting a QUAKEDP protocol server (it was sending red as green and blue), thanks to Spike for pointing this out

------------------------------------------------------------------------
r6026 | havoc | 2006-02-24 07:04:40 +0100 (Fri, 24 Feb 2006) | 2 lines

beginnings of qw protocol support

------------------------------------------------------------------------
r6025 | havoc | 2006-02-24 07:03:21 +0100 (Fri, 24 Feb 2006) | 3 lines

added InfoString_Print
modified InfoString_GetValue and InfoString_SetValue to reject " characters

------------------------------------------------------------------------
r6024 | havoc | 2006-02-24 06:18:03 +0100 (Fri, 24 Feb 2006) | 2 lines

renamed cl.protocol to cls.protocol

------------------------------------------------------------------------
r6023 | havoc | 2006-02-24 06:17:36 +0100 (Fri, 24 Feb 2006) | 2 lines

fix infinite loop bugs in InfoString_SetValue

------------------------------------------------------------------------
r6022 | havoc | 2006-02-24 05:46:27 +0100 (Fri, 24 Feb 2006) | 2 lines

removed canSend field from netconn_t, and added a fromserver variable in client parsing just for clarity

------------------------------------------------------------------------
r6021 | havoc | 2006-02-24 05:44:04 +0100 (Fri, 24 Feb 2006) | 2 lines

remove an unnecessary SV_VM block

------------------------------------------------------------------------
r6020 | havoc | 2006-02-24 05:14:42 +0100 (Fri, 24 Feb 2006) | 2 lines

patch from esteel that fixes the +/-button command descriptions (they all said button3)

------------------------------------------------------------------------
r6019 | havoc | 2006-02-23 17:19:09 +0100 (Thu, 23 Feb 2006) | 2 lines

fix rcon_password validation to refuse whitespace, and refuse empty passwords (as it was meant to do all along, but wasn't working properly)

------------------------------------------------------------------------
r6018 | havoc | 2006-02-23 17:04:24 +0100 (Thu, 23 Feb 2006) | 2 lines

rearrange SV_VM_Begin/End again to fix crashes

------------------------------------------------------------------------
r6017 | havoc | 2006-02-23 15:50:41 +0100 (Thu, 23 Feb 2006) | 4 lines

added qw compatible "rcon" support (allows a client who knows the server's rcon_password to run a command on the server), had to move NetConn_ServerFrame outside of the SV_VM_Begin block in Host_ServerFrame, and add relevant SV_VM_Begin blocks to various parts of host_cmd.c
added qw print command packet to client packet processing (needed for remote rcon when not connected to the server)
added qw "packet" command (sends a text message to the specified address)

------------------------------------------------------------------------
r6016 | havoc | 2006-02-23 12:08:14 +0100 (Thu, 23 Feb 2006) | 2 lines

changed Polygon[DF]_Divide functions to also be able to return an on-plane points count

------------------------------------------------------------------------
r6015 | havoc | 2006-02-23 11:57:31 +0100 (Thu, 23 Feb 2006) | 5 lines

merged NetConn_SendReliableMessage into NetConn_SendUnreliableMessage, and also merged away the other ReliableMessage functions (ReSend and Next)
rearranged client and server message sending calls to attempt to send unreliable messages, even if empty (necessary to trigger sending of reliable messages)
eliminated last remnants of NetConn_SendToAll stuff
changed some cls.demoplayback checks to !cls.netcon checks

------------------------------------------------------------------------
r6014 | havoc | 2006-02-23 11:47:09 +0100 (Thu, 23 Feb 2006) | 2 lines

make cl_movement handling a little more robust (hopefully)

------------------------------------------------------------------------
r6013 | havoc | 2006-02-23 11:34:56 +0100 (Thu, 23 Feb 2006) | 2 lines

changed r_speeds to only display timings with r_speeds 2, r_speeds 1 now only displays statistics (no glFinish needed so this is much faster)

------------------------------------------------------------------------
r6012 | havoc | 2006-02-23 06:47:53 +0100 (Thu, 23 Feb 2006) | 2 lines

another int cast for that patch

------------------------------------------------------------------------
r6011 | havoc | 2006-02-23 06:43:57 +0100 (Thu, 23 Feb 2006) | 2 lines

added int cast on write call in new terminal printing code, and added an include of io.h on windows

------------------------------------------------------------------------
r6010 | havoc | 2006-02-23 06:29:16 +0100 (Thu, 23 Feb 2006) | 2 lines

removed runmove array in favor of using a private entity flag to prevent movement on the first physics frame an entity exists in, this makes projectiles fired by cl_movement 1 clients behave properly

------------------------------------------------------------------------
r6009 | havoc | 2006-02-23 06:26:53 +0100 (Thu, 23 Feb 2006) | 2 lines

add the priv.server->move field needed by a previous commit

------------------------------------------------------------------------
r6006 | havoc | 2006-02-23 05:14:59 +0100 (Thu, 23 Feb 2006) | 2 lines

change unknown opcode error to a Con_DPrintf, this makes fteqcc fastarrays progs load

------------------------------------------------------------------------
r6005 | havoc | 2006-02-23 02:48:09 +0100 (Thu, 23 Feb 2006) | 2 lines

